//--------------------------------------------------------------------------
// Plantarium -- Copyright (c) 1998 
//--------------------------------------------------------------------------
#include <owl\opensave.h>
#include <stdlib.h> // conversion int -> string
#include <stdio.h>
#include <string.h>

#include "astedial.h"

const char IniFilename[] = "Spica.ini";
// pour entrer la date

// pour les combobox
static asteroidesXfer asteData;

TDialogAsteroides::TDialogAsteroides( TWindow* parent,systeme* syst):
	 TDialog( parent, DIALOG_ASTEROIDES) {

	 system=syst;
	 box_list_objets=new TListBox(this,IDC_LISTASTE);
    box_selectionnes=new TListBox(this,IDC_LISTVISIBLE);

    MagReel=new TStatic(this,IDC_EDIT_MAG);
    MagMax=new TStatic(this,IDC_EDIT_MAG_MAX);

    Mag=system->MagAste;
    tabaste[0]=-1;

    // sauvegarde pour le cancel
    int i=0;
    while(system->tabselected[i]!=-1 && i<2999){
    	sauveselected[i]=system->tabselected[i];
      i++;
    }
    sauveselected[i]=-1;

	 SetTransferBuffer(&asteData); // l ou stocke les donnees des combobox

  }
TDialogAsteroides::~TDialogAsteroides(){

	}

void TDialogAsteroides::SetupWindow() {
	 TDialog::SetupWindow();
    char txt[15];
    sprintf(txt,"%2.1lf",Mag);
    MagMax->SetText(txt);
    MagReel->SetText("");
    // magnitude bright star
  	// -2 -> 6 => *10 => -20 -> 60 ; 80=60-(-20)
  	::SetScrollRange(GetDlgItem(IDC_SCROLLBAR_MAG_ASTE), SB_CTL, 0, 200, FALSE);
  	::SetScrollPos(GetDlgItem(IDC_SCROLLBAR_MAG_ASTE), SB_CTL, (int)(Mag*10.0), TRUE);

    UpdateListe();
    // ceux deja selectionns
    int i=0;
    while(system->tabselected[i]>=0&&i<2999) {
    	box_selectionnes->AddString(system->tabcomet[system->tabselected[i++]]->nom);
    }

}
void TDialogAsteroides::UpdateListe(){
	box_list_objets->ClearList();
  	int i,k=0;
    // list des cometes possibles
   for(i=0;i<system->nbrcomet;i++){
    	 if(system->tabcomet[i]->Magn[0]<Mag) {
       	box_list_objets->AddString(system->tabcomet[i]->nom);
         tabaste[k++]=i;
       }
   }
   tabaste[k]=-1;
}
void TDialogAsteroides::EvPaint() {
	 TDialog::EvPaint();
	 }

int TDialogAsteroides::Execute() {
	 TDialog::Execute();
	 return result;

}

void TDialogAsteroides::Ignore() {}
void TDialogAsteroides::Fin2(){

    box_list_objets->ClearList();
    box_selectionnes->ClearList();
    int i=0;

    while(sauveselected[i]!=-1 && i<2999){
    	system->tabselected[i]=sauveselected[i];
      i++;
    }
    system->tabselected[i]=-1;

	result=1;
	CloseWindow(result);
}
void TDialogAsteroides::Fin(){
	 box_list_objets->ClearList();
    box_selectionnes->ClearList();

    char string[40];
	sprintf(string,"%d",(int)(floor(100.*Mag)));
	WritePrivateProfileString( "Asteroides", "Magnitude Maximale", string, IniFilename );
   system->MagAste=Mag;
 	result=0;
	CloseWindow(result);
}
void TDialogAsteroides::Magnitude1(){
   int i;
   int tab[3000];
   i=box_list_objets->GetSelIndexes(tab,2999);
   if(i==1) {
   	char txt[15];
    	sprintf(txt,"Magnitude de %s:%2.1lf",system->tabcomet[tabaste[tab[0]]]->nom,system->tabcomet[tabaste[tab[0]]]->Magn[0]);
    	MagReel->SetText(txt);
   }
   else MagReel->SetText("");
}
void TDialogAsteroides::Magnitude2(){
   char txt[15];
   MagMax->GetText(txt,7);
   sscanf(txt,"%lf",&Mag);
  	::SetScrollPos(GetDlgItem(IDC_SCROLLBAR_MAG_ASTE), SB_CTL, (int)(Mag*10.0), TRUE);
   UpdateListe();
}
void TDialogAsteroides::EvHScroll(UINT scrollCode, UINT thumbPos, HWND WndCtrl)
{
  UINT Pos = ::GetScrollPos(WndCtrl, SB_CTL);
  const int PageStep = 10;

  switch (scrollCode) {
  case SB_LINEUP:
    Pos--;
    break;
  case SB_LINEDOWN:
    Pos++;
    break;
  case SB_PAGEUP:
    Pos -= PageStep;
    break;
  case SB_PAGEDOWN:
    Pos += PageStep;
    break;
  case SB_THUMBPOSITION:
    break;
  case SB_THUMBTRACK:
    Pos = thumbPos;
    break;
  }
  ::SetScrollPos(WndCtrl, SB_CTL, Pos, TRUE);

  Mag=(double)(Pos)/10.0;
  char ss[10];
  sprintf(ss,"%3.1lf  ",Mag);
  MagMax->SetText(ss);
  UpdateListe();
}


void TDialogAsteroides::Ajout(){
	int i,k;
   int tab[3000];
   i=box_list_objets->GetSelIndexes(tab,2998);
   if(i>=0){
   	int j=0;
   	int erreur=0;
      for(k=0;k<i;k++){
   		while(system->tabselected[j]>=0) {

   			if(system->tabselected[j++]==tabaste[tab[k]]) erreur=1;
   		}  //while
   		if (erreur==0){// pas deja present dans la liste
   			system->tabselected[j]=tabaste[tab[k]];
      		box_selectionnes->AddString(system->tabcomet[system->tabselected[j]]->nom);
      		system->tabselected[j+1]=-1;
   		} // if erreur
      }//for k
   } //if i
}
void TDialogAsteroides::AjoutAll(){
   int i=0;
   box_selectionnes->ClearList();
   while(tabaste[i]>=0&&i<2999){
   	system->tabselected[i]=tabaste[i];
      box_selectionnes->AddString(system->tabcomet[system->tabselected[i]]->nom);
      i++;
   }
   system->tabselected[i]=-1;
   system->tabselected[2999]=-1;
}
void TDialogAsteroides::Supp(){
   int i,k,kk,l,erreur;
   int tab[3000];
   int tab2[3000];
   for(i=0;i<3000;i++){
   	tab2[i]=system->tabselected[i];
    	if(system->tabselected[i]<0) i=3100;
   }
   i=box_selectionnes->GetSelIndexes(tab,3000);
   box_selectionnes->ClearList();
   box_selectionnes->SetSelIndex(-1);
   l=0;
   for(k=0;k<3000;k++){
   	 erreur=0;
      for(kk=0;kk<i;kk++){
        if(k==tab[kk]) erreur=1;
      }
      if(erreur==0){
      	system->tabselected[l]=tab2[k];
      	if(tab2[k]!=-1) box_selectionnes->AddString(system->tabcomet[system->tabselected[l]]->nom);
         l++;
      }
  		if(tab2[k]==-1) k=3000;

   }
}
void TDialogAsteroides::SuppAll(){
   system->tabselected[0]=-1;
   box_selectionnes->ClearList();
}


DEFINE_RESPONSE_TABLE1( TDialogAsteroides, TDialog )
  EV_WM_PAINT,
  EV_EN_CHANGE(IDC_EDIT_MAG_MAX,Magnitude2),
  EV_LBN_SELCHANGE(IDC_LISTASTE,Magnitude1),
  EV_WM_HSCROLL,
  EV_COMMAND( IDC_AJOUTER, Ajout ),
  EV_COMMAND( IDC_AJOUTER_TOUT, AjoutAll ),
  EV_COMMAND( IDC_SUPP, Supp ),
  EV_COMMAND( IDC_SUP_TOUT, SuppAll ),

  EV_COMMAND( IDOK, Fin ),
  EV_COMMAND( ID_CANCEL, Fin2 ),


END_RESPONSE_TABLE;

void AsteroideFileConversion(){
   char src[50];
   int result=-1;
  static TOpenSaveDialog::TData data (
	 0,
	 "Format XEphem (*.edb)|*.edb|",
	 0,
	 "",
	 "edb"
  );
  if (TFileOpenDialog(0, data,0,"Convertir un fichier d'astroides").Execute() == IDOK) {
	 char fileTitle[30];
	 TOpenSaveDialog::GetFileTitle(data.FileName, fileTitle, 30);
	 strcpy(src,fileTitle);
    if(src[strlen(src)-3]=='e' && src[strlen(src)-2]=='d' && src[strlen(src)-1]=='b')
	 	result=convert(src);
	 if(result==0) MessageBox(0,"Fichier converti avec succ !", "Information", MB_OK	);
    else MessageBox(0,"La conversion a choue", "Information", MB_OK	);

  }
   // edb -> syt


}



