//--------------------------------------------------------------------------
// Le plantarium -- Copyright (c) 1998
//--------------------------------------------------------------------------
#ifndef DIALOGS2_H
#define DIALOGS2_H


#include <owl\dc.h>
#include <stdio.h>
#include <stdlib.h>
#include <dir.h>


#include <owl/dialog.h>
#include <owl/static.h>
#include <owl/button.h>
#include <owl/listbox.h>
#include <owl/combobox.h>
#include <owl/checkbox.h>
#include <string.h>



#include "constant.h"
#include "date.h"

#include "planetar.rh"

//////////////
// localisation
struct dialogs4Xfer {
//{{mainXFER_DATA}}
	 TComboBoxData  box_ville;
    TComboBoxData  box_ville2;
    TComboBoxData  box_ete;
    TComboBoxData  box_ordi;
    TComboBoxData  box_obs;
//{{mainXFER_DATA_END}}
};


class TDialogLocali: public TDialog {
private:


	TComboBox * box_ville;
   TComboBox * box_ville2;
   TComboBox * box_ete;
   TComboBox * box_ordi;
   TComboBox * box_obs;

	// Tstatic *
	TStatic * edit_longi;
	TStatic * edit_latit;


	int result;  //=0 si cancel, 1 sinon
	int lasttype;
	int *numcity;
   int *numcity1;
   int num;
	double *longi,*latit;
	double *longi2,*latit2;
	char *city;
   char *city1;
   int oldnum,moddi;
   int *ordi,*ete,*obs;
   date2 * d;

   int lordi;

public:
 TDialogLocali( TWindow* parent,date2* datum,int* numcit,int* numcit1, double* lon, double* lat,char*city2,char*city3,int * ete2,int *ordi2,int *obs2);
  ~TDialogLocali();
  void SetupWindow() ;
  void EvPaint() ;

  int  Execute() ;
  void Ignore();
  void Fin();
  void Fin2();

  void DelEte();
  void DelOrdi();
  void DelObs();
  void DelVille();
  void DelVille2();

  void IniVille();
  void IniVille2();
  void IniEte();
  void IniOrdi();
  void IniObs();

  void ModifVille();
  void ModifVille2();
  void ModifEte();
  void ModifEdit();

  // pour les fonctions declenches par les boutons
  DECLARE_RESPONSE_TABLE( TDialogLocali );
};




//--------------------------------
///  carte
// pour les combobox
struct dialogs2Xfer {
//{{mainXFER_DATA}}
	 TComboBoxData  box_annee;
	 TComboBoxData  box_mois;
	 TComboBoxData  box_jour;
	 TComboBoxData  box_heure;

	 TComboBoxData  box_type;
	 TComboBoxData  box_dec1;
	 TComboBoxData  box_dec2;
	 TComboBoxData  box_asc1;
	 TComboBoxData  box_asc2;

	 TComboBoxData  box_ville;

//{{mainXFER_DATA_END}}
};

class TDialogCarte: public TDialog {
private:

	TComboBox * box_annee;
	TComboBox * box_mois;
	TComboBox * box_jour;
	TComboBox * box_heure;

	TComboBox * box_type;
	TComboBox * box_dec1;
	TComboBox * box_dec2;
	TComboBox * box_asc1;
	TComboBox * box_asc2;
	TComboBox * box_ville;

	// Tstatic *
	TStatic * edit_f1;
	TStatic * edit_f2;
	TStatic * edit_f3;
	TStatic * edit_f4;

	TStatic * edit_af1;
	TStatic * edit_af2;
	TStatic * edit_af3;
	TStatic * edit_af4;

	TStatic * edit_longi;
	TStatic * edit_latit;

	TStatic * edit_titre;

	date2 *d;

	int annee,mois,jour,heure; // sauvegarde pour le cas ou cancel
	int *type,*dec1,*dec2,*asc1,*asc2;
	int *azi1,*azi2,*hau1,*hau2;
	int result;  //=0 si cancel, 1 sinon
	int lasttype;
	int *numcity;
   int num;
	double *longi,*latit;
	double *longi2,*latit2;
	char *city;
   int oldnum,moddi;

public:
 TDialogCarte( TWindow* parent,date2* datum,int* typ, int* de1,int* de2,int* as1,int* as2,int* azim1,int* azim2,int* haut1, int* haut2,int* numcit, double* lon, double* lat,char*city2);
  ~TDialogCarte();
  void SetupWindow() ;
  void EvPaint() ;

  int  Execute() ;
  void Ignore();
  void Fin();
  void Fin2();

  void DelAzim();
  void DelMerc();
  void IniAzim();
  void IniMerc();
  void DelVille();
  void IniVille();

  void ModifAnnee();
  void ModifMois();
  void ModifJour();
  void ModifType();
  void ModifVille();
  void ModifEdit();

  // pour les fonctions declenches par les boutons
  DECLARE_RESPONSE_TABLE( TDialogCarte );
};



/// ************************************************
//     Dialog pour le choix des magnitudes a afficher

class TMagnitudesDialog : public TDialog {
  public:
	 TMagnitudesDialog(TWindow* parent,double *magn)
		  : TWindow(parent), TDialog(parent, DIALOG_MAGNITUDES) {
				Magnitudes=magn;
				Magni=*Magnitudes;

		  }

    void CClose();
	 void  SetupWindow();

	 void  EvHScroll(UINT, UINT, HWND);

	 double *Magnitudes,Magni;

  DECLARE_RESPONSE_TABLE(TMagnitudesDialog);
};

/// ************************************************
//     Dialog pour le choix des magnitudes avec autre catalogue a afficher

class TMagnitudesCataDialog : public TDialog {
  public:
	 TMagnitudesCataDialog(TWindow* parent,double *magnB,double *magnmaxC,double *magnminC)
				: TWindow(parent), TDialog(parent, MAGNITUDE_GSC) {
				Magnitudes=magnB; Magni=*Magnitudes;
				MagnitudesMax=magnmaxC; MagniMax=*MagnitudesMax;
				MagnitudesMin=magnminC; MagniMin=*MagnitudesMin;
		  }

    void CClose();
	 void  SetupWindow();

	 void  EvHScroll(UINT, UINT, HWND);

	 double *Magnitudes,Magni;
	 double *MagnitudesMax,MagniMax;
	 double *MagnitudesMin,MagniMin;

  DECLARE_RESPONSE_TABLE(TMagnitudesCataDialog);
};

/// ************************************************
//     Dialog pour le choix des magnitudes avec autre catalogue a afficher

struct dialogs5Xfer {
//{{mainXFER_DATA}}
	 TComboBoxData  box_LecteurCD;

//{{mainXFER_DATA_END}}
};
class TCatalogueDialog : public TDialog {
  public:
	 TCatalogueDialog(TWindow* parent,int *dis,int *cata);/*
		  : TWindow(parent), TDialog(parent, CATALOGUE) {
				disk=dis;
				catalog=cata;
		  }
		  */
	 ~TCatalogueDialog();

	 void  SetupWindow();
	 void Fin();

	 void ModifDisk();
	 void ChoixGsc();

	 TComboBox * box_LecteurCD;
	 TCheckBox * GscCata;

    int tabdisk[26],kk;
	 int *catalog,*disk;

  DECLARE_RESPONSE_TABLE(TCatalogueDialog);
};

#endif // DIALOGS2_H
