
#include "systeme.h"
#include "ciel.rh"
#include "date.h"

#include "conjonct.h"
#include "outil.h"

#include <owl/dc.h>
#include <string.h>
#include <stdlib.h> // conversion int -> string



void graphe_conjonction(date2*d,date2*datum,systeme *sys,TMemoryDC &memdc,bool satel,HBRUSH pinceau[16],HPEN crayon[16],bool PPrint,bool NB){
//sys: pointeur sur le systeme
	if (PPrint==false){memdc.SelectObject(pinceau[0]);memdc.SelectObject(crayon[0]);}
	else {memdc.SelectObject(pinceau[1]);memdc.SelectObject(crayon[1]);}
	if (PPrint==false) memdc.SetTextColor(RGB(120,120,200));
   else memdc.SetTextColor(RGB(0,0,0));
	memdc.SetBkColor(RGB(0,0,70));

double asct,ascs=0; //ascension droite (temporaire,soleil)
int x=0,t,i,j,k ; // x=abscisse des points, t,i,j,k pour les boucles for
int centre=sys->ScrL()/2,ecart=sys->ScrL()*2/5;// pour l'affichage:coordonnee du centre + 1/2largeur
int nbr;   // nombre d'objets celestes
nbr=sys->getnbrplanete();
for(i=0;i<sys->getnbrplanete();i++) nbr+=sys->getplanete(i)->getnbrsatellite();
int *antex;
antex=new int[nbr];
for(i=0;i<nbr;i++) antex[i]=centre;

double pas=24; //pas de calcul en heure
date2*datum2;
datum2=new date2();

// informations sur crayons et pinceaux
int premiercrayon=4;
int Terrenumero=0;
for(i=0;i<sys->getnbrplanete();i++){
  if (strcmp(sys->getplanete(i)->getnom(),"Terre")==0) Terrenumero=i;
}
int derniercrayon=10;

//definition d'un carre sur lequel est affiche les planetes
if (PPrint==false) memdc.SelectObject(crayon[2]);   //rouge
else memdc.SelectObject(crayon[0]);
	if (PPrint==false)memdc.SelectObject(pinceau[3]); //noir
	else memdc.SelectObject(pinceau[1]);                    //blanc
memdc.Rectangle(4,30,sys->ScrL()-4,sys->ScrH()-5);

// dessin du soleil
		if (NB==false) memdc.SelectObject(crayon[6]);   //jaune
		else memdc.SelectObject(crayon[0]);
		memdc.MoveTo(centre,31);
		memdc.LineTo(centre,sys->ScrH()-6);
		memdc.MoveTo(centre+1,31);
		memdc.LineTo(centre+1,sys->ScrH()-6);

// date de debut
datum2->setsieclejulien(d->getsieclejulien());
// calcul du pas en heure
pas=(datum->getsieclejulien()-d->getsieclejulien())*1788.9796;// 876600.0/490;
SetCursor(LoadCursor(NULL, (TResId)IDC_WAIT));


// boucle sur l'ordonnee de l'affichage
for(t=31;t<sys->ScrH()-5;t++){
  // mise a jour de la date
  datum2->ajoutheure(pas);
  datum2->antimiseajour();
  // calcul de la position
  sys->calculposition(datum2,satel);
  // ascension du soleil
  ascs=sys->getsun()->getascensiondroite();
  if (ascs>180) ascs-=360;    //-180<asc<180

  j=0; // numero des satellites

  // boucle sur les planetes
  for(i=0;i<sys->getnbrplanete();i++){
		//calcul abscisse d'affichage
		asct=-sys->getplanete(i)->getascensiondroite()+ascs;
		while (asct<-180) asct+=360;
		while (asct>180) asct-=360;
		x=centre+(asct)*2*ecart/(360);

		// gere le cas de la Terre
		/*
		if (i<Terrenumero) memdc.SelectObject(crayon[premiercrayon+i%(derniercrayon-premiercrayon)]);       // i!=2 car on ne reprsente pas la Terre
		if (i>Terrenumero) memdc.SelectObject(crayon[premiercrayon+(i-1)%(derniercrayon-premiercrayon)]);
		*/
		// couleurs
		if (strcmp(sys->getplanete(i)->getnom(),"Mercure")==0) memdc.SelectObject(crayon[13]);
		if (strcmp(sys->getplanete(i)->getnom(),"Venus")==0) memdc.SelectObject(crayon[1]);
		if (strcmp(sys->getplanete(i)->getnom(),"Mars")==0) memdc.SelectObject(crayon[7]);
		if (strcmp(sys->getplanete(i)->getnom(),"Jupiter")==0) memdc.SelectObject(crayon[2]);
		if (strcmp(sys->getplanete(i)->getnom(),"Saturne")==0) memdc.SelectObject(crayon[8]);
		if (strcmp(sys->getplanete(i)->getnom(),"Neptune")==0) memdc.SelectObject(crayon[10]);
		if (strcmp(sys->getplanete(i)->getnom(),"Uranus")==0) memdc.SelectObject(crayon[9]);
      if (strcmp(sys->getplanete(i)->getnom(),"Pluton")==0) memdc.SelectObject(crayon[11]);
		if (NB==true) memdc.SelectObject(crayon[0]);   //noir

		// gere les retour a la ligne
		if (x<(centre-ecart+30) && antex[i]>(centre+ecart-30)) antex[i]=centre-ecart;
		if (x>(centre+ecart-30) && antex[i]<(centre-ecart+30)) antex[i]=centre+ecart;
		//dessin
		memdc.MoveTo(antex[i],t-1);
		if (i!=Terrenumero) memdc.LineTo(x,t);
		antex[i]=x;

		//pour les satellites
		if (satel==true){
			for(k=0;k<sys->getplanete(i)->getnbrsatellite();k++){
				asct=sys->getplanete(i)->getsatellite(k)->getascensiondroite()-sys->getsun()->getascensiondroite();
				while (asct<-180) asct+=360;
				while (asct>180) asct-=360;
				x=centre+(asct)*2*ecart/(360);

				memdc.SelectObject(crayon[premiercrayon+(sys->getnbrplanete()-1+j)%(derniercrayon-premiercrayon)]);
            if (NB==true) memdc.SelectObject(crayon[0]); 
				// probleme qd vxt->360 ou vxt->0
				x=centre+(asct)*2*ecart/(360);
				if (x<(centre-ecart+40) && antex[sys->getnbrplanete()+j]>(centre+ecart-40)) antex[sys->getnbrplanete()+j]=centre-ecart;
				if (x>(centre+ecart-40) && antex[sys->getnbrplanete()+j]<(centre-ecart+40)) antex[sys->getnbrplanete()+j]=centre+ecart;
				memdc.MoveTo(antex[sys->getnbrplanete()+j],t-1);
				memdc.LineTo(x,t);
				antex[sys->getnbrplanete()+j]=x;
				j++;

			} // for
		}//if satel
	}

}
// redessine la ligne du cadre qui a t modifie
if (PPrint==false) memdc.SelectObject(crayon[2]);   //rouge
else memdc.SelectObject(crayon[0]);
memdc.MoveTo(4,30);
memdc.LineTo(sys->ScrL()-5,30);

j=0; //remise  zro du numro de satellite pour la lgende

delete[] antex;
memdc.SetBkMode(TRANSPARENT);
memdc.SetTextColor(RGB(0,0,0));
// legende
memdc.TextOut(sys->ScrL()+50,5,"LEGENDE",strlen("LEGENDE"));

if (PPrint==false) memdc.SetTextColor(RGB(200,200,200));
else memdc.SetTextColor(RGB(0,0,0));
memdc.TextOut(6,45,"-180",5);
memdc.TextOut(sys->ScrL()-40,45,"+180",5);
memdc.TextOut(6,sys->ScrH()/2,"EST",3);
memdc.TextOut(sys->ScrL()-55,sys->ScrH()/2,"OUEST",5);
if (PPrint==false) memdc.SetTextColor(RGB(0,0,0));
else memdc.SetTextColor(RGB(0,0,0));
// affiche nom des planetes avec ligne de la couleur correspondante devant
int aaa=0;
for(i=0;i<sys->getnbrplanete();i++){
		if (strcmp(sys->getplanete(i)->getnom(),"Mercure")==0) memdc.SelectObject(crayon[13]);

		if (strcmp(sys->getplanete(i)->getnom(),"Venus")==0) {
				if (PPrint==false)memdc.SelectObject(crayon[1]);
				else memdc.SelectObject(crayon[3]);
            }
		if (strcmp(sys->getplanete(i)->getnom(),"Mars")==0) memdc.SelectObject(crayon[7]);
		if (strcmp(sys->getplanete(i)->getnom(),"Jupiter")==0) memdc.SelectObject(crayon[2]);
		if (strcmp(sys->getplanete(i)->getnom(),"Saturne")==0) memdc.SelectObject(crayon[8]);
		if (strcmp(sys->getplanete(i)->getnom(),"Neptune")==0) memdc.SelectObject(crayon[10]);
		if (strcmp(sys->getplanete(i)->getnom(),"Uranus")==0) memdc.SelectObject(crayon[9]);
		if (strcmp(sys->getplanete(i)->getnom(),"Pluton")==0) memdc.SelectObject(crayon[11]);
		if (NB==true) memdc.SelectObject(crayon[0]);
		if (strcmp(sys->getplanete(i)->getnom(),"Terre")==0){aaa=1;}
		else{
		memdc.MoveTo(sys->ScrL()+20,sys->ScrH()/4+(i-aaa)*35);
		memdc.LineTo(sys->ScrL()+40,sys->ScrH()/4+(i-aaa)*35);
		memdc.TextOut(sys->ScrL()+50,sys->ScrH()/4-5+(i-aaa)*35,sys->getplanete(i)->getnom(),strlen(sys->getplanete(i)->getnom()));
      }
		/*
		if (i<Terrenumero) {memdc.SelectObject(crayon[premiercrayon+i%(derniercrayon-premiercrayon)]);       // i!=2 car on ne reprsente pas la Terre
				memdc.MoveTo(520,170+i*35);
				memdc.LineTo(540,170+i*35);
				memdc.TextOut(550,165+i*35,sys->getplanete(i)->getnom(),strlen(sys->getplanete(i)->getnom()));
				}
	if (i>Terrenumero) {memdc.SelectObject(crayon[premiercrayon+(i-1)%(derniercrayon-premiercrayon)]);
				memdc.MoveTo(520,170+(i-1)*35);
				memdc.LineTo(540,170+(i-1)*35);
				memdc.TextOut(550,165+(i-1)*35,sys->getplanete(i)->getnom(),strlen(sys->getplanete(i)->getnom()));
				}
	*/
	if (satel==true){
		for(k=0;k<sys->getplanete(i)->getnbrsatellite();k++){
			memdc.SelectObject(crayon[premiercrayon+(sys->getnbrplanete()-1+j)%(derniercrayon-premiercrayon)]);
			if (NB==true) memdc.SelectObject(crayon[0]);
			memdc.MoveTo(sys->ScrL()+20,sys->ScrH()/4+(sys->getnbrplanete()-1+j)*35);
			memdc.LineTo(sys->ScrL()+40,sys->ScrH()/4+(sys->getnbrplanete()-1+j)*35);
			memdc.TextOut(sys->ScrL()+50,sys->ScrH()/4-5+(sys->getnbrplanete()-1+j)*35,sys->getplanete(i)->getsatellite(k)->getnom(),strlen(sys->getplanete(i)->getsatellite(k)->getnom()));
		}
	}
		if (PPrint==false)memdc.SelectObject(crayon[3]); //noir
	else memdc.SelectObject(crayon[1]);                    //blanc
	memdc.MoveTo(6,31);
	memdc.LineTo(sys->ScrL()-6,31);
	}
memdc.SetBkMode(OPAQUE);
// date de debut, date de fin
if (PPrint==true) memdc.SetBkColor(RGB(255,255,255));
else memdc.SetBkColor(RGB(0,0,0));
d->afficherdate(memdc,6,31,PPrint);
datum->afficherdate(memdc,6,sys->ScrH()-19,PPrint);



datum2->~date2();
SetCursor(LoadCursor(NULL, (TResId)IDC_ARROW));

}

void conjonction_affichercoordonnee(date2*d,date2*datum,int y,TMemoryDC &memdc,systeme *sys){
	memdc.SetBkColor(RGB(200,200,200));
	memdc.SetBkMode(OPAQUE);
   memdc.SetTextColor(RGB(0,0,0));
		char txt[50];
	date2 *dd;
	dd=new date2();
	dd->setsieclejulien(d->getsieclejulien()+((double)(y-30.)*(datum->getsieclejulien()-d->getsieclejulien())/((double)sys->ScrH()-35.)));
	dd->antimiseajour();


	sprintf(txt,"Date pointe : %d/%d/%d   ",dd->getjour(),dd->getmois(),dd->getannee());
	memdc.TextOut(sys->ScrL()+30,30,txt,strlen(txt));
	dd->~date2();
	memdc.SetBkMode(TRANSPARENT);
}
