#include "date.h"
#include <string.h>
#include <stdio.h> //sprintf
// heure e [0..23]
// jour e [1..31]
// mois e [1..12]
date2::date2(void): heure(0), jour(0), mois(0), annee(0),minute(0), sieclejulien(0), sbgmt(0),slgmt(0),saison(0)
  {}

date2::date2(int h, int j, int m, int a,int mi): heure(h), jour(j), mois(m), annee(a),minute(mi)
  { miseajour();
	 minute=0; }

date2::~date2(void) {
  setminute(0);
  setheure(0);
  setjour(1);
  setmois(1);
  setannee(1996);
  setsieclejulien(0.);
}

int date2::getheure(void)
  { return heure;}

int date2::getjour(void)
  { return jour;}

int date2::getmois(void)
  { return mois;}

int date2::getannee(void)
  { return annee;}

int date2::getminute(void)
  { return minute;}

long double date2::getsieclejulien(void)
  { return sieclejulien;}

void date2::setheure(int h)
  { heure=h;}

void date2::setjour(int j)
  { jour=j;}

void date2::setmois(int m)
  { mois=m;}

void date2::setannee(int a)
  { annee=a;}
void date2::setminute(int a)
  { minute=a;}

void date2::setsieclejulien(long double s)
  { sieclejulien=s;}

void date2::miseajour(void) {   /*
  assert(heure>=0);
  assert(heure<25);
  assert(jour>0);
  assert(jour<32);
  assert(mois>0);
  assert(mois<13);
  assert(annee>1583);      */

  long double y,m,a,b,jj;

  if(mois>2) {y=annee; m=mois;}
  else {y=annee-1; m=mois+12;}

  if (annee<=1582 && mois<=10 && jour<15){  // on est pas dans le calendrier gregorien
		b=0;
  }
  else {
		a=floor(y/100.);
		b=2.-a+floor(a/4.);
  }

  jj=b+floor(365.25*y)+floor(30.6001*(m+1.))+jour+((double)heure+((double)minute)/60.0)/24.0-694025.5;

  sieclejulien=(jj)/36525.0;
}

void date2::antimiseajour(void){
	long double jj,Z,F,alpha,A,B,C,D,E,j;

	jj=sieclejulien*36525.0+2415020.0;
	Z=floor(jj+0.5);
	F=jj+0.5-Z;

	if(Z<2299161.) {A=Z;}
	else {
		alpha=floor((Z-1867216.25)/36524.25);
		A=Z+1+alpha-floor(alpha/4);
		}
	B=A+1524;
	C=floor((B-122.1)/365.25);
	D=floor(365.25*C);
	E=floor((B-D)/30.6001);

	j=(B-D-floor(30.6001*E)+F);
	jour=floor(j);
	heure=floor((j-(double)jour)*24.); //  floor sert ici uniquement  arrondir  l'heure la plus basse
	minute=floor(((double)(j-(double)jour)*24.-(double)heure)*60.);
	if(E<=13) {mois=E-1;}
	else {mois=E-13;}
	if(mois>=3) {annee=C-4716;}
	else {annee=C-4715;}
}

void date2::ajoutheure(long h=1){
	sieclejulien+=(double)h/876600.0;
 //	miseajour();
}
void date2::ajoutminute(int h=5){
	sieclejulien+=((double)h/876600.0)/60.0;
	//antimiseajour();
}

void date2::ajouterheuredecimale(double h)
{
 sieclejulien+=h/876600.0;
}


void date2::afficherdate(TMemoryDC&memdc, int x,int y,bool PPrint){
char datte[16];
char temp[16]="Date:";
int d;
strcpy(datte,temp);
d=getjour();
if (d<10)strcat(datte,"0");
strcat(datte,itoa(d,temp,10));
strcat(datte,"/");
d=getmois();
if (d<10)strcat(datte,"0");
strcat(datte,itoa(d,temp,10));
strcat(datte,"/");
strcat(datte,itoa(getannee(),temp,10));
//SetBkMode(memdc,TRANSPARENT);
if (PPrint==false){
	//SetBkColor(memdc,RGB(0,0,70));
	SetTextColor(memdc,RGB(200,200,200));
}
else {
	//SetBkColor(memdc,RGB(255,255,255));
	SetTextColor(memdc,RGB(0,0,0));
}
TextOut(memdc, x, y, datte,strlen(datte)/*15*/);
//SetBkMode(memdc,OPAQUE);
}

void date2::afficherj(TMemoryDC&memdc, int x,int y,bool PPrint){
char temp[10]="";
SetBkMode(memdc,TRANSPARENT);
if (PPrint==false){
	SetBkColor(memdc,RGB(0,0,70));
	SetTextColor(memdc,RGB(200,200,200));
}
else {
	SetBkColor(memdc,RGB(255,255,255));
	SetTextColor(memdc,RGB(0,0,0));
}
  TextOut(memdc, x, y, itoa(getsieclejulien()*10000,temp,10),10);
  SetBkMode(memdc,OPAQUE);
}


void date2::afficherdateheure(TMemoryDC&memdc, int x,int y,bool PPrint,bool opaq){
char datte[25]; // pour les minutes :25
char temp[20]="Date:";
int d;
strcpy(datte,temp);

d=getjour();
if (d<10)strcat(datte,"0");
strcat(datte,itoa(d,temp,10));
strcat(datte,"/");

d=getmois();
if (d<10)strcat(datte,"0");
strcat(datte,itoa(d,temp,10));
strcat(datte,"/");

strcat(datte,itoa(getannee(),temp,10));
strcat(datte,"_");

d=getheure();
if (d<10)strcat(datte,"0");
strcat(datte,itoa(d,temp,10));
strcat(datte,"h");
 //minutes
strcat(datte,"_");

d=getminute();
if (d<10)strcat(datte,"0");
strcat(datte,itoa(d,temp,10));
strcat(datte,"mn");


SetBkMode(memdc,TRANSPARENT);
if (opaq==true) SetBkMode(memdc,OPAQUE);
if (PPrint==false){
	if (opaq==true) SetBkColor(memdc,RGB(200,200,200));
	SetTextColor(memdc,RGB(0,0,0));
}
else {
	if (opaq==true)SetBkColor(memdc,RGB(255,255,255));
	SetTextColor(memdc,RGB(0,0,0));
}
TextOut(memdc, x, y, datte,strlen(datte));
SetBkMode(memdc,OPAQUE);

}

void date2::date3(char* datte){
	 sprintf(datte,"%d/%d/%d",jour,mois,annee);
}

void date2::date4(char * datte){
	 sprintf(datte,"%dh%d %d/%d/%d",heure,minute,jour,mois,annee);
}

//gestion decalages horaires
double date2::setshift(char nom[30]) //donne un pays et une saison et retourne le dec horaire
{
  FILE* fptr1;//*fptr2;
  fptr1=fopen("pays.syt","rt");
  //fptr2=fopen("test2.syt","wt"); //pr tester la lecture donnes

  char name[30];

  float he,hi;

  fscanf(fptr1,"%s %f %f\n",name,&he,&hi);

  while (strcmp(name,"#")!=0)
  {
	 //fprintf(fptr2,"%s %f %f\n",name,he,hi); //pr tester la lecture donnes
	 if  (strcmp(name,nom)==0)
		{
			if (saison==0) return ((double)he);
			if (saison==1) return ((double)hi);
			else return ((double)-1000);
		}
	 fscanf(fptr1,"%s %f %f\n",name,&he,&hi);


  }
return ((double)-1000);
}


void date2::setsaison()//heure d'ete0 ou d'hiver1?
{
 //aie! aie! c'est tres pipo tout ca!

 //ete
 if(getmois()>=4 && getmois()<10) saison= 1;
 else saison= 0;

}



