//--------------------------------------------------------------------------
// Plantarium -- Copyright (c) 1998 
//--------------------------------------------------------------------------
#include <owl\owlpch.h>
#include <stdlib.h> // conversion int -> string

#pragma hdrstop

#include "dialogs.h"
#include <owl/dc.h>

// pour entrer la date

// pour les combobox
static dialogsXfer dialogsData;


TDialogDate::TDialogDate( TWindow* parent,date2* datum ):
	 TDialog( parent, DATE_DIALOG) {

	 box_annee=new TComboBox(this,IDC_COMBOBOX_ANNEE);
	 box_mois=new TComboBox(this,IDC_COMBOBOX_MOIS);
	 box_jour=new TComboBox(this,IDC_COMBOBOX_JOUR);
	 box_heure=new TComboBox(this,IDC_COMBOBOX_HEURE);

	 SetTransferBuffer(&dialogsData); // l ou stocke les donnees des combobo
    d=datum;
  }
TDialogDate::~TDialogDate(){
	box_annee->~TComboBox();
	box_mois->~TComboBox();
	box_jour->~TComboBox();
	box_heure->~TComboBox();
	}
/// -----------------------------------------------------------
/// -----------------------------------------------------------
void TDialogDate::SetupWindow() {
	 TDialog::SetupWindow();
	 // sauvegarde pour le cas ou cancel
	 annee=d->getannee();
	 mois=d->getmois();
	 jour=d->getjour();
	 heure=d->getheure();
	 //
	 int i=1;
	 char string[5];
	 // entree des annee;
	 for(i=anneedebut;i<anneefin;i++){
		box_annee->AddString(itoa(i,string,10));
	 }
	 box_annee->SetText(itoa(d->getannee(),string,10));

	 // entree des mois
	 box_mois->AddString("Janvier");
	 box_mois->AddString("Fvrier");
	 box_mois->AddString("Mars");
	 box_mois->AddString("Avril");
	 box_mois->AddString("Mai");
	 box_mois->AddString("Juin");
	 box_mois->AddString("Juillet");
	 box_mois->AddString("Aout");
	 box_mois->AddString("Septembre");
	 box_mois->AddString("Octobre");
	 box_mois->AddString("Novembre");
	 box_mois->AddString("Dcembre");

	 box_mois->SetSelIndex(d->getmois()-1);

	 // entree des jours

	 for(i=1;i<=31;i++){
	 box_jour->AddString(itoa(i,string,10));
	 }
    ModifMois();// pour supprimer le 31 ...
	 box_jour->SetSelIndex(d->getjour()-1);

	  // entree des heures

	 for(i=0;i<=23;i++){
	 box_heure->AddString(itoa(i,string,10));
	 }
	 box_heure->SetSelIndex(d->getheure());

  }
/// -----------------------------------------------------------
void TDialogDate::EvPaint() {
	 TDialog::EvPaint();
	 }

int TDialogDate::Execute() {
	 TDialog::Execute();

		 return result;

  }
void TDialogDate::Ignore() {}
void TDialogDate::Fin2(){ // cancel
	d->setannee(annee);
	d->setmois(mois);
	d->setjour(jour);
	d->setheure(heure);
	d->miseajour();
	result=1;
	int i;
	for(i=0;i<anneefin-anneedebut;i++) box_annee->DeleteString(0);
	for(i=0;i<12;i++) box_mois->DeleteString(0);
	for(i=0;i<31;i++) box_jour->DeleteString(0);
	for(i=0;i<24;i++) box_heure->DeleteString(0);
	CloseWindow(result);
}
void TDialogDate::Fin(){  // ok
result=0;
       d->setannee(box_annee->GetSelIndex()+anneedebut);
	 d->setmois(box_mois->GetSelIndex()+1);
	 d->setjour(box_jour->GetSelIndex()+1);
	 d->setheure(box_heure->GetSelIndex());
	 d->miseajour();

	  int i;
	for(i=0;i<anneefin-anneedebut;i++) box_annee->DeleteString(0);
	for(i=0;i<12;i++) box_mois->DeleteString(0);
	for(i=0;i<31;i++) box_jour->DeleteString(0);
	for(i=0;i<24;i++) box_heure->DeleteString(0);

		CloseWindow(result);
  }
/// -----------------------------------------------------------

/// -----------------------------------------------------------
void TDialogDate::ModifAnnee(){

	int year,mois,day;

	 year=box_annee->GetSelIndex()+anneedebut;
	 day=box_jour->GetSelIndex()+1;
	 mois=box_mois->GetSelIndex();
	  //regarde si annee bixetile ou non et si on est au mois de fevrier
	 if ((year)%4!=0){ //annee non bixetile
			if (mois==1 && box_jour->FindString("29", 0)>=0 ){
					box_jour->DeleteString(28);
					if (day==29) box_jour->SetText("28");
			}
	 }
	 else {
		 if (mois==1 && box_jour->FindString("29", 1)<0 ){
					box_jour->AddString("29");
			}

	 }

}
/// -----------------------------------------------------------
void TDialogDate::ModifMois(){

	 int year,mois,day;

	 year=box_annee->GetSelIndex()+anneedebut;
	 day=box_jour->GetSelIndex()+1;
	 mois=box_mois->GetSelIndex();

	 if ( box_jour->FindString("29", 0)<0) box_jour->AddString("29");
	 if ( box_jour->FindString("30", 0)<0) box_jour->AddString("30");
	 // il y a au moins trente jours pour chaque mois
	 if (mois==0 || mois==2 || mois==4 || mois==6 || mois==7 || mois==9 || mois==11){
			// mois a 31 jour mais il manque le 31e jour
			if(box_jour->FindString("31", 0)<0) box_jour->AddString("31");
	 }
	 else{// autres mois sauf fevrier et il y a le 31e jour en trop
			if (mois!=1 && box_jour->FindString("31", 0)>=0 ){
					box_jour->DeleteString(30);
					if (day==31) box_jour->SetText("30");
			}
			else{   // mois de fevrier
				if (mois==1){
					  if ((year)%4!=0){ // annee non bissextile
							if (box_jour->FindString("31", 0)>=0) box_jour->DeleteString(30);
							if (box_jour->FindString("30", 0)>=0) box_jour->DeleteString(29);
							if (box_jour->FindString("29", 0)>=0) box_jour->DeleteString(28);
							if (day>28) box_jour->SetText("28");
					  }
					  else {  // annee bissextile
                   	if (box_jour->FindString("31", 0)>=0) box_jour->DeleteString(30);
							if (box_jour->FindString("30", 0)>=0) box_jour->DeleteString(29);
							if (day>28) box_jour->SetText("29");
					  }
				}
			}
	 }

}
/// -----------------------------------------------------------
void TDialogDate::ModifJour(){
	
}

/// -----------------------------------------------------------

/// -----------------------------------------------------------
/// -----------------------------------------------------------

DEFINE_RESPONSE_TABLE1( TDialogDate, TDialog )
  EV_WM_PAINT,

  EV_COMMAND( IDC_OK, Fin ),
  EV_COMMAND( IDC_CANCEL, Fin2 ),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_ANNEE,ModifAnnee),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_MOIS,ModifMois),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_JOUR,ModifJour),

END_RESPONSE_TABLE;


//******************************************************************************
//******************************************************************************
// boite de dialog about

TDialogAbout::TDialogAbout( TWindow* parent ) :TDialog( parent, HELP_ABOUT){};
TDialogAbout::~TDialogAbout(){}
void TDialogAbout::SetupWindow(){
		TDialog::SetupWindow();

     }
void TDialogAbout::EvPaint() {
// dessin du fond en mmoire

	 HDC hdc, hdcMemory;
	 hdc = GetDC(HWindow);
	 hdcMemory = CreateCompatibleDC(hdc);
	 
	 TBitmap fond( _hInstance, BITMAP_ABOUT3 );
	 SelectObject( hdcMemory,fond );
  // copie de la mmoire  l'cran
	 BitBlt( hdc,0, 0, 550, 350, hdcMemory, 0, 0, SRCCOPY );

	 fond.~TBitmap();

	 DeleteDC(hdcMemory);
	 ReleaseDC(HWindow, hdc);

	  }

void TDialogAbout::Fin(){
CloseWindow();
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// Quand clique sur la souris pour quitter
//

void TDialogAbout::EvLButtonDown(uint, TPoint& point){
	if (point.x>148 &&point.x<352 &&point.y>287 && point.y<330) Fin();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// pour les fonctions declenches par les boutons
DEFINE_RESPONSE_TABLE1( TDialogAbout, TDialog )

  EV_WM_PAINT,

	// qd clik sur la souris pour quitter
	 EV_WM_LBUTTONDOWN,

END_RESPONSE_TABLE;
