//--------------------------------------------------------------------------
// Plantarium -- Copyright (c) 1998 
//--------------------------------------------------------------------------
#include <owl\opensave.h>
#include <stdlib.h> // conversion int -> string
#include <stdio.h>
#include <string.h>
#pragma hdrstop

#include "ephemeri.h"


// pour entrer la date

// pour les combobox
static ephemerideXfer epheData;

TDialogEphemeride::TDialogEphemeride( TWindow* parent,systeme* syst,date2*datum):
	 TDialog( parent, DIALOG_EPHE) {

	 system=syst;
	 box_annee=new TComboBox(this,IDC_COMBOBOX_ANNEE);
	 box_mois=new TComboBox(this,IDC_COMBOBOX_MOIS);
	 box_jour=new TComboBox(this,IDC_COMBOBOX_JOUR);
	 box_heure=new TComboBox(this,IDC_COMBOBOX_HEURE);
	 box_objet=new TComboBox(this,IDC_COMBOBOX_OBJET);
	 box_pas=new TComboBox(this,IDC_COMBOBOX_PAS);
	 box_nombre=new TComboBox(this,IDC_COMBOBOX_NOMBRE);

	 SetTransferBuffer(&epheData); // l ou stocke les donnees des combobox

	 edit_fin=new TStatic(this,IDC_EDIT_FIN);

    Pipo_txt=new TRichEdit(this,IDC_EDIT_PIPO2);

	 d=datum;

  }
TDialogEphemeride::~TDialogEphemeride(){
	box_annee->~TComboBox();
	box_mois->~TComboBox();
	box_jour->~TComboBox();
	box_heure->~TComboBox();
	box_pas->~TComboBox();
	box_nombre->~TComboBox();
   box_objet->~TComboBox();

   Pipo_txt->~TRichEdit();

   edit_fin->~TStatic();
	}

void TDialogEphemeride::SetupWindow() {
	 TDialog::SetupWindow();
	 int i=1;
	 char string[10];

    Pipo_txt->SetText("Choisissez l'objet, la date\nPuis cliquez sur le bouton \"Ephmrides\"");


// entree des annee;
	 for(i=anneedebut;i<anneefin;i++){
		box_annee->AddString(itoa(i,string,10));
	 }
	 box_annee->SetText(itoa(d->getannee(),string,10));

// entree des mois
	 box_mois->AddString("Janvier");
	 box_mois->AddString("Fvrier");
	 box_mois->AddString("Mars");
	 box_mois->AddString("Avril");
	 box_mois->AddString("Mai");
	 box_mois->AddString("Juin");
	 box_mois->AddString("Juillet");
	 box_mois->AddString("Aout");
	 box_mois->AddString("Septembre");
	 box_mois->AddString("Octobre");
	 box_mois->AddString("Novembre");
	 box_mois->AddString("Dcembre");

	 box_mois->SetSelIndex(d->getmois()-1);

// entree des jours

	 for(i=1;i<=31;i++){
	 box_jour->AddString(itoa(i,string,10));
	 }
	 Verif();// pour supprimer le 31 ...
	 box_jour->SetSelIndex(d->getjour()-1);

 // entree des heures
    	 for(i=0;i<=23;i++){
	 box_heure->AddString(itoa(i,string,10));
	 }
	 box_heure->SetSelIndex(d->getheure());

// entree des objets
    // ajout de l'etoile centrale
		box_objet->AddString(system->getsun()->getnom());
	 // ajout des planetes
	 for(i=0;i<system->getnbrplanete();i++){
		 if(i!=2) box_objet->AddString(system->getplanete(i)->getnom());
	 }

	 //ajout des satellites
	 box_objet->AddString("Lune");

	 // selection par defaut : 1e planete
	 box_objet->SetText(system->getplanete(0)->getnom());
// entree des pas
	 box_pas->AddString("1 heure");
	 sprintf(string,"1 jour");
	  box_pas->AddString(string);
	 for(i=2;i<=365;i++){
		 sprintf(string,"%d jours",i);
		 box_pas->AddString(string);
	 }
	 box_pas->SetSelIndex(0);
// entree des nombres
	 for(i=1;i<=20;i++){
		 sprintf(string,"%d",i*5);
		 box_nombre->AddString(string);
	 }
	 box_nombre->SetSelIndex(0);

    ModifFin();

}
void TDialogEphemeride::EvPaint() {
	 TDialog::EvPaint();
	 }

int TDialogEphemeride::Execute() {
	 TDialog::Execute();
	 return result;

}

void TDialogEphemeride::Ignore() {}
void TDialogEphemeride::Fin2(){
	 int i;
for(i=0;i<anneefin-anneedebut;i++) box_annee->DeleteString(0);
for(i=0;i<12;i++) box_mois->DeleteString(0);
for(i=0;i<31;i++) box_jour->DeleteString(0);
for(i=0;i<24;i++) box_heure->DeleteString(0);
box_objet->DeleteString(0);//supression du soleil
for(i=0;i<system->getnbrplanete();i++) {
  box_objet->DeleteString(0);
}
	result=1;
	CloseWindow(result);
}
void TDialogEphemeride::Fin(){
	 result=0;
	 d->setannee(box_annee->GetSelIndex()+anneedebut);
	 d->setmois(box_mois->GetSelIndex()+1);
	 d->setjour(box_jour->GetSelIndex()+1);
	 d->setheure(box_heure->GetSelIndex());
	 d->miseajour();
	 int i;
for(i=0;i<anneefin-anneedebut;i++) box_annee->DeleteString(0);
for(i=0;i<12;i++) box_mois->DeleteString(0);
for(i=0;i<31;i++) box_jour->DeleteString(0);
for(i=0;i<24;i++) box_heure->DeleteString(0);
box_objet->DeleteString(0);//supression du soleil
for(i=0;i<system->getnbrplanete()-1;i++) {
  box_objet->DeleteString(0);
}
box_objet->DeleteString(0);//supression  lune

		CloseWindow(result);
  }

void TDialogEphemeride::ModifAnnee(){
		 int year,mois,day;

	 year=box_annee->GetSelIndex()+anneedebut;
	 day=box_jour->GetSelIndex()+1;
	 mois=box_mois->GetSelIndex();
	  //regarde si annee bixetile ou non et si on est au mois de fevrier
	 if ((year)%4!=0){ //annee non bixetile
					if (mois==1 && box_jour->FindString("29", 0)>=0 ){
							box_jour->DeleteString(28);
					if (day==29) box_jour->SetText("28");
					}
	 }
	 else {
		 if (mois==1 && box_jour->FindString("29", 1)<0 ){
					box_jour->AddString("29");
			}

	 }
}
void TDialogEphemeride::ModifFin(){
  d->setannee(box_annee->GetSelIndex()+anneedebut);
  d->setmois(box_mois->GetSelIndex()+1);
  d->setjour(box_jour->GetSelIndex()+1);
  d->setheure(box_heure->GetSelIndex());
  d->miseajour();
  pas=box_pas->GetSelIndex();
  if (pas==0) pas=1;
  else pas*=24;
  nombre=(box_nombre->GetSelIndex()+1)*5;
  //calcule la date de fin
  d->ajoutheure(pas*nombre);
  d->antimiseajour();
  char str[15];
  sprintf(str,"%d/%d/%d",d->getjour(),d->getmois(),d->getannee());
  edit_fin->SetText(str);

}
void TDialogEphemeride::Verif(){
	 int year,mois,day;

	 year=box_annee->GetSelIndex()+anneedebut;
	 day=box_jour->GetSelIndex()+1;
	 mois=box_mois->GetSelIndex();
	 if ( box_jour->FindString("29", 0)<0) box_jour->AddString("29");
	 if ( box_jour->FindString("30", 0)<0) box_jour->AddString("30");
	 // il y a au moins trente jours pour chaque mois
	 if (mois==0 || mois==2 || mois==4 || mois==6 || mois==7 || mois==9 || mois==11){
			// mois a 31 jour mais il manque le 31e jour
			if(box_jour->FindString("31", 0)<0) box_jour->AddString("31");
	 }
	 else{// autres mois sauf fevrier et il y a le 31e jour en trop
			if (mois!=1 && box_jour->FindString("31", 0)>=0 ){
					box_jour->DeleteString(30);
					if (day==31) box_jour->SetText("30");
			}
			else{   // mois de fevrier
				if (mois==1){
					  if ((year)%4!=0){ // annee non bissextile
							if (box_jour->FindString("31", 0)>=0) box_jour->DeleteString(30);
							if (box_jour->FindString("30", 0)>=0) box_jour->DeleteString(29);
							if (box_jour->FindString("29", 0)>=0) box_jour->DeleteString(28);
							if (day>28) box_jour->SetText("28");
					  }
					  else {  // annee bissextile
							if (box_jour->FindString("31", 0)>=0) box_jour->DeleteString(30);
							if (box_jour->FindString("30", 0)>=0) box_jour->DeleteString(29);
							if (day>28) box_jour->SetText("29");
					  }
				}
			}
	 }
}
void TDialogEphemeride::ModifMois(){
    Verif();
	 }
void TDialogEphemeride::Calculer(){
   char src[50];
  static TOpenSaveDialog::TData data (
	 0,
	 "Fichier Texte (*.TXT)|*.txt|",
	 0,
	 "",
	 "TXT"
  );
  if (TFileOpenDialog(this, data,0,"Sauvegarder les phmrides").Execute() == IDOK) {
	 char fileTitle[30];
	 TOpenSaveDialog::GetFileTitle(data.FileName, fileTitle, 30);
	 strcpy(src,fileTitle);
	 SetCursor(0,IDC_WAIT);
	 Calculer2(src);
	 MessageBox("Ephmrides sauvegards", "Information", MB_OK	);
	 SetCursor(0,IDC_ARROW);
  }
}
void TDialogEphemeride::Prevoir(){
   Pipo_txt->SetText("Veillez patienter...");
	Calculer2("temp.syt");
   FILE*fptr1=fopen("temp.syt","rt");
   char texto[10000];
   int i,c;
   i=1;c=fgetc(fptr1);
   texto[0]=c;
   while(c!=EOF){
   	i=1;
   	while(c!=EOF && i<9999) {c=fgetc(fptr1);texto[i++]=c;}
      texto[i-1]='\0';
   	Pipo_txt->SetText(texto);
   }
   fclose(fptr1);
}

void TDialogEphemeride::Calculer2(char* src){
 FILE*fptr1=fopen(src,"wt");
 double ascension,declinaison,Surf=0.0,Diam=0.0,Mag=0.;
 int as1,as2,as3,de1,de2,de3,obje,i;
 char stringo[15];
 d->setannee(box_annee->GetSelIndex()+anneedebut);
  d->setmois(box_mois->GetSelIndex()+1);
  d->setjour(box_jour->GetSelIndex()+1);
  d->setheure(box_heure->GetSelIndex());
  d->miseajour();
  pas=box_pas->GetSelIndex();
  if (pas==0) pas=1;
  else pas*=24;
  nombre=(box_nombre->GetSelIndex()+1)*5;
  //calcule la date de fin

 
obje=box_objet->GetSelIndex()-1;
	if (obje==-1){
			fprintf(fptr1,"\t\t\tEphmrides du soleil\n\t\t\t---------------------\n\n");
			fprintf(fptr1,"   Date\t\tAscension droite\tDclinaison\n");
	}
	else{
		if (obje<system->getnbrplanete()-1){
			if (obje>=2) obje++;
			sprintf(stringo,"Ephmrides de %s",system->getplanete(obje)->getnom());
			fprintf(fptr1,"\t\t\t%s\n\t\t\t",stringo);
			i=strlen(stringo);
			while (i-->0) fprintf(fptr1,"-");
         fprintf(fptr1,"\n\n   Date\t\tAscension droite\tDclinaison \tMagnitude\tDiametre angulaire\n");
			if (obje>=2) obje--;
		}
		else{
			 fprintf(fptr1,"\t\t\tEphmrides de la Lune\n\t\t\t----------------------\n\n");
			 fprintf(fptr1,"   Date\t\tAscension droite\tDclinaison\tPhase\tDiametre angulaire\n");
		}
	}
	 for(i=0;i<nombre;i++){
 if (obje==-1){//etoile centrale
		system->getsun()->calculposition(d);
		// chargement des donnes
		declinaison=system->getsun()->getdeclinaison();
		ascension=system->getsun()->getascensiondroite();

 }
else{
// si objet=planete
 if (obje<system->getnbrplanete()-1){
 // calcul de la position
	 if (obje>=2) obje++;     //evite la terre
	 system->getplanete(obje)->calculposition(d,system->getsun());
	 system->getplanete(obje)->parallax(d,system->getlatitude(),system->getlongitude());
 // chargement des donnes
		  declinaison=system->getplanete(obje)->getdeclinaison();//+system->getplanete(obje)->correcteur(system->getsun(),d)[1]+system->getplanete(obje)->correcteur(system->getsun(),d)[3];
		  ascension=system->getplanete(obje)->getascensiondroite();//+system->getplanete(obje)->correcteur(system->getsun(),d)[0]+system->getplanete(obje)->correcteur(system->getsun(),d)[2];
		  //distance=system->getplanete(obje)->getdistancealamere();
		  Surf=system->getplanete(obje)->getsurface();
		  Mag=system->getplanete(obje)->getmag();
		  Diam=(double)system->getplanete(obje)->getrayon()/1000./(double)system->getplanete(obje)->getdistancealamere();
	  if (obje>=2) obje--;

 }
 else {  // c'est un satellite mais lequel?


 // maintenant on sait lequel !
  // clacul de la position
		system->getplanete(2)->getsatellite(0)->calculposition(d,system->getsun());
		system->getplanete(2)->getsatellite(0)->parallax(d,system->getlatitude(),system->getlongitude());
  // chargement des donnes
		  declinaison=system->getplanete(2)->getsatellite(0)->getdeclinaison();
		  ascension=system->getplanete(2)->getsatellite(0)->getascensiondroite();
		  //distance=system->getplanete(2)->getsatellite(0)->getdistancealamere();
		  Diam=system->getplanete(2)->getsatellite(0)->getrayon()/1000./system->getplanete(2)->getsatellite(0)->getdistancealamere();
				//fraction du disque illuminee
					double phase1,phase2,partie=1;

					phase1=((d->getannee()+(d->getmois()+d->getjour()/31.0)/12)-1900)*12.3685;
					if (phase1>=0){
						phase2=phase1-floor(phase1);
						if (phase2<0.6&&phase2>0.099) partie=1;
						else partie=-1;
					}
					else{
						phase2=phase1-ceil(phase1);
						if (phase2>0.599||phase2<0.1) partie=1;
						else partie=-1;
					}
				Surf=partie*(system->getplanete(2)->getsatellite(0)->fractionillumnee(d,system->getsun()));


	}    // else
 }    //else

 Diam*=8.66322/M_PI; //->diam en seconde d'arc

 // maintenant on connait asc, dec et dist de l'objet

 // conversion en deg, min, sec
		double dec1=declinaison,asc1=ascension;
		if (declinaison>=0) de1=floor(declinaison);
			else de1=ceil(declinaison);
			declinaison=declinaison-de1;
			if(declinaison<0) declinaison=-declinaison;
			if (declinaison>=0) de2=floor(declinaison*60);
			else de2=ceil(declinaison*60);
			declinaison=declinaison-de2/60.00;
			if (declinaison>=0)de3=floor(declinaison*3600);
			else de3=ceil(declinaison*3600);

		if (ascension>=0) as1=floor(ascension/15.);
			else as1=ceil(ascension/15.);
			 ascension=ascension-(15*as1);
			if(ascension<0) ascension=-ascension;
			if (ascension>=0) as2=floor(ascension*4.);//4=60/15
			else as2=ceil(ascension*4.);
			 ascension=ascension-(as2/4.);
			if (ascension>=0) as3=floor(ascension*240.);
			else as3=ceil(ascension*240.);
			if(as1<0) as1=as1+24;
			//date
			fprintf(fptr1,"%dh %d/%d/%d\t  ",d->getheure(),d->getjour(), d->getmois(), d->getannee());
			//asc
			if (as1<10 && as1>=0 && asc1>=0) fprintf(fptr1,"0%d ",as1);
			if (as1==0 && asc1<0) fprintf(fptr1,"-0%d ",as1);
			if (as1>-10 && as1<=-1) fprintf(fptr1,"-0%d ",abs(as1));
			if (abs(as1)>=10) fprintf(fptr1,"%dh ",as1);
			if (abs(as2)<10) fprintf(fptr1,"0%d\' ",as2);
			if (abs(as2)>=10) fprintf(fptr1,"%d\' ",abs(as2));
			if (abs(as3)<10) fprintf(fptr1,"0%d\"\t\t",as3);
			if (abs(as3)>=10) fprintf(fptr1,"%d\"\t\t",abs(as3));
			//dec
			if (de1<10 && de1>=0 && dec1>=0) fprintf(fptr1,"0%d ",de1);
			if (de1==0 && dec1<0) fprintf(fptr1,"-0%d ",de1);
			if (de1>-10 && de1<=-1) fprintf(fptr1,"-0%d ",abs(de1));
			if (abs(de1)>=10) fprintf(fptr1,"%d ",de1);
			if (abs(de2)<10) fprintf(fptr1,"0%d\' ",de2);
			if (abs(de2)>=10) fprintf(fptr1,"%d\' ",abs(de2));
			if (abs(de3)<10) fprintf(fptr1,"0%d\"\t",de3);
			if (abs(de3)>=10) fprintf(fptr1,"%d\"\t",abs(de3));
			if (obje>=0){
				if (obje<system->getnbrplanete()-1){   //particulier aux planetes
					// magnitude
					fprintf(fptr1,"  %3.2lf\t\t",Mag);
					// diametre
					fprintf(fptr1,"   %3.2lf\"",Diam);
				}   //if obj<
				else{ //pour la lune
					// phase
					Surf/=2.;
					if (Surf<0) Surf=0.5-Surf;
					fprintf(fptr1,"%3.2lf\t",Surf);
					// diametre
					Diam/=60.;
					fprintf(fptr1,"    %3.2lf\'",Diam);
				}//else
			} //if obj>0

			fprintf(fptr1,"\n",abs(de3));
		d->ajoutheure(pas);
		d->antimiseajour();
	 }// for i


		
 // affichage
		 if (obje==system->getnbrplanete()) fprintf(fptr1,"\nPhase:\t0 ou 1 -> Nouvelle Lune\n\t0.25 -> Premier quartier\n\t0.50 -> Pleine Lune\n\t0.75 -> Dernier quartier");
		 fprintf(fptr1,"\n\n\n\t*-*-* Spica *-*-*");//\n--> Version de dmonstration <--\n lsaintma@messel.emse.fr");
		 fclose(fptr1);
}


DEFINE_RESPONSE_TABLE1( TDialogEphemeride, TDialog )
  EV_WM_PAINT,

  EV_COMMAND( 106, Fin ),
  EV_COMMAND( 107, Calculer ),
  EV_COMMAND( 111, Prevoir ),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_ANNEE,ModifAnnee),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_MOIS,ModifMois),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_PAS,ModifFin),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_NOMBRE,ModifFin),

END_RESPONSE_TABLE;


//------------------------------------------

//------------------------------------------

TDialogPrevision::TDialogPrevision( TWindow* parent,systeme* syst,date2*datum):
	 TDialog( parent, DIALOG_PIPO) {

	 system=syst;
	 box_annee=new TComboBox(this,IDC_COMBOBOX_ANNEE);
	 box_mois=new TComboBox(this,IDC_COMBOBOX_MOIS);
	 box_jour=new TComboBox(this,IDC_COMBOBOX_JOUR);
	 box_heure=new TComboBox(this,IDC_COMBOBOX_HEURE);

    Pipo_txt=new TRichEdit(this,IDC_EDIT_PIPO);


	 SetTransferBuffer(&epheData); // l ou stocke les donnees des combobox

	 d=datum;

  }
TDialogPrevision::~TDialogPrevision(){
	box_annee->~TComboBox();
	box_mois->~TComboBox();
	box_jour->~TComboBox();
	box_heure->~TComboBox();
   Pipo_txt->~TRichEdit();
	}

void TDialogPrevision::SetupWindow() {
	 TDialog::SetupWindow();
	 int i=1;
	 char string[10];

    Pipo_txt->SetText("Choisissez la date\nPuis cliquez sur le bouton \"Prvoir\"");

// entree des annee;
	 for(i=anneedebut;i<anneefin;i++){
		box_annee->AddString(itoa(i,string,10));
	 }
	 box_annee->SetText(itoa(d->getannee(),string,10));

// entree des mois
	 box_mois->AddString("Janvier");
	 box_mois->AddString("Fvrier");
	 box_mois->AddString("Mars");
	 box_mois->AddString("Avril");
	 box_mois->AddString("Mai");
	 box_mois->AddString("Juin");
	 box_mois->AddString("Juillet");
	 box_mois->AddString("Aout");
	 box_mois->AddString("Septembre");
	 box_mois->AddString("Octobre");
	 box_mois->AddString("Novembre");
	 box_mois->AddString("Dcembre");

	 box_mois->SetSelIndex(d->getmois()-1);

// entree des jours

	 for(i=1;i<=31;i++){
	 box_jour->AddString(itoa(i,string,10));
	 }
	 Verif();// pour supprimer le 31 ...
	 box_jour->SetSelIndex(d->getjour()-1);

 // entree des heures
    	 for(i=0;i<=23;i++){
	 box_heure->AddString(itoa(i,string,10));
	 }
	 box_heure->SetSelIndex(d->getheure());



}
void TDialogPrevision::EvPaint() {
	 TDialog::EvPaint();
	 }

int TDialogPrevision::Execute() {
	 TDialog::Execute();
	 return result;

}

void TDialogPrevision::Ignore() {}
void TDialogPrevision::Fin2(){
	 int i;
for(i=0;i<anneefin-anneedebut;i++) box_annee->DeleteString(0);
for(i=0;i<12;i++) box_mois->DeleteString(0);
for(i=0;i<31;i++) box_jour->DeleteString(0);
for(i=0;i<24;i++) box_heure->DeleteString(0);
	result=1;
	CloseWindow(result);
}
void TDialogPrevision::Fin(){
	 result=0;
	 d->setannee(box_annee->GetSelIndex()+anneedebut);
	 d->setmois(box_mois->GetSelIndex()+1);
	 d->setjour(box_jour->GetSelIndex()+1);
	 d->setheure(box_heure->GetSelIndex());
	 d->miseajour();
	 int i;
for(i=0;i<anneefin-anneedebut;i++) box_annee->DeleteString(0);
for(i=0;i<12;i++) box_mois->DeleteString(0);
for(i=0;i<31;i++) box_jour->DeleteString(0);
for(i=0;i<24;i++) box_heure->DeleteString(0);

		CloseWindow(result);
  }

void TDialogPrevision::ModifAnnee(){
		 int year,mois,day;

	 year=box_annee->GetSelIndex()+anneedebut;
	 day=box_jour->GetSelIndex()+1;
	 mois=box_mois->GetSelIndex();
	  //regarde si annee bixetile ou non et si on est au mois de fevrier
	 if ((year)%4!=0){ //annee non bixetile
					if (mois==1 && box_jour->FindString("29", 0)>=0 ){
							box_jour->DeleteString(28);
					if (day==29) box_jour->SetText("28");
					}
	 }
	 else {
		 if (mois==1 && box_jour->FindString("29", 1)<0 ){
					box_jour->AddString("29");
			}

	 }
}

void TDialogPrevision::Verif(){
	 int year,mois,day;

	 year=box_annee->GetSelIndex()+anneedebut;
	 day=box_jour->GetSelIndex()+1;
	 mois=box_mois->GetSelIndex();
	 if ( box_jour->FindString("29", 0)<0) box_jour->AddString("29");
	 if ( box_jour->FindString("30", 0)<0) box_jour->AddString("30");
	 // il y a au moins trente jours pour chaque mois
	 if (mois==0 || mois==2 || mois==4 || mois==6 || mois==7 || mois==9 || mois==11){
			// mois a 31 jour mais il manque le 31e jour
			if(box_jour->FindString("31", 0)<0) box_jour->AddString("31");
	 }
	 else{// autres mois sauf fevrier et il y a le 31e jour en trop
			if (mois!=1 && box_jour->FindString("31", 0)>=0 ){
					box_jour->DeleteString(30);
					if (day==31) box_jour->SetText("30");
			}
			else{   // mois de fevrier
				if (mois==1){
					  if ((year)%4!=0){ // annee non bissextile
							if (box_jour->FindString("31", 0)>=0) box_jour->DeleteString(30);
							if (box_jour->FindString("30", 0)>=0) box_jour->DeleteString(29);
							if (box_jour->FindString("29", 0)>=0) box_jour->DeleteString(28);
							if (day>28) box_jour->SetText("28");
					  }
					  else {  // annee bissextile
							if (box_jour->FindString("31", 0)>=0) box_jour->DeleteString(30);
							if (box_jour->FindString("30", 0)>=0) box_jour->DeleteString(29);
							if (day>28) box_jour->SetText("29");
					  }
				}
			}
	 }
}
void TDialogPrevision::ModifMois(){
    Verif();
	 }
void TDialogPrevision::Calculer(){
   char src[50];
  static TOpenSaveDialog::TData data (
	 0,
	 "Fichier Texte (*.TXT)|*.txt|",
	 0,
	 "",
	 "TXT"
  );
  if (TFileOpenDialog(this, data,0,"Sauvegarder les prvisions").Execute() == IDOK) {
	 char fileTitle[30];
	 TOpenSaveDialog::GetFileTitle(data.FileName, fileTitle, 30);
	 strcpy(src,fileTitle);
	 SetCursor(0,IDC_WAIT);
	 Calculer2(src);
	 MessageBox("Prvisions sauvegards", "Information", MB_OK	);
	 SetCursor(0,IDC_ARROW);
  }
}

void TDialogPrevision::Prevoir(){
   Pipo_txt->SetText("Veillez patienter...");
	Calculer2("temp.syt");
   FILE*fptr1=fopen("temp.syt","rt");
   char texto[10000];
   int i,c;
   i=1;c=fgetc(fptr1);
   texto[0]=c;
   while(c!=EOF){
   	i=1;
   	while(c!=EOF && i<9999) {c=fgetc(fptr1);texto[i++]=c;}
      texto[i-1]='\0';
   	Pipo_txt->SetText(texto);
   }
   fclose(fptr1);
}

void TDialogPrevision::Calculer2(char* src){

  d->setannee(box_annee->GetSelIndex()+anneedebut);
  d->setmois(box_mois->GetSelIndex()+1);
  d->setjour(box_jour->GetSelIndex()+1);
  d->setheure(box_heure->GetSelIndex());
  d->miseajour();

  commentaire(d,system,src);

  

}


DEFINE_RESPONSE_TABLE1( TDialogPrevision, TDialog )
  EV_WM_PAINT,

  EV_COMMAND( IDC_OK, Fin ),
  EV_COMMAND( IDC_CALCULER, Prevoir ),
  EV_COMMAND( IDC_SAUVE, Calculer ),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_ANNEE,ModifAnnee),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_MOIS,ModifMois),

END_RESPONSE_TABLE;




