//--------------------------------------------------------------------------
// Plantarium -- Copyright (c) 1998
//--------------------------------------------------------------------------
#ifndef EPHE_H
#define EPHE_H

#include <owl/dialog.h>
#include <owl/static.h>
#include <owl/button.h>
#include <owl/listbox.h>
#include <owl/combobox.h>
#include <owl/richedit.h>

#include "planetar.rh"
#include "date.h"
#include "systeme.h"

// pour les previsions
#include "commengr.h"


// pour les combobox
struct ephemerideXfer {
//{{mainXFER_DATA}}
	 TComboBoxData  box_annee;
	 TComboBoxData  box_mois;
	 TComboBoxData  box_jour;
	 TComboBoxData  box_heure;
	 TComboBoxData  box_pas;
	 TComboBoxData  box_nombre;
	 TComboBoxData  box_objet;
//{{mainXFER_DATA_END}}
};

class TDialogEphemeride: public TDialog {
private :

	systeme* system;

	// TCombobox
	TComboBox * box_annee;
	TComboBox * box_mois;
	TComboBox * box_jour;
	TComboBox * box_heure;
	TComboBox * box_objet;
	TComboBox * box_pas;
	TComboBox * box_nombre;

	// Tstatic *
	TStatic * edit_fin;
   TRichEdit * Pipo_txt;
   
   long pas,nombre;
	date2 *d;
   int result;//=0 si cancel, 1 sinon

public:
  TDialogEphemeride( TWindow* parent,systeme*syst,date2*datum );
  ~TDialogEphemeride();
  void SetupWindow() ;
  void EvPaint() ;

  int Execute() ;
  void Ignore();
  void Fin();
  void Fin2();

  void ModifFin();
  void ModifAnnee();
  void ModifMois();
  void ModifJour();
  void ModifHeure();
  void ModifObjet();
  void Calculer();
  void Prevoir();
  void Calculer2(char*src);
  void Verif();

  // pour les fonctions declenches par les boutons
  DECLARE_RESPONSE_TABLE( TDialogEphemeride );
};

class TDialogPrevision: public TDialog {
private :

	systeme* system;

	// TCombobox
	TComboBox * box_annee;
	TComboBox * box_mois;
	TComboBox * box_jour;
	TComboBox * box_heure;

   TRichEdit * Pipo_txt;

	date2 *d;
   int result;//=0 si cancel, 1 sinon

public:
  TDialogPrevision( TWindow* parent,systeme*syst,date2*datum );
  ~TDialogPrevision();
  void SetupWindow() ;
  void EvPaint() ;

  int Execute() ;
  void Ignore();
  void Fin();
  void Fin2();

  void ModifAnnee();
  void ModifMois();
  void ModifJour();
  void ModifHeure();
  void Calculer();
  void Prevoir();
  void Calculer2(char*src);
  void Verif();

  // pour les fonctions declenches par les boutons
  DECLARE_RESPONSE_TABLE( TDialogPrevision );
};

#endif // EPHE_H
