//--------------------------------------------------------------------------
// Plantarium -- Copyright (c) 1998 Laurent Saint-Marcel
//--------------------------------------------------------------------------
#include <owl\owlpch.h>
#include <stdlib.h> // conversion int -> string
#include <owl/gdiobjec.h>
#include <stdio.h>
#include <math.h>

#pragma hdrstop

#include "help.h"
#include "planetar.rh"



TDialogInfo::TDialogInfo( TWindow* parent,int type1,char*nom1,char*constel1,double asc1, double dec1,double mag1,double surface1, char*spectre1 ,double diam1):
	 TDialog( parent, DIALOG_INFO) {
    
	 type=type1;
	 asc=asc1;
	 dec=dec1;
	 mag=mag1;
    diam=diam1;
	 surface=surface1;
	 strcpy(nom,nom1);
	 strcpy(constel,constel1);
	 strcpy(spectre,spectre1);
	 hbr = CreateSolidBrush(RGB(0, 0, 0));
	 ppen=CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
    first=true;


  }
TDialogInfo::~TDialogInfo(){
	// DeleteDC(memDC);
	// DeleteObject(ppen);
	// DeleteObject(hbr);
	}
void TDialogInfo::SetupWindow() {
	 TDialog::SetupWindow();
	//  HDC hdc;
	// hdc = GetDC(HWindow);
	// memDC = CreateCompatibleDC(hdc);

	 char str[30],s[30];
	 int fenetreid=101;
	 // type
	 if (type==0) strcpy(s,"Satellite");
	 if (type==1) strcpy(s,"Plante");
	 if (type==2) strcpy(s,"Etoile");
	 if (type==3) strcpy(s,"Nebuleuse");
	 if (type==4) strcpy(s,"Amas Globulaire");
	 if (type==5) strcpy(s,"Amas Ouvert");
	 if (type==6) strcpy(s,"Galaxie");
	 if (type==7) strcpy(s,"Galaxie Elliptique");
	 if (type==8) strcpy(s,"Galaxie Spirale");
	 if (type==9) strcpy(s,"Galaxie spirale Barre");
    if (type==10) strcpy(s,"Galaxie irrgulire");
	 if (type==11) strcpy(s,"Astroide");

	 sprintf(str,"Type : %s",s);
	 SetDlgItemText(fenetreid++, str);

	 // Nom
	 if (type<=1|| type>=10){
		sprintf(str,"Nom : %s",nom);
		SetDlgItemText(fenetreid++, str);
	 }
	 // constellation
	 if (type==2){
		sprintf(str,"Constellation : %s",constel);
		SetDlgItemText(fenetreid++, str);
      sprintf(str,"Nom : %s",nom);
		SetDlgItemText(fenetreid++, str);
	 }
	 //ngc et messier
	 if (type>=3 &&type<=10){
		//sprintf(str,"Nom : %s",constel);
		//SetDlgItemText(fenetreid++, str);
		sprintf(str,"Numro : %s",nom);
		SetDlgItemText(fenetreid++, str);
	 }
	 // Ascension droite
	 int as1,as2,as3;
	 double ascension=asc;
			if (ascension>=0) as1=floor(ascension/15.);
			else as1=ceil(ascension/15.);
			 ascension=ascension-(15.*as1);
			if(ascension<0) ascension=-ascension;
			if (ascension>=0) as2=floor((ascension*60.)/15.);
			ascension=ascension-(15.*as2/60.);
			if(ascension<0) ascension=-ascension;
			if (ascension>=0) as3=floor((ascension*3600.0)/15.0);
	 sprintf(str,"Ascension droite : %dh% dm %ds",as1,as2,as3);
	 SetDlgItemText(fenetreid++, str);
	 // Declinaison
	 sprintf(str,"Dclinaison : %3.1lf",dec);
	 SetDlgItemText(fenetreid++, str);
	 // magnitude et type spectral
	 if (type==2){
		// magnitude
		sprintf(str,"Magnitude : %2.1lf",mag);
		SetDlgItemText(fenetreid++, str);
		// type spectral
		sprintf(str,"Type spectral : %s",spectre);
		SetDlgItemText(fenetreid++, str);
	 }  // if type==2

	 // dessin de la fraction illumine
		// dessine la lune dans la legende
		if(type==1 && strcmp(nom,"Pluton")!=0){

				sprintf(str,"Magnitude : %3.1lf",mag);
				SetDlgItemText(fenetreid++, str);
		}
		if (type==0 ||type==1){ //satellite ou planete
			if (surface<0) sprintf(str,"Partie visible : %3.1lf%",-surface*100.0);
			else sprintf(str,"Partie visible : %3.1lf%",surface*100.0);
			SetDlgItemText(fenetreid++, str);

			sprintf(str,"Diamtre angulaire : %5.1lf s",diam);
			SetDlgItemText(fenetreid++, str);


		} // if type


}

void TDialogInfo::EvPaint() {
// dessin du de la fraction illumne

	if ((type==0 ||type==1)&& first==true){ //satellite ou planete
			first=false;
			int i,aay=110,aax=250;
			double rayon=25.0;
			// partie noire
         HDC hdc;
	 		hdc = GetDC(HWindow);
	 		SelectObject(hdc,hbr);
			SelectObject(hdc,ppen);
			Rectangle(hdc,aax-5,aay-5,aax+5+2*rayon,aay+5+2*rayon);
         TPoint ppoin[2];

			for(i=-rayon;i<rayon;i++){
				 if (surface<0){
					ppoin[0].x=aax+rayon-rayon*cos(asin(abs(i)/rayon));
               ppoin[0].y=aay+rayon+i;
					ppoin[1].x=aax+rayon+rayon*(-1-2.0*surface)*cos(asin(abs(i)/rayon));
               ppoin[1].y=aay+rayon+i;
               Polyline(hdc,ppoin, 2);
					}
				else {
            	ppoin[0].x=aax+rayon+rayon*cos(asin(abs(i)/rayon));
               ppoin[0].y=aay+rayon+i;
					ppoin[1].x=aax+rayon+rayon*(1-2.0*surface)*cos(asin(abs(i)/rayon));
               ppoin[1].y=aay+rayon+i;
               Polyline(hdc,ppoin, 2);
				}
		  }
		ReleaseDC(HWindow, hdc);
  }



}


int TDialogInfo::Execute() {
	TDialog::Execute();
	return 1;
}
void TDialogInfo::Fin(){CloseWindow();}

DEFINE_RESPONSE_TABLE1( TDialogInfo, TDialog )

  EV_WM_PAINT,

END_RESPONSE_TABLE;


