#include "jovsat.h"
#include "horaire.h"
#include <owl\dc.h>

//position des satellites de jupiter
void jovsat(date2* datum,systeme *sys)
{
//avec par ordre d'apparition:
double t,d,v,m,n,j,a,b,k,R,r,delta,phi,u1,u2,u3,u4,g,h,r1,r2,r3,r4,grs,lgmsjII;

t=datum->getsieclejulien();
d=t*36525.0;
v=134.63+0.00111587*d;
m=358.476+0.9856005*d;
n=225.328+0.0830853*d+0.33*sin(dr(v));
j=221.647+0.9025179*d-0.33*sin(dr(v));

a=1.916*sin(dr(m))+0.02*sin(dr(2*m));
b=5.552*sin(dr(n))+0.167*sin(dr(2*n));
k=j+a-b;

R=1.00014-0.01672*cos(dr(m))-0.00014*cos(dr(2*m));
r=5.20867-0.25192*cos(dr(n))-0.0061*cos(dr(2*n));

delta=sqrt(r*r+R*R-2*r*R*cos(dr(k)));
phi=rd(asin((R/delta)*sin(dr(k))));
//la grde tache rouge de jov appartient au systme II et est decale de 42 deg E
lgmsjII=mespr(290.28+870.1869088*(d-(delta/173.0))+phi-b);
grs=-lgmsjII+42.0 ;

//mes 4 angles pour reperer mes 4 satellites, non corrigs
u1=mespr(84.5506+203.405863*(d-(delta/173.0))+phi-b);
u2=mespr(41.5015+101.2916323*(d-(delta/173.0))+phi-b);
u3=mespr(109.977+50.2345169*(d-(delta/173.0))+phi-b);
u4=mespr(176.3586+21.4879802*(d-(delta/173.0))+phi-b);



//termes de correction pour mes angles
g=187.3+50.310674*(d-(delta/173.0));
h=311.1+21.569226*(d-(delta/173.0));


//mes distances au centre exprimmes en rayons de jov
r1=5.9061-0.0244*cos(dr(2*(u1-u2)));
r2=9.3972-0.0889*cos(dr(2*(u2-u3)));
r3=14.9894-0.0227*cos(dr(g));
r4=26.3649-0.1944*cos(dr(h));


//correction des perturbations mutuelles des satellites pour mes angles
u1=u1+0.472*sin(2*dr(u1-u2));
u2=u2+1.073*sin(2*dr(u2-u3));
u3=u3+0.174*sin(dr(g));
u4=u4+0.845*sin(dr(h));

//pour le calcul de z
double De,Ds,lambda;
lambda=238.05+0.083091*d+0.33*sin(dr(v))+b;
Ds=3.07*sin(dr(lambda+44.5));
De=Ds-2.15*sin(dr(phi))*cos(dr(lambda+24.0))-1.31*((r-delta)/delta)*sin(dr(lambda-99.4));

int i;
sys->tabjupi[0]=r1;sys->tabjupi[1]=r2;sys->tabjupi[2]=r3;sys->tabjupi[3]=r4;
sys->tabjupi[4]=u1;sys->tabjupi[5]=u2;sys->tabjupi[6]=u3;sys->tabjupi[7]=u4;
for (i=0;i<4;i++){sys->tabjupi[8+i]=-sys->tabjupi[i]*sin(dr(sys->tabjupi[4+i]));}  // x
for (i=0;i<4;i++){sys->tabjupi[12+i]=-sys->tabjupi[i]*cos(dr(sys->tabjupi[4+i]));}  // y
for (i=0;i<4;i++){sys->tabjupi[16+i]=-sys->tabjupi[i]*cos(dr(sys->tabjupi[4+i]))*sin(dr(De));}  // z
sys->tabjupi[20]=grs;




}//fin de fonction


//-----------------------------------------------------
void jovsat_affiche(date2*d,date2*datum,systeme *sys,TMemoryDC &memdc,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint,bool NB){

	int nbr=4;   // nombre d'objets celestes
	double pas=24.; //pas de calcul en heure


//sys: pointeur sur le systeme
	if (PPrint==false){memdc.SelectObject(pinceau[0]);memdc.SelectObject(crayon[0]);}
	else {memdc.SelectObject(pinceau[1]);memdc.SelectObject(crayon[1]);}
	if (PPrint==false) memdc.SetTextColor(RGB(120,120,200));
   else memdc.SetTextColor(RGB(0,0,0));
	memdc.SetBkColor(RGB(0,0,70));

int x=0,t,i; // x=abscisse des points, t,i,j,k pour les boucles for

// caractristiques fenetre
int centre=sys->ScrW()/4,ecart=sys->ScrW()/5;// pour l'affichage:coordonnee du centre + 1/2largeur
int hauteurh=130;
int hauteurb=sys->ScrH()-28;

int antex[4];
for(i=0;i<nbr;i++) antex[i]=centre;


date2*datum2;
datum2=new date2();


//definition d'un carre sur lequel est affiche les planetes
if (PPrint==false) memdc.SelectObject(crayon[2]);   //rouge
else memdc.SelectObject(crayon[0]);
	if (PPrint==false)memdc.SelectObject(pinceau[3]); //noir
	else memdc.SelectObject(pinceau[1]);                    //blanc

memdc.Rectangle(4,hauteurh-20,centre*2-4,hauteurh+1);  //suprieur
memdc.Rectangle(4,hauteurb-1,centre*2-4,hauteurb+20);  //infrieur



// date de debut
datum2->setsieclejulien(d->getsieclejulien());
// calcul du pas en heure
pas=(datum->getsieclejulien()-d->getsieclejulien())/((float)(hauteurb-hauteurh));// 876600.0/490;
//-------------------------------------
//				copie l'ecran pour gagner du temps en cas d'animation
	memdc.Rectangle(4,hauteurh,centre*2-4,hauteurb);  //central
   // dessin du centre
		if (NB==false) memdc.SelectObject(crayon[6]);   //jaune
		else memdc.SelectObject(crayon[0]);
		memdc.MoveTo(centre,hauteurh+1);
		memdc.LineTo(centre,hauteurb-1);
		memdc.MoveTo(centre+1,hauteurh+1);
		memdc.LineTo(centre+1,hauteurb-1);
	 // redessine tout

// boucle sur l'ordonnee de l'affichage
for(t=hauteurh+1;t<hauteurb-1;t++){
  // mise a jour de la date
 // datum2->ajoutheure(pas);
  //datum2->antimiseajour();
  datum2->setsieclejulien(d->getsieclejulien()+pas*(double)(t-hauteurh-1));


  jovsat(datum2,sys);

  // x du centre
  // boucle sur les planetes
  for(i=0;i<nbr;i++){
		//calcul abscisse d'affichage
		x=centre+(sys->tabjupi[8+i])*ecart/(27.);

		// gere le cas de la Terre
		/*
		if (i<Terrenumero) memdc.SelectObject(crayon[premiercrayon+i%(derniercrayon-premiercrayon)]);       // i!=2 car on ne reprsente pas la Terre
		if (i>Terrenumero) memdc.SelectObject(crayon[premiercrayon+(i-1)%(derniercrayon-premiercrayon)]);
		*/
		// couleurs
		if (i==0) memdc.SelectObject(crayon[13]);
		if (i==1) {if (PPrint==true){
							memdc.SelectObject(crayon[3]);}
							else{
							memdc.SelectObject(crayon[1]);}
			}
		if (i==2) memdc.SelectObject(crayon[7]);
		if (i==3) memdc.SelectObject(crayon[2]);
		if (NB==true) memdc.SelectObject(crayon[0]);   //noir

		// gere les retour a la ligne
		//if (x<(centre-ecart+30) && antex[i]>(centre+ecart-30)) antex[i]=centre-ecart;
		//if (x>(centre+ecart-30) && antex[i]<(centre-ecart+30)) antex[i]=centre+ecart;
		//dessin
		memdc.MoveTo(antex[i],t-1);
		memdc.LineTo(x,t);
		antex[i]=x;
		} // for nbr
 } // for t

// redessine la ligne du cadre qui a t modifie
if (PPrint==false) memdc.SelectObject(crayon[2]);   //rouge
else memdc.SelectObject(crayon[0]);
memdc.MoveTo(4,hauteurh);
memdc.LineTo(centre*2-5,hauteurh);


// legende
	memdc.SetBkMode(TRANSPARENT);
	memdc.SetTextColor(RGB(0,0,0));
	// legende
	TextOut(memdc,sys->ScrL()+80,5,"LEGENDE",strlen("LEGENDE"));

	if (PPrint==false) memdc.SetTextColor(RGB(200,200,200));
	else memdc.SetTextColor(RGB(0,0,0));
	//TextOut(memdc,6,sys->ScrH()/2,"OUEST",5);
	//TextOut(memdc,sys->ScrL()-55,sys->ScrH()/2,"EST",3);
	if (PPrint==false) memdc.SetTextColor(RGB(0,0,0));
	else memdc.SetTextColor(RGB(0,0,0));
	// affiche nom des planetes avec ligne de la couleur correspondante devant
	for(i=0;i<nbr;i++){
		if (NB==true) memdc.SelectObject(crayon[0]);   //noir
		if (i==0){
			if (NB==false)memdc.SelectObject(crayon[13]);
				else memdc.SelectObject(crayon[3]);
			TextOut(memdc,sys->ScrL()+30,20,"Io",2);
			memdc.MoveTo(sys->ScrL()+10,25);
			memdc.LineTo(sys->ScrL()+25,25);
		}
		if (i==1){
			if (PPrint==false)memdc.SelectObject(crayon[1]);
				else memdc.SelectObject(crayon[3]);
			TextOut(memdc,sys->ScrL()+30,40,"Europa",6);
			memdc.MoveTo(sys->ScrL()+10,45);
			memdc.LineTo(sys->ScrL()+25,45);
		}
		if (i==2){
			if (NB==false)memdc.SelectObject(crayon[7]);
				else memdc.SelectObject(crayon[3]);
			TextOut(memdc,sys->ScrL()+120,20,"Ganymde",8);
			memdc.MoveTo(sys->ScrL()+100,25);
			memdc.LineTo(sys->ScrL()+115,25);
		}
		if (i==3){
			if (NB==false) memdc.SelectObject(crayon[2]);
         	else memdc.SelectObject(crayon[3]);
			TextOut(memdc,sys->ScrL()+120,40,"Callisto",8);
			memdc.MoveTo(sys->ScrL()+100,45);
			memdc.LineTo(sys->ScrL()+115,45);
		}

	}  //for i
	// affichage heure et minute
  	char txt[30];
	char txt1[30];
	datum->date4(txt1);
	sprintf(txt,"Heure GMT : %s",txt1 );
	memdc.TextOut(sys->ScrL()+20,56,txt,strlen(txt));
	date4l(datum,txt1);
	sprintf(txt,"Heure Locale : %s",txt1);
	memdc.TextOut(sys->ScrL()+20,65,txt,strlen(txt));



	if (PPrint==false)memdc.SelectObject(crayon[3]); //noir
	else memdc.SelectObject(crayon[1]);                    //blanc
	memdc.MoveTo(6,hauteurh+1);
	memdc.LineTo(centre*2-6,hauteurh+1);
	memdc.SetBkMode(OPAQUE);
// fin legende

//debut cadre supe et inferieur
	// date de debut, date de fin
	if (PPrint==true) {memdc.SetBkColor(RGB(255,255,255));memdc.SetTextColor(RGB(0,0,0));}
	else {memdc.SetBkColor(RGB(0,0,0));memdc.SetTextColor(RGB(200,200,200));}
	memdc.SetBkMode(OPAQUE);

   TextOut(memdc,6,31,"-180",5);
TextOut(memdc,centre*2-40,31,"+180",5);
sprintf(txt,"%d/%d/%d %dh  ",d->getjour(),d->getmois(),d->getannee(),d->getheure());
	TextOut(memdc,centre-37,hauteurh-17,txt,strlen(txt));
sprintf(txt,"%d/%d/%d %dh  ",datum->getjour(),datum->getmois(),datum->getannee(),datum->getheure());
	TextOut(memdc,centre-37,hauteurb+2,txt,strlen(txt));

datum2->~date2();

}

void jovsat_affichercoordonnee(date2*d,date2*datum,int y,TMemoryDC &memdc,systeme *sys){
	if (abs(sys->ScrH()-158)>3){
	memdc.SetBkColor(RGB(200,200,200));
	memdc.SetBkMode(OPAQUE);
	memdc.SetTextColor(RGB(0,0,0));
		char txt[50];
	date2 *dd;
	dd=new date2();
	dd->setsieclejulien(d->getsieclejulien()+((double)(y-130)*(datum->getsieclejulien()-d->getsieclejulien())/((double)sys->ScrH()-158.)));
	dd->antimiseajour();

	sprintf(txt,"Date pointe : %d/%d/%d %dh     ",dd->getjour(),dd->getmois(),dd->getannee(),dd->getheure());
	TextOut(memdc,sys->ScrL()+30,80,txt,strlen(txt));
	dd->~date2();
	memdc.SetBkMode(TRANSPARENT);
   }
   
}


//-----------------------------------------------------
//   vu de la terre
void jovsat_affiche2(date2*d,systeme *sys,TMemoryDC &memdc,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint,bool NB){

	int nbr=4;   // nombre d'objets celestes
//sys: pointeur sur le systeme
	if (PPrint==false){memdc.SelectObject(pinceau[0]);memdc.SelectObject(crayon[0]);}
	else {memdc.SelectObject(pinceau[1]);memdc.SelectObject(crayon[1]);}
	if (PPrint==false) memdc.SetTextColor(RGB(120,120,200));
	else memdc.SetTextColor(RGB(0,0,0));
	memdc.SetBkColor(RGB(0,0,70));

int x,y,i,z; // x=abscisse des points, t,i,j,k pour les boucles for
int centre=sys->ScrW()/4,ecart=sys->ScrW()/5;// pour l'affichage:coordonnee du centre + 1/2largeur
int hauteur=65;

//definition d'un carre sur lequel est affiche les planetes
if (PPrint==false) memdc.SelectObject(crayon[2]);   //rouge
else memdc.SelectObject(crayon[0]);
	if (PPrint==false)memdc.SelectObject(pinceau[3]); //noir
	else memdc.SelectObject(pinceau[1]);                    //blanc
memdc.Rectangle(4,30,sys->ScrW()/2-4,30+2*(hauteur-30));

// dessin de jupiter
		if (NB==false){ memdc.SelectObject(crayon[6]);   //jaune
			memdc.SelectObject(pinceau[6]);}   //jaune
		else {memdc.SelectObject(crayon[0]); memdc.SelectObject(pinceau[1]);}   //jaune
			memdc.Ellipse(centre-0.5*(float)ecart/27.,(hauteur)-0.5*(float)ecart/27.,centre+0.5*(float)ecart/27.,(hauteur)+0.5*(float)ecart/27.);



	 jovsat(d,sys);

  // boucle sur les planetes
  for(i=0;i<nbr;i++){
		//calcul abscisse d'affichage
		x=centre+(sys->tabjupi[8+i])*ecart/(27.);
		y=(hauteur)+(sys->tabjupi[16+i])*ecart/(27.);
		z=(sys->tabjupi[4+i]);   //u

		// couleurs
		if (i==0) {memdc.SelectObject(crayon[13]);memdc.SelectObject(pinceau[13]);}
		if (i==1) {if (PPrint==true){
							memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[3]);}
							else{
							memdc.SelectObject(crayon[1]);memdc.SelectObject(pinceau[1]);}
			}
		if (i==2) {memdc.SelectObject(crayon[7]);memdc.SelectObject(pinceau[7]);}
		if (i==3) {memdc.SelectObject(crayon[2]);memdc.SelectObject(pinceau[2]);}
		if (NB==true) {memdc.SelectObject(crayon[0]);memdc.SelectObject(pinceau[0]);}   //noir

		// gere les retours a la ligne
		//if (x<(centre-ecart+30) && antex[i]>(centre+ecart-30)) antex[i]=centre-ecart;
		//if (x>(centre+ecart-30) && antex[i]<(centre-ecart+30)) antex[i]=centre+ecart;
		//dessin
		if (abs(x-centre)<ecart/(27.) && abs(y-hauteur)<ecart/(27.) && abs(z)<90){
		}
		else memdc.Ellipse(x-1,y-1,x+1,y+1);
		} // for nbr



}

// vu de dessus
//-----------------------------------------------------
void jovsat_affiche3(date2*d,systeme *sys,TMemoryDC &memdc,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint,bool NB){

	int nbr=4;   // nombre d'objets celestes
//sys: pointeur sur le systeme
	if (PPrint==false){memdc.SelectObject(pinceau[0]);memdc.SelectObject(crayon[0]);}
	else {memdc.SelectObject(pinceau[1]);memdc.SelectObject(crayon[1]);}
	if (PPrint==false) memdc.SetTextColor(RGB(120,120,200));
	else memdc.SetTextColor(RGB(0,0,0));
	memdc.SetBkColor(RGB(0,0,70));

int x,y,i; // x=abscisse des points, t,i,j,k pour les boucles for
int centre=sys->ScrW()*3/4,ecart=(sys->ScrH()/2-30)/4;// pour l'affichage:coordonnee du centre + 1/2largeur


//definition d'un carre sur lequel est affiche les planetes
if (PPrint==false) memdc.SelectObject(crayon[2]);   //rouge
else memdc.SelectObject(crayon[0]);
	if (PPrint==false)memdc.SelectObject(pinceau[3]); //noir
	else memdc.SelectObject(pinceau[1]);                    //blanc
memdc.Rectangle(sys->ScrW()/2+5,110,sys->ScrW()-10,sys->ScrH()/2+30);

// dessin de jupiter
		if (NB==false){ memdc.SelectObject(crayon[6]);   //jaune
			memdc.SelectObject(pinceau[6]);}   //jaune
		else {memdc.SelectObject(crayon[0]); memdc.SelectObject(pinceau[1]);}   //jaune
			memdc.Ellipse(centre-0.5*(float)ecart/27.,(sys->ScrH()/4+60)-0.5*(float)ecart/27.,centre+0.5*(float)ecart/27.,(sys->ScrH()/4+60)+0.5*(float)ecart/27.);

  // calcul position des satellites
		jovsat(d,sys);

  // boucle sur les planetes
  for(i=0;i<nbr;i++){
		//calcul abscisse d'affichage
		x=centre+(sys->tabjupi[8+i])*ecart/(27.);
		y=(sys->ScrH()/4+60)+(sys->tabjupi[12+i])*ecart/(27.);

		// couleurs
		if (i==0) {memdc.SelectObject(crayon[13]);memdc.SelectObject(pinceau[13]);}
				if (i==1) {if (PPrint==true){
							memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[3]);}
							else{
							memdc.SelectObject(crayon[1]);memdc.SelectObject(pinceau[1]);}
			}
		if (i==2) {memdc.SelectObject(crayon[7]);memdc.SelectObject(pinceau[7]);}
		if (i==3) {memdc.SelectObject(crayon[2]);memdc.SelectObject(pinceau[2]);}
		if (NB==true) {memdc.SelectObject(crayon[0]);memdc.SelectObject(pinceau[0]);}   //noir

		// gere les retour a la ligne
		//if (x<(centre-ecart+30) && antex[i]>(centre+ecart-30)) antex[i]=centre-ecart;
		//if (x>(centre+ecart-30) && antex[i]<(centre-ecart+30)) antex[i]=centre+ecart;
		//dessin
	   memdc.Ellipse(x-1,y-1,x+1,y+1);
		} // for nbr


}




///---------------------------------------
// affiche jupi + tache +ombre satellites
void jovsat_affichetache(date2*d,systeme *sys,TMemoryDC &memdc ,TMemoryDC &memdc2,TBitmap *Jupi,TBitmap *Tache,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint,bool NB){
  double grs;

	//definition d'un carre sur lequel est affiche les planetes
	if (PPrint==false) memdc.SelectObject(crayon[2]);   //rouge
		else memdc.SelectObject(crayon[0]);
	if (PPrint==false)memdc.SelectObject(pinceau[3]); //noir
		else memdc.SelectObject(pinceau[1]);                    //blanc
	memdc.Rectangle(sys->ScrW()/2+8,sys->ScrH()/2+45,sys->ScrW()-10,sys->ScrH()-10);

// boucle sur l'ordonnee de l'affichage
jovsat(d,sys);
  grs=sys->tabjupi[20];


float R=90*(float)sys->ScrH()/500.; //rayon jupi en pixel base 500 pixels de haut
float H=32*(float)sys->ScrH()/500.; // position de la tache rouge %  l'equateur
float r=8*(float)sys->ScrH()/500.; // rayon de la tache

int X=sys->ScrW()*3/4;  // centre de la planete
int Y=sys->ScrH()*3/4+15; //   "
int i,j;
// dessin planete
	if (NB==false){
		 TBitmap * Jupi2;
		 Jupi2=new TBitmap(*Jupi);
		 memdc2.SelectObject(*Jupi2);
		 memdc2.StretchBlt(0, 0, 2*R, 2*R,memdc2, 0, 0, 212, 198, SRCCOPY);
		 memdc.BitBlt(X-R,Y-R,2*R,2*R,memdc2,0,0, SRCCOPY);
		 memdc2.RestoreBitmap();
		 Jupi2->~TBitmap();
		 // scan pour enlever blanc
		 if (PPrint==true){
			TColor koul;
			for(i=X-R;i<=X+R;i++){
				for(j=Y-R;j<=Y+R;j++){
				 koul=memdc.GetPixel(i,j);
				 if(koul.Blue()==0 && koul.Green()==0 &&koul.Red()==0) memdc.SetPixel(i,j,RGB(255,255,255));
				}
			}
		 }
	}
	else {
			memdc.SelectObject(pinceau[1]); // blanc
			memdc.SelectObject(crayon[3]);  // noir
			memdc.Ellipse(X-R,Y-R,X+R,Y+R);

	}

// tache
// rayon au niveau de la tache
	float R2=0.8*R*cos(atan((H+r)/R));
// si visible on calcul sa position et on l'affiche
	if ( (mespr(grs)>0 && mespr(grs)<90)||(mespr(grs)>270 && mespr(grs)<360)){
		int x=X+R2*sin(dr(grs));  //centre ellipse
		int y=Y-H*(float)sys->ScrH()/500.;           //    "
		int lx=1.2*(int)(r*cos(dr(grs)));
		int ly=0.8*(int)r;
		if (NB==true ){
			memdc.SelectObject(pinceau[3]); // noir
			memdc.SelectObject(crayon[3]);
			memdc.Ellipse(x-lx,y-ly,x+lx,y+ly);    // dessin tache
		}
		else{    /*
       TBitmap * Jupi2;
		 Jupi2=new TBitmap(*Tache);
		 memdc2.SelectObject(*Jupi2);
		 dx=(float)(R*lx)*(8./212.);
		 dy=(float)(R*ly)*(4./198.);
       if(dx<0) dx=-dx;
		 memdc2.StretchBlt(0, 0, dx, dy,memdc2, 0, 0, 40, 24, SRCCOPY);
		 memdc.BitBlt(x-dx/2.,y-dy/2.,dx,dy,memdc2,0,0, SRCCOPY);
		 memdc2.RestoreBitmap();
		 Jupi2->~TBitmap();
		 */
		 memdc.SelectObject(pinceau[7]);
       memdc.SelectObject(crayon[1]); // blanc
		 memdc.Ellipse(x-lx,y-ly,x+lx,y+ly);    // dessin tache
		}

	}
  int nbr=4,x,y,z;
 // dessin des satellites
   for(i=0;i<nbr;i++){
		//calcul abscisse d'affichage
		x=X+(sys->tabjupi[8+i])*R;
		z=Y+(sys->tabjupi[16+i])*R;
		y=(sys->tabjupi[12+i])*R;

		// couleurs
		if (i==0) {memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[13]);}
		if (i==1) {if (PPrint==true){
							memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[3]);}
							else{
							memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[1]);}
			}
		if (i==2) {memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[7]);}
		if (i==3) {memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[2]);}
		if (NB==true) {memdc.SelectObject(crayon[0]);memdc.SelectObject(pinceau[0]);}   //noir
		//dessin
		if ( ( ((x-X)*(x-X)+(z-Y)*(z-Y))<R*R && y>0 ) || x<sys->ScrW()/2.+9 || x>sys->ScrW()-12 || z<sys->ScrH()/2+46 || z>sys->ScrH()-12){
		}
		  else memdc.Ellipse(x-3,z-3,x+3,z+3);
	} // for nbr

}
