#ifndef OBJET_CELESTE_H
#define OBJET_CELESTE_H
#include "constant.h"
#include "date.h"
//#include "systeme.h" // pour les constantes (en particulier dp)
class soleil;


class objetceleste{
  public:
	 char nom[max_nom];
	 char couleur[max_couleur];
	 double rayon;
    double Magn[4]; // magnitude

	 // caracteristiques de la position
	 double L[dp];  //longitude moyenne de l'objet
	 double a[dp];  //demi gd axe de l'orbite
	 double e[dp];  //excentricit de l'orbite
	 double I[dp];  // inclinaison de l'orbite
	 double o[dp];  // argument du perihelie
	 double O[dp];  // longitude du noeud ascendant
	 double M[dp];  // aniomalie moyenne

	 // position a l'ecran
	 int posiecranX,posiecranY;

	 // coordonnes  une date T
	 double latitude;
	 double longitude;
	 double distanceausoleil;

	 double declinaison;
	 double ascensiondroite;
	 double distancealamere;

// methodes

  public:
	 // constructeur - destructeur
	 objetceleste(char *, char * , double);
	 ~objetceleste(){};

	 // mise a jour des caracteristiques
	 void setL(double k,int rang);
	 void seta(double k,int rang);
	 void sete(double k,int rang);
	 void setI(double k,int rang);
	 void seto(double k,int rang);
	 void setO(double k,int rang);
	 void setM(double k,int rang);

	 //void setMag(double Magni,int rang);

	 double getlatitude();
	 double getlongitude();
	 double getdistanceausoleil();

	 double getdeclinaison();
	 double getascensiondroite();
	 double getdistancealamere();
	 double getrayon();
	 void parallax(date2 *,double,double);

	 //mise a jour de eo
	 double mise_a_jour(double * ,double );
	 double* getL(void);
	 double* gete(void);
	 double* getM(void);

	 char* getnom();

	 //virtual void calculposition(date2*,soleil*)=0;  //applique les fonctions de calcul

	 // position a l'ecran
		 // pour connaitre sa position  l'ecran
	 void setx(int q){posiecranX=q;}
	 void sety(int q){posiecranY=q;}
	 int getx(void){return posiecranX;}
	 int gety(void){return posiecranY;}


		  void setMagni(double Magni,int rang);
	  double getMagni(int rang);
};

#endif // OBJET_CELESTE_H



