#include "planete.h"
#include "outil.h"
#include "date.h"
#include  "soleil.h"
#include <stdio.h>
#include <string.h>
#include <math.h>

//methodes
  // constructeur - destructeur
	 planete::planete(char*no,char*couleu,double rayo) :objetceleste(no,couleu,rayo) {
	 }
	 planete::~planete(){}

  // fonctions set
	 void planete::setnbrsatellite(int n){nbrsat=n;}
	 void planete::setsatellite(satellite *sat,int rang)// attention : rang E [0, nbrsat-1]
	 { if (rang>=0 && rang<nbrsat) tabsat[rang]=sat;
	 }
  // fonctions get
	 int planete::getnbrsatellite(){return nbrsat;}
	 satellite * planete::getsatellite(int i){return tabsat[i];} // attention : i E [0, nbrsat-1]
  // eclairage de la planete
	double planete::getphi()
	{
		return rd(acos(min(1.,max(-1.,(distanceausoleil*distanceausoleil+distancealamere*distancealamere-1.)/(2.*distancealamere*distanceausoleil)))));
	}

	double planete::getsurface ()
	{
		return cos(dr(getphi())/2.)*cos(dr(getphi())/2.);
	}

	double planete::getmag ()
	{
   	double x=getphi()/100.;
		return (5.*log10(distanceausoleil*distancealamere)+getMagni(0)+x*getMagni(1)+x*x*getMagni(2)+x*x*x*getMagni(3));
	}

  // fonctions calcul
//*******************************************************************************

void planete::calculposition(date2*d,soleil*sun){   //calcul lat,lon,dist1
//mise a jour du tps
double t=d->getsieclejulien();

//les elements orbitaux mais cette fois calculs grace au tmps
struct eo
{double L;
 double a;
 double e;
 double i;
 double argpe;
 double longnoeasc;
 double M;
};
eo astre;

astre.L=mespr(mise_a_jour(L,t));
astre.a=mise_a_jour(a,t);
astre.e=mise_a_jour(e,t);
astre.i=mespr(mise_a_jour(I,t));
astre.argpe=mespr(mise_a_jour(o,t));
astre.longnoeasc=mespr(mise_a_jour(O,t));
astre.M=mespr(mise_a_jour(M,t));

//**************************************************************************
//*********************CALCUL COORDONNEES HELIOCENTRIQUES*******************
//**************************************************************************
//les variables intermdiaires
double E,u,v;

//calcul de E par la methode du point fixe
int i;
double tmp;
E=dr(astre.M);

for (i=0;i<20;i++)
{
E=(dr(astre.M)+astre.e*sin(E));
}
E=rd(E);

//calcul de v
v=rd(2*atan(  sqrt((1+astre.e)/(1-astre.e))  * tan(dr(E)/2)  ));
//calcul de distanceausoleil
distanceausoleil=astre.a*(1-astre.e*cos( dr(E) ) );

//calcul de u
u=mespr(astre.L+v-(astre.M+astre.longnoeasc));

//calcul de la latitude
//assert(astre.i<90);
tmp=mespr(rd(  atan(  cos(dr(astre.i)) * tan(dr(u)) )  ));
if(fabs(tmp-u)>90)  tmp=mespr(tmp+180);

longitude=mespr(tmp+astre.longnoeasc);

//calcul de longitude
latitude=rd(asin( sin(dr(u)) * sin(dr(astre.i)) ));

//**************************************************************************
//*****************CALCUL COORDONNEES GEOCENTRIQUES*************************
//**************************************************************************

char * earth="Terre";

if(strcmp(earth,nom)!=0)
{
//Calcul des coordonnes du soleil

//cette fois calculs grace au tmps
struct eo_soleil
{double L;
 double e;
 double M;
 double epsilon;
};

struct eo_soleil sol;

sol.L=mespr(mise_a_jour(sun->getL(),t));
sol.e=mise_a_jour(sun->gete(),t);
sol.M=mespr(mise_a_jour(sun->getM(),t));
sol.epsilon=mise_a_jour(sun->getepsilon(),t);


//calcul de Es par la methode du point fixe
double Es,vs,Os,Rs,lambda,beta;
Es=dr(sol.M);
for (i=0;i<20;i++)
{
Es=(dr(sol.M)+sol.e*sin(Es));
}
Es=mespr(rd(Es));

//calcul de vs
vs=rd(2*atan(  sqrt((1+sol.e)/(1-sol.e))  * tan(dr(Es)/2)  ));

//calcul de la longitude vraie Os
Os=mespr(sol.L+vs-sol.M);

//Calcul du rayon Rs
Rs=1.0000002*(1-sol.e*cos(dr(Es)));



//calcul de la longitude et de la latitude geocentrique
//Calcul de lambda
//GARE AU SCROUNCH!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
lambda=rd(atan(  ( distanceausoleil*cos(dr(latitude))*sin(dr(longitude-Os)) ) / ( distanceausoleil*cos(dr(latitude)) * cos(dr(longitude-Os)) + Rs) ));
if(( distanceausoleil*cos(dr(latitude)) * cos(dr(longitude-Os)) + Rs)<0) lambda=lambda+180;
lambda=mespr(lambda+Os);

//calcul de distancealamere
distancealamere=sqrt(Rs*Rs+distanceausoleil*distanceausoleil+2*distanceausoleil*Rs*cos(dr(latitude))*cos(dr(longitude-Os)));

//calcul de beta
beta=rd(asin( (distanceausoleil/distancealamere) *sin(dr(latitude)) ));

//gare au scrounch!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
ascensiondroite=rd(atan( ( sin(dr(lambda)) * cos(dr(sol.epsilon)) - tan(dr(beta)) * sin(dr(sol.epsilon)) ) / cos(dr(lambda))  ));
if(cos(dr(lambda))<0) ascensiondroite+=180;
while (ascensiondroite<0) ascensiondroite+=360;


declinaison=rd(asin( sin(dr(beta))*cos(dr(sol.epsilon)) + cos(dr(beta))*sin(dr(sol.epsilon))*sin(dr(lambda))  ));




} // if terre

if(strcmp(earth,nom)==0)
  {
  declinaison=0;
  ascensiondroite=0;
  distancealamere=0;
  }
}





 //**********************************************************************************
double *planete::correcteur(soleil *sun,date2 * datum)
{
//mise ajour du temps
double t=datum->getsieclejulien();
//
//cette fois calculs grace au tmps
struct eo_soleil
{double L;
 double e;
 double M;
 double epsilon;
};

struct eo_soleil sol;

sol.L=mespr(mise_a_jour(sun->getL(),t));
sol.e=mise_a_jour(sun->gete(),t);
sol.M=mespr(mise_a_jour(sun->getM(),t));
sol.epsilon=mise_a_jour(sun->getepsilon(),t);
//




 //contient ttes les donnes pr calculer une position en dp struct elements_orbitaux_lune {double Lp[dp];  double Mp[dp];  double omega[dp]; }; //les memes mas cette fois calculs grace au tmpsstruct eo_lune{double Lp; double Mp; double omega;};struct elements_orbitaux_lune dplune;struct eo_lune lune ;dplune.Lp[0]=270.434164;dplune.Lp[1]=481267.8831;dplune.Lp[2]=-0.001133;dplune.Lp[3]=0.0000019;dplune.Mp[0]=296.104608;dplune.Mp[1]=477198.8419;dplune.Mp[2]=0.009192;dplune.Mp[3]=0.0000144;dplune.omega[0]=259.183275;dplune.omega[1]=-1934.1420;dplune.omega[2]=0.002078;dplune.omega[3]=0.0000022;lune.Lp=mespr(mise_a_jour(dplune.Lp,t));lune.Mp=mespr(mise_a_jour(dplune.Mp,t));lune.omega=mespr(mise_a_jour(dplune.omega,t));



//calcul de E par la methode du point fixe
int i;
double E,v,O;
E=dr(sol.M);

for (i=0;i<20;i++)
{
E=(dr(sol.M)+sol.e*sin(E));
}
E=rd(E);

//calcul de v
v=rd(2*atan(  sqrt((1+sol.e)/(1-sol.e))  * tan(dr(E)/2)  ));

//calcul de O
O=sol.L+v-sol.M;
//sale!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//contient ttes les donnes pr calculer une position en dp

 struct elements_orbitaux_lune

 {double Lp[dp];

  double omega[dp];

 };



 //les memes mas cette fois calculs grace au tmps

struct eo_lune

{double Lp;

 double omega;


};



struct elements_orbitaux_lune dplune;

struct eo_lune lune ;



dplune.Lp[0]=270.434164;

dplune.Lp[1]=481267.8831;

dplune.Lp[2]=-0.001133;

dplune.Lp[3]=0.0000019;

dplune.omega[0]=259.183275;

dplune.omega[1]=-1934.1420;

dplune.omega[2]=0.002078;

dplune.omega[3]=0.0000022;

lune.Lp=mespr(mise_a_jour(dplune.Lp,t));
lune.omega=mespr(mise_a_jour(dplune.omega,t));
//sale!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


double dpsi,depsilon;
dpsi=-(17.2327+0.01737*t)*sin(dr(lune.omega))
	  -(1.2729+0.00013*t)*sin(dr(2*sol.L))
	  +0.2088*sin(dr(2*lune.omega))
	  -0.2037*sin(dr(2*lune.Lp))
	  +(0.1261-0.00031*t)*sin(dr(sol.M));

depsilon=
	  (9.21+0.00091*t)*cos(dr(lune.omega))
	  +(0.5522-0.00029*t)*cos(dr(2*sol.L))   //gare au scrounch+ ou -
	  -0.0904*cos(dr(2*lune.omega))
	  +0.0884*cos(dr(2*lune.Lp));

//*************************************************************
//un tableau pr renger les 4 termes de corrrection
double * correction=new double[4];
//termes d'aberrations annuelle
correction[0]=(-20.49)*((cos(dr(getascensiondroite()))*cos(dr(O))*cos(dr(sol.epsilon))+sin(dr(getascensiondroite()))*sin(dr(O)) )/cos(dr(getdeclinaison())))/3600.0  ;
correction[1]=(-20.49)*(( cos(dr(O))*cos(dr(sol.epsilon)) * (  tan(dr(sol.epsilon)) * cos(dr(getdeclinaison())) - sin(dr(getascensiondroite())) * sin(dr(getdeclinaison())) )+ cos(dr(getascensiondroite()))* sin(dr(getdeclinaison()))* sin(dr(O)) ))/3600.0;
correction[2]=(( cos(dr(sol.epsilon)) + sin(dr(sol.epsilon))*sin(dr(getascensiondroite()))+tan(dr(getdeclinaison())) )* dpsi - cos(dr(getascensiondroite()))*tan(dr(getdeclinaison()))*depsilon)/3600.0;
correction[3]=((sin(dr(sol.epsilon))*cos(dr(getascensiondroite())) )*dpsi + sin(dr(getascensiondroite()))*depsilon)/3600.0;
return correction;

}
