//--------------------------------------------------------------------------
// Plantarium -- Copyright (c) 1998 
//--------------------------------------------------------------------------
#include <owl\owlpch.h>
#include <stdlib.h> // conversion int -> string
#include <stdio.h>

#pragma hdrstop

#include "position.h"


// pour entrer la date

// pour les combobox
static positionXfer positionData;

TDialogPosition::TDialogPosition( TWindow* parent,systeme* syst,date2*datum):
	 TDialog( parent, DIALOG_POSITION) {

	 system=syst;
	 box_annee=new TComboBox(this,IDC_COMBOBOX_ANNEE);
	 box_mois=new TComboBox(this,IDC_COMBOBOX_MOIS);
	 box_jour=new TComboBox(this,IDC_COMBOBOX_JOUR);
    box_heure=new TComboBox(this,IDC_COMBOBOX_HEURE);
    box_objet=new TComboBox(this,IDC_COMBOBOX_OBJET);

	 SetTransferBuffer(&positionData); // l ou stocke les donnees des combobox

	 edit_dec1=new TStatic(this,IDC_DEC1);
	 edit_dec2=new TStatic(this,IDC_DEC2);
	 edit_dec3=new TStatic(this,IDC_DEC3);

	 edit_asc1=new TStatic(this,IDC_ASC1);
	 edit_asc2=new TStatic(this,IDC_ASC2);
	 edit_asc3=new TStatic(this,IDC_ASC3);

	 edit_distance=new TStatic(this,IDC_DISTANCE);
	 d=datum;

  }
TDialogPosition::~TDialogPosition(){
	box_annee->~TComboBox();
	box_mois->~TComboBox();
	box_jour->~TComboBox();
	box_heure->~TComboBox();
	}

void TDialogPosition::SetupWindow() {
	 TDialog::SetupWindow();
	 int i=1;
	 char string[5];

// entree des annee;
	 for(i=anneedebut;i<anneefin;i++){
		box_annee->AddString(itoa(i,string,10));
	 }
	 box_annee->SetText(itoa(d->getannee(),string,10));

// entree des mois
	 box_mois->AddString("Janvier");
	 box_mois->AddString("Fvrier");
	 box_mois->AddString("Mars");
	 box_mois->AddString("Avril");
	 box_mois->AddString("Mai");
	 box_mois->AddString("Juin");
	 box_mois->AddString("Juillet");
	 box_mois->AddString("Aout");
	 box_mois->AddString("Septembre");
	 box_mois->AddString("Octobre");
	 box_mois->AddString("Novembre");
	 box_mois->AddString("Dcembre");

	 box_mois->SetSelIndex(d->getmois()-1);

// entree des jours

	 for(i=1;i<=31;i++){
	 box_jour->AddString(itoa(i,string,10));
	 }
	 Verif();// pour supprimer le 31 ...
	 box_jour->SetSelIndex(d->getjour()-1);

 // entree des heures
    	 for(i=0;i<=23;i++){
	 box_heure->AddString(itoa(i,string,10));
	 }
	 box_heure->SetSelIndex(d->getheure());

// entree des objets
    // ajout de l'etoile centrale
		box_objet->AddString(system->getsun()->getnom());
	 // ajout des planetes
	 for(i=0;i<system->getnbrplanete();i++){
		 box_objet->AddString(system->getplanete(i)->getnom());
	 }

	 //ajout des satellites
	 for(i=0;i<system->getnbrplanete();i++){
			for(int j=0;j<system->getplanete(i)->getnbrsatellite();j++){
				box_objet->AddString(system->getplanete(i)->getsatellite(j)->getnom());
			}
	 }
	 // selection par defaut : 1e planete
	 box_objet->SetText(system->getplanete(0)->getnom());

	 ModifResultat();
  }
void TDialogPosition::EvPaint() {
	 TDialog::EvPaint();
	 }

int TDialogPosition::Execute() {
	 TDialog::Execute();
	 return result;

}

void TDialogPosition::Ignore() {}
void TDialogPosition::Fin2(){
	 int i,j;
for(i=0;i<anneefin-anneedebut;i++) box_annee->DeleteString(0);
for(i=0;i<12;i++) box_mois->DeleteString(0);
for(i=0;i<31;i++) box_jour->DeleteString(0);
for(i=0;i<24;i++) box_heure->DeleteString(0);
box_objet->DeleteString(0);//supression du soleil
for(i=0;i<system->getnbrplanete();i++) {
  box_objet->DeleteString(0);
  for(j=0;j<system->getplanete(i)->getnbrsatellite();j++) {
	 box_objet->DeleteString(0);
  }
}
	result=1;
	CloseWindow(result);
}
void TDialogPosition::Fin(){
	 result=0;
	 d->setannee(box_annee->GetSelIndex()+anneedebut);
	 d->setmois(box_mois->GetSelIndex()+1);
	 d->setjour(box_jour->GetSelIndex()+1);
	 d->setheure(box_heure->GetSelIndex());
	 d->miseajour();
	 int i,j;
for(i=0;i<anneefin-anneedebut;i++) box_annee->DeleteString(0);
for(i=0;i<12;i++) box_mois->DeleteString(0);
for(i=0;i<31;i++) box_jour->DeleteString(0);
for(i=0;i<24;i++) box_heure->DeleteString(0);
box_objet->DeleteString(0);//supression du soleil
for(i=0;i<system->getnbrplanete();i++) {
  box_objet->DeleteString(0);
  for(j=0;j<system->getplanete(i)->getnbrsatellite();j++) {
    box_objet->DeleteString(0);
  }
}

		CloseWindow(result);
  }

void TDialogPosition::ModifAnnee(){
		 int year,mois,day;

	 year=box_annee->GetSelIndex()+anneedebut;
	 day=box_jour->GetSelIndex()+1;
	 mois=box_mois->GetSelIndex();
	  //regarde si annee bixetile ou non et si on est au mois de fevrier
	 if ((year)%4!=0){ //annee non bixetile
					if (mois==1 && box_jour->FindString("29", 0)>=0 ){
							box_jour->DeleteString(28);
					if (day==29) box_jour->SetText("28");
					}
	 }
	 else {
		 if (mois==1 && box_jour->FindString("29", 1)<0 ){
					box_jour->AddString("29");
			}

	 }
	 ModifResultat();

}
void TDialogPosition::Verif(){
	 int year,mois,day;

	 year=box_annee->GetSelIndex()+anneedebut;
	 day=box_jour->GetSelIndex()+1;
	 mois=box_mois->GetSelIndex();
	 if ( box_jour->FindString("29", 0)<0) box_jour->AddString("29");
	 if ( box_jour->FindString("30", 0)<0) box_jour->AddString("30");
	 // il y a au moins trente jours pour chaque mois
	 if (mois==0 || mois==2 || mois==4 || mois==6 || mois==7 || mois==9 || mois==11){
			// mois a 31 jour mais il manque le 31e jour
			if(box_jour->FindString("31", 0)<0) box_jour->AddString("31");
	 }
	 else{// autres mois sauf fevrier et il y a le 31e jour en trop
			if (mois!=1 && box_jour->FindString("31", 0)>=0 ){
					box_jour->DeleteString(30);
					if (day==31) box_jour->SetText("30");
			}
			else{   // mois de fevrier
				if (mois==1){
					  if ((year)%4!=0){ // annee non bissextile
							if (box_jour->FindString("31", 0)>=0) box_jour->DeleteString(30);
							if (box_jour->FindString("30", 0)>=0) box_jour->DeleteString(29);
							if (box_jour->FindString("29", 0)>=0) box_jour->DeleteString(28);
							if (day>28) box_jour->SetText("28");
					  }
					  else {  // annee bissextile
							if (box_jour->FindString("31", 0)>=0) box_jour->DeleteString(30);
							if (box_jour->FindString("30", 0)>=0) box_jour->DeleteString(29);
							if (day>28) box_jour->SetText("29");
					  }
				}
			}
	 }
}
void TDialogPosition::ModifMois(){
    Verif();
	 ModifResultat();
}
void TDialogPosition::ModifJour(){
	 ModifResultat();
}
void TDialogPosition::ModifHeure(){
	 ModifResultat();
}
void TDialogPosition::ModifObjet(){
	 ModifResultat();
}
void TDialogPosition::ModifResultat(){
// variables
	int obje;
	double declinaison,ascension,distance=0;
	double de1,de2,de3,as1,as2,as3;
	char dec1[10],dec2[10],dec3[10];
	char asc1[10], asc2[10], asc3[10];
   char dist[25];

  d->setannee(box_annee->GetSelIndex()+anneedebut);
  d->setmois(box_mois->GetSelIndex()+1);
  d->setjour(box_jour->GetSelIndex()+1);
  d->setheure(box_heure->GetSelIndex());

  d->miseajour();

obje=box_objet->GetSelIndex()-1;

 if (obje==-1){//etoile centrale
	 system->getsun()->calculposition(d);
 // chargement des donnes
		  declinaison=system->getsun()->getdeclinaison();
		  ascension=system->getsun()->getascensiondroite();
		  distance=system->getsun()->getdistancealamere();
 }
else{
// si objet=planete
 if (obje<system->getnbrplanete()){
 // calcul de la position
		 system->getplanete(obje)->calculposition(d,system->getsun());
 // chargement des donnes
		  declinaison=system->getplanete(obje)->getdeclinaison();//+system->getplanete(obje)->correcteur(system->getsun(),d)[1]+system->getplanete(obje)->correcteur(system->getsun(),d)[3];
		  ascension=system->getplanete(obje)->getascensiondroite();//+system->getplanete(obje)->correcteur(system->getsun(),d)[0]+system->getplanete(obje)->correcteur(system->getsun(),d)[2];
		  distance=system->getplanete(obje)->getdistancealamere();

 }
 else {  // c'est un satellite mais lequel?

		int plannbr=0,satel=0,curseur=system->getnbrplanete()-1;
		  while (obje!=curseur){
				if (satel>=system->getplanete(plannbr)->getnbrsatellite()) {
						satel=0;
						plannbr++;
				}
				else {satel++;curseur++;}
		  }
 // maintenant on sait lequel !
  // clacul de la position
		system->getplanete(plannbr)->getsatellite(satel-1)->calculposition(d,system->getsun());
  // chargement des donnes
		  declinaison=system->getplanete(plannbr)->getsatellite(satel-1)->getdeclinaison();
		  ascension=system->getplanete(plannbr)->getsatellite(satel-1)->getascensiondroite();
		  distance=system->getplanete(plannbr)->getsatellite(satel-1)->getdistancealamere();

	}
 }
 // maintenant on connait asc, dec et dist de l'objet

 // conversion en deg, min, sec

			if (declinaison>=0) de1=floor(declinaison);
			else de1=ceil(declinaison);
			declinaison=declinaison-de1;
			if(declinaison<0) declinaison=-declinaison;
			if (declinaison>=0) de2=floor(declinaison*60);
			else de2=ceil(declinaison*60);
			declinaison=declinaison-de2/60.00;
			if (declinaison>=0)de3=floor(declinaison*3600);
			else de3=ceil(declinaison*3600);

			if (ascension>=0) as1=floor(ascension/15);
			else as1=ceil(ascension/15);
			 ascension=ascension-(15*as1);
			if(ascension<0) ascension=-ascension;
			if (ascension>=0) as2=floor((ascension*60)/15);
			else as2=ceil((ascension*60)/15);
			 ascension=ascension-((15*as2)/60);
			if (ascension>=0) as3=floor((ascension*3600)/15);
			else as3=ceil((ascension*3600)/15);
			 if(as1<0) as1=as1+24;

		 // as1=ascension;as2=0;as3=0;
 // conversion en string
		 itoa(de1,dec1,10);
		 itoa(de2,dec2,10);
		 itoa(de3,dec3,10);
		 itoa(as1,asc1,10);
		 itoa(as2,asc2,10);
		 itoa(as3,asc3,10);

  // conversion distance en text


		  if(obje>=system->getnbrplanete()) sprintf(dist,"%3.2lf mUA",1000.*distance);
		  // lune
		  else sprintf(dist,"%3.4lf UA",distance);

 // affichage
		 edit_dec1->SetText(dec1);
		 edit_dec2->SetText(dec2);
		 edit_dec3->SetText(dec3);
		 edit_asc1->SetText(asc1);
		 edit_asc2->SetText(asc2);
		 edit_asc3->SetText(asc3);
		 edit_distance->SetText(dist);

}


DEFINE_RESPONSE_TABLE1( TDialogPosition, TDialog )
  EV_WM_PAINT,

  EV_COMMAND( IDC_OK, Fin ),
  EV_COMMAND( IDC_CANCEL, Fin2 ),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_ANNEE,ModifAnnee),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_MOIS,ModifMois),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_JOUR,ModifJour),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_HEURE,ModifHeure),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_OBJET,ModifObjet),

END_RESPONSE_TABLE;


