#include "satsat.h"
#include "horaire.h"
#include <owl\dc.h>

const int nbr=6;//et pas 8 car japet est non corrige dc faux   ni hyperion : trop petit

//position des satellites de saturne
void satsat(date2* datum3,systeme *sys,bool Actualiser)
{
//datum3->antimiseajour();

//Calcul a partir des donnes de Xephem_3.0

//les satellites sont 8
//I Mimas, II Enceclade,III Tethys ,IV Dion, V Rhea,VI Titan, VII
//Hyperion, VIII Japet
//Attention correction pour Thetis,orbite hors plan equatorial pour
//Japet
//epoque : 31 dec 1979 0:0:0 UT
//en deg et deg jour

if(Actualiser==true){
//initialisation des donnes satellites
//de 0  8 arg a l'epoque
sys->tabjupi[0]=18.2919;
sys->tabjupi[1]=174.2135;
sys->tabjupi[2]=172.8546;
sys->tabjupi[3]=76.8438;
sys->tabjupi[4]=37.2555;
sys->tabjupi[5]=57.7005;
sys->tabjupi[6]=266.6977;
sys->tabjupi[7]=195.3513;

//de 9  15 vitesse angulaire
sys->tabjupi[8]=381.960878;
sys->tabjupi[9]=262.702179;
sys->tabjupi[10]=190.6686144;
sys->tabjupi[11]=131.505802;
sys->tabjupi[12]=79.6607672;
sys->tabjupi[13]=22.54663941;
sys->tabjupi[14]=16.88756168;
sys->tabjupi[15]=4.504559706;

//de 16  23 magnitude
sys->tabjupi[16]=13.0;
sys->tabjupi[17]=11.8;
sys->tabjupi[18]=10.3;
sys->tabjupi[19]=10.2;
sys->tabjupi[20]=9.8;
sys->tabjupi[21]=8.4;
sys->tabjupi[22]=14.3;
sys->tabjupi[23]=11.2;

//les rayons vecteurs enfin en diametres equatoriaux de saturne
sys->tabjupi[24]=1.5382;
sys->tabjupi[25]=1.97331;
sys->tabjupi[26]=2.4424;
sys->tabjupi[27]=3.12862;
sys->tabjupi[28]=4.3693;
sys->tabjupi[29]=10.12431;
sys->tabjupi[30]=12.29073;
sys->tabjupi[31]=29.50522;

//les rayons equatoriaux des satellites en km (pour sat r=120660km)
sys->tabjupi[32]=390.0;
sys->tabjupi[33]=510.0;
sys->tabjupi[34]=1050.0;
sys->tabjupi[35]=1120.0;
sys->tabjupi[36]=1530.0;
sys->tabjupi[37]=5150;
sys->tabjupi[38]=300;//aucun sens  : non spherique!!!
sys->tabjupi[39]=1440;

}
//mes variables
int i;
double d,r,corr,t;
t=datum3->getsieclejulien();
sys->sun->calculposition(datum3);
sys->getplanete(5)->calculposition(datum3,sys->sun);
r=sys->getplanete(5)->getdeclinaison();
d=(t*36525.0)-29218.5;//je passe de l'epoque.5/1/1900  1/1/1980

//calcul de la correction
corr=0;

//calcul de u
for(i=0;i<nbr;i++)
{sys->tabjupi[40+i]=mespr(sys->tabjupi[i]+sys->tabjupi[8+i]*(d-(r/173.83))+corr);}

//calcul de x
for(i=0;i<nbr;i++)
{sys->tabjupi[48+i]=sys->tabjupi[24+i]*sin(dr(sys->tabjupi[40+i]));}

//calcul de y
for(i=0;i<nbr;i++)
{sys->tabjupi[56+i]=sys->tabjupi[24+i]*cos(dr(sys->tabjupi[40+i]));}


}//fin de fonction


/*
 *  RINGS OF SATURN from xephem by Elwood Charles Downey.
 *  Adapted to Spica by Guillaume RICHARD :--))
*/

void ring_tilt (date2 * datum,systeme *sys,Vecteur &VecZ, double &Angle)

{

//mes declarations
double TVA,PVA,PVC,TVC,DECL,RA,DOT1,INC,pp;//,angledeg;
sys->calculposition(datum);
DECL = sys->getplanete(5)->getdeclinaison();
RA	  = sys->getplanete(5)->getascensiondroite();
pp= 3.141592;

	  /*  **************** FIND INCLINATION OF RINGS ************************* */
	  /*  Use dot product of Earth-Saturn vector and Saturn's rotation axis */
	  TVA = dr(90 - 83.51) ; /*  Theta coordinate of Saturn's axis */
	  PVA = dr(40.27) ; /*  Phi coordinate of Saturn's axis */
	  TVC = (pp / 2) - dr(DECL);
     PVC = dr(RA);
	  DOT1 = sin(TVA) * cos(PVA) * sin(TVC) * cos(PVC);
	  DOT1 = DOT1 + sin(TVA) * sin(PVA) * sin(TVC) * sin(PVC);
	  DOT1 = DOT1 + cos(TVA) * cos(TVC);
	  INC = atan(sqrt(1 - DOT1 * DOT1) / DOT1); /*    ArcCOS */
	  if (INC > 0) INC = (pp / 2) - INC;
	  else INC = -(pp / 2) - INC;
	  //angledeg=rd(INC);
	  Angle=INC;

 VecZ.X=0;
 VecZ.Y=0;
 VecZ.Z=1;
}




//-----------------------------------------------------
void satsat_affiche(date2*d,date2*datum,systeme *sys,TMemoryDC &memdc,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint,bool NB,bool Actualiser){
   
	double pas=24.; //pas de calcul en heure


//sys: pointeur sur le systeme
	if (PPrint==false){memdc.SelectObject(pinceau[0]);memdc.SelectObject(crayon[0]);}
	else {memdc.SelectObject(pinceau[1]);memdc.SelectObject(crayon[1]);}
	if (PPrint==false) memdc.SetTextColor(RGB(120,120,200));
	else memdc.SetTextColor(RGB(0,0,0));
	memdc.SetBkColor(RGB(0,0,70));

int x=0,t,i; // x=abscisse des points, t,i,j,k pour les boucles for

// caractristiques fenetre
int centre=sys->ScrW()/4,ecart=sys->ScrW()/5;// pour l'affichage:coordonnee du centre + 1/2largeur
int hauteurh=130;
int hauteurb=sys->ScrH()-28;

int antex[8];
for(i=0;i<nbr;i++) antex[i]=centre;


date2*datum2;
datum2=new date2();


//definition d'un carre sur lequel est affiche les planetes
if (PPrint==false) memdc.SelectObject(crayon[2]);   //rouge
else memdc.SelectObject(crayon[0]);
	if (PPrint==false)memdc.SelectObject(pinceau[3]); //noir
	else memdc.SelectObject(pinceau[1]);                    //blanc

memdc.Rectangle(4,hauteurh-20,centre*2-4,hauteurh+1);  //suprieur
memdc.Rectangle(4,hauteurb-1,centre*2-4,hauteurb+20);  //infrieur



// date de debut
//datum2->setsieclejulien(d->getsieclejulien());
// calcul du pas en heure
pas=(datum->getsieclejulien()-d->getsieclejulien())/((float)(hauteurb-hauteurh));// 876600.0/490;
//datum2->setsieclejulien(d->getsieclejulien()+0.000715469);
//-------------------------------------
//				copie l'ecran pour gagner du temps en cas d'animation
	memdc.Rectangle(4,hauteurh,centre*2-4,hauteurb);  //central
	// dessin du centre
		if (NB==false) memdc.SelectObject(crayon[6]);   //jaune
		else memdc.SelectObject(crayon[0]);
		memdc.MoveTo(centre,hauteurh+1);
		memdc.LineTo(centre,hauteurb-1);
		memdc.MoveTo(centre+1,hauteurh+1);
		memdc.LineTo(centre+1,hauteurb-1);
	 // redessine tout

// boucle sur l'ordonnee de l'affichage
for(t=hauteurh+1;t<hauteurb-1;t++){
  // mise a jour de la date
 // datum2->ajoutheure(pas);
  //datum2->antimiseajour();
  datum2->setsieclejulien(d->getsieclejulien()+pas*(double)(t-hauteurh-1));


  satsat(datum2,sys,Actualiser);

  // x du centre
  // boucle sur les planetes
  for(i=0;i<nbr;i++){
		//calcul abscisse d'affichage
		x=centre+(sys->tabjupi[48+i])*ecart/(29.);
	//	x=100;


		// couleurs
		if (i==0) memdc.SelectObject(crayon[13]);
		if (i==1) if (PPrint==false) memdc.SelectObject(crayon[1]); else memdc.SelectObject(crayon[3]);
		if (i==2) memdc.SelectObject(crayon[7]);     //orange
		if (i==3) memdc.SelectObject(crayon[2]);     // rouge
		if (i==4) memdc.SelectObject(crayon[4]);     //bleu
		if (i==5) memdc.SelectObject(crayon[8]);     // rose
		if (i==6) memdc.SelectObject(crayon[9]);         // vert
		if (i==7) memdc.SelectObject(crayon[10]);       //bleu clair
		if (NB==true) memdc.SelectObject(crayon[0]);   //noir

		// gere les retour a la ligne
		//if (x<(centre-ecart+30) && antex[i]>(centre+ecart-30)) antex[i]=centre-ecart;
		//if (x>(centre+ecart-30) && antex[i]<(centre-ecart+30)) antex[i]=centre+ecart;
		//dessin
		memdc.MoveTo(antex[i],t-1);
		memdc.LineTo(x,t);
		antex[i]=x;
		} // for nbr
 } // for t

// redessine la ligne du cadre qui a t modifie
if (PPrint==false) memdc.SelectObject(crayon[2]);   //rouge
else memdc.SelectObject(crayon[0]);
memdc.MoveTo(4,hauteurh);
memdc.LineTo(centre*2-5,hauteurh);

datum2->~date2();

//--------
// legende
	SetBkMode(memdc,TRANSPARENT);
	memdc.SetTextColor(RGB(0,0,0));
	// legende
	TextOut(memdc,sys->ScrL()+80,5,"LEGENDE",strlen("LEGENDE"));

	if (PPrint==false) memdc.SetTextColor(RGB(200,200,200));
	else memdc.SetTextColor(RGB(0,0,0));
	//TextOut(memdc,6,sys->ScrH()/2,"OUEST",5);
	//TextOut(memdc,sys->ScrL()-55,sys->ScrH()/2,"EST",3);
	if (PPrint==false) memdc.SetTextColor(RGB(0,0,0));
	else memdc.SetTextColor(RGB(0,0,0));
	// affiche nom des planetes avec ligne de la couleur correspondante devant
	for(i=0;i<nbr;i++){
		if (NB==true) memdc.SelectObject(crayon[0]);   //noir
		if (i==0){
			memdc.SelectObject(crayon[13]);
			TextOut(memdc,sys->ScrL()+30,18,"Mimas",5);
			memdc.MoveTo(sys->ScrL()+10,23);
			memdc.LineTo(sys->ScrL()+25,23);
		}
		if (i==1){
			if (PPrint==false)memdc.SelectObject(crayon[1]);
				else memdc.SelectObject(crayon[3]);
			TextOut(memdc,sys->ScrL()+30,29,"Encelade",8);
			memdc.MoveTo(sys->ScrL()+10,34);
			memdc.LineTo(sys->ScrL()+25,34);
		}
		if (i==2){
			memdc.SelectObject(crayon[7]);
			TextOut(memdc,sys->ScrL()+120,18,"Thethys",7);
			memdc.MoveTo(sys->ScrL()+100,23);
			memdc.LineTo(sys->ScrL()+115,23);
		}
		if (i==3){
			memdc.SelectObject(crayon[2]);
			TextOut(memdc,sys->ScrL()+120,29,"Dion",5);
			memdc.MoveTo(sys->ScrL()+100,34);
			memdc.LineTo(sys->ScrL()+115,34);
		}
		if (i==4){
			memdc.SelectObject(crayon[4]);
			TextOut(memdc,sys->ScrL()+30,40,"Rhea",4);
			memdc.MoveTo(sys->ScrL()+10,45);
			memdc.LineTo(sys->ScrL()+25,45);
		}
		if (i==5){
			memdc.SelectObject(crayon[8]);
			TextOut(memdc,sys->ScrL()+120,40,"Titan",5);
			memdc.MoveTo(sys->ScrL()+100,45);
			memdc.LineTo(sys->ScrL()+115,45);
		}
		if (i==6){
			memdc.SelectObject(crayon[9]);
			TextOut(memdc,sys->ScrL()+30,51,"Hyperion",8);
			memdc.MoveTo(sys->ScrL()+10,56);
			memdc.LineTo(sys->ScrL()+25,56);
		}
		if (i==7){
			memdc.SelectObject(crayon[10]);
			TextOut(memdc,sys->ScrL()+120,51,"Japet",5);
			memdc.MoveTo(sys->ScrL()+100,56);
			memdc.LineTo(sys->ScrL()+115,56);
		}

	}  //for i
	// affichage heure et minute
	char txt[30];
	char txt1[30];
	datum->date4(txt1);
	sprintf(txt,"Heure GMT : %s",txt1 );
	memdc.TextOut(sys->ScrL()+20,51,txt,strlen(txt));
	date4l(datum,txt1);
	sprintf(txt,"Heure Locale : %s",txt1);
	memdc.TextOut(sys->ScrL()+20,62,txt,strlen(txt));

	if (PPrint==false)memdc.SelectObject(crayon[3]); //noir
	else memdc.SelectObject(crayon[1]);                    //blanc
	memdc.MoveTo(6,hauteurh+1);
	memdc.LineTo(centre*2-6,hauteurh+1);
	SetBkMode(memdc,OPAQUE);
// fin legende

//debut cadre supe et inferieur
	// date de debut, date de fin
	if (PPrint==true) {memdc.SetBkColor(RGB(255,255,255));memdc.SetTextColor(RGB(0,0,0));}
	else {memdc.SetBkColor(RGB(0,0,0));memdc.SetTextColor(RGB(200,200,200));}
	SetBkMode(memdc,OPAQUE);

	SetBkMode(memdc,OPAQUE);
	TextOut(memdc,6,31,"-180",5);
TextOut(memdc,centre*2-40,31,"+180",5);
sprintf(txt,"%d/%d/%d %dh  ",d->getjour(),d->getmois(),d->getannee(),d->getheure());
	TextOut(memdc,centre-37,hauteurh-17,txt,strlen(txt));
sprintf(txt,"%d/%d/%d %dh  ",datum->getjour(),datum->getmois(),datum->getannee(),datum->getheure());
	TextOut(memdc,centre-37,hauteurb+2,txt,strlen(txt));



}

void satsat_affichercoordonnee(date2*d,date2*datum,int y,TMemoryDC &memdc,systeme *sys){

	if (abs(sys->ScrH()-158)>3){
	memdc.SetBkColor(RGB(200,200,200));
	SetBkMode(memdc,OPAQUE);
	memdc.SetTextColor(RGB(0,0,0));
		char txt[50];
	date2 *dd;
	dd=new date2();
	dd->setsieclejulien(d->getsieclejulien()+((double)(y-130)*(datum->getsieclejulien()-d->getsieclejulien())/((double)sys->ScrH()-158.)));
	dd->antimiseajour();

	sprintf(txt,"Date pointe : %d/%d/%d %dh     ",dd->getjour(),dd->getmois(),dd->getannee(),dd->getheure());
	TextOut(memdc,sys->ScrL()+30,85,txt,strlen(txt));
	dd->~date2();
	SetBkMode(memdc,TRANSPARENT);
	}

}


//-----------------------------------------------------
//   vu de la terre
void satsat_affiche2(date2 *d,systeme *sys,TMemoryDC &memdc,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint,bool NB){

//sys: pointeur sur le systeme
	if (PPrint==false){memdc.SelectObject(pinceau[0]);memdc.SelectObject(crayon[0]);}
	else {memdc.SelectObject(pinceau[1]);memdc.SelectObject(crayon[1]);}
	if (PPrint==false) memdc.SetTextColor(RGB(120,120,200));
	else memdc.SetTextColor(RGB(0,0,0));
	memdc.SetBkColor(RGB(0,0,70));

int x,y,i,z; // x=abscisse des points, t,i,j,k pour les boucles for
int centre=sys->ScrW()/4,ecart=sys->ScrW()/5;// pour l'affichage:coordonnee du centre + 1/2largeur
int hauteur=65;

//definition d'un carre sur lequel est affiche les planetes
if (PPrint==false) memdc.SelectObject(crayon[2]);   //rouge
else memdc.SelectObject(crayon[0]);
	if (PPrint==false)memdc.SelectObject(pinceau[3]); //noir
	else memdc.SelectObject(pinceau[1]);                    //blanc
memdc.Rectangle(4,30,sys->ScrW()/2-4,30+2*(hauteur-30));

// dessin de jupiter
		if (NB==false){ memdc.SelectObject(crayon[6]);   //jaune
			memdc.SelectObject(pinceau[6]);}   //jaune
		else {memdc.SelectObject(crayon[0]); memdc.SelectObject(pinceau[1]);}   //jaune
			memdc.Ellipse(centre-0.5*(float)ecart/30.,(hauteur)-0.5*(float)ecart/30.,centre+0.5*(float)ecart/27.,(hauteur)+0.5*(float)ecart/27.);



//	 satsat(d,sys);

  // boucle sur les planetes
  for(i=0;i<nbr;i++){
		//calcul abscisse d'affichage
		x=centre+(sys->tabjupi[48+i])*ecart/(30.);
		y=(hauteur)+(0)*ecart/(30.);
		z=(sys->tabjupi[40+i]);   //u
	//	x=100;y=100;z=100;
		// couleurs
		 if (i==0) memdc.SelectObject(crayon[13]);
			if (i==1) if(PPrint==false) memdc.SelectObject(crayon[1]); else memdc.SelectObject(crayon[3]);
		if (i==2) memdc.SelectObject(crayon[7]);     //orange
		if (i==3) memdc.SelectObject(crayon[2]);     // rouge
		if (i==4) memdc.SelectObject(crayon[4]);     //bleu
		if (i==5) memdc.SelectObject(crayon[8]);     // rose
		if (i==6) memdc.SelectObject(crayon[9]);         // vert
		if (i==7) memdc.SelectObject(crayon[10]);       //bleu clair
		if (NB==true) {memdc.SelectObject(crayon[0]);memdc.SelectObject(pinceau[0]);}   //noir

		// gere les retour a la ligne
		//if (x<(centre-ecart+30) && antex[i]>(centre+ecart-30)) antex[i]=centre-ecart;
		//if (x>(centre+ecart-30) && antex[i]<(centre-ecart+30)) antex[i]=centre+ecart;
		//dessin
		if (abs(x-centre)<ecart/(27.) && abs(y-hauteur)<ecart/(27.) && abs(z)<90){
		}
		else memdc.Ellipse(x-1,y-1,x+1,y+1);
		} // for nbr



}

// vu de dessus
//-----------------------------------------------------
void satsat_affiche3(date2 *d,systeme *sys,TMemoryDC &memdc,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint,bool NB){

//sys: pointeur sur le systeme
	if (PPrint==false){memdc.SelectObject(pinceau[0]);memdc.SelectObject(crayon[0]);}
	else {memdc.SelectObject(pinceau[1]);memdc.SelectObject(crayon[1]);}
	if (PPrint==false) memdc.SetTextColor(RGB(120,120,200));
	else memdc.SetTextColor(RGB(0,0,0));
	memdc.SetBkColor(RGB(0,0,70));

int x,y,i; // x=abscisse des points, t,i,j,k pour les boucles for
int centre=sys->ScrW()*3/4,ecart=(sys->ScrH()/2-30)/4;// pour l'affichage:coordonnee du centre + 1/2largeur


//definition d'un carre sur lequel est affiche les planetes
if (PPrint==false) memdc.SelectObject(crayon[2]);   //rouge
else memdc.SelectObject(crayon[0]);
	if (PPrint==false)memdc.SelectObject(pinceau[3]); //noir
	else memdc.SelectObject(pinceau[1]);                    //blanc
memdc.Rectangle(sys->ScrW()/2+5,110,sys->ScrW()-10,sys->ScrH()/2+30);

// dessin de jupiter
		if (NB==false){ memdc.SelectObject(crayon[6]);   //jaune
			memdc.SelectObject(pinceau[6]);}   //jaune
		else {memdc.SelectObject(crayon[0]); memdc.SelectObject(pinceau[1]);}   //jaune
			memdc.Ellipse(centre-0.5*(float)ecart/30.,(sys->ScrH()/4-15+60)-0.5*(float)ecart/30.,centre+0.5*(float)ecart/27.,(sys->ScrH()/4-15+60)+0.5*(float)ecart/27.);

  // calcul position des satellites
  //		satsat(d,sys);

  // boucle sur les planetes
  for(i=0;i<nbr;i++){
		//calcul abscisse d'affichage
		x=centre+(sys->tabjupi[48+i])*ecart/(30.);
		y=(sys->ScrH()/4-15+60)+(sys->tabjupi[56+i])*ecart/(30.);
 //	  x=100;y=100;
		// couleurs
	 if (i==0) memdc.SelectObject(crayon[13]);
		if (i==1) if(PPrint==false) memdc.SelectObject(crayon[1]); else memdc.SelectObject(crayon[3]);
		if (i==2) memdc.SelectObject(crayon[7]);     //orange
		if (i==3) memdc.SelectObject(crayon[2]);     // rouge
		if (i==4) memdc.SelectObject(crayon[4]);     //bleu
		if (i==5) memdc.SelectObject(crayon[8]);     // rose
		if (i==6) memdc.SelectObject(crayon[9]);         // vert
		if (i==7) memdc.SelectObject(crayon[10]);       //bleu clair
		if (NB==true) {memdc.SelectObject(crayon[0]);memdc.SelectObject(pinceau[0]);}   //noir

		// gere les retour a la ligne
		//if (x<(centre-ecart+30) && antex[i]>(centre+ecart-30)) antex[i]=centre-ecart;
		//if (x>(centre+ecart-30) && antex[i]<(centre-ecart+30)) antex[i]=centre+ecart;
		//dessin
		memdc.Ellipse(x-1,y-1,x+1,y+1);
		} // for nbr


}




///---------------------------------------
// affiche jupi + tache +ombre satellites
void satsat_affichetache(date2*d,systeme *sys,TMemoryDC &memdc ,TMemoryDC &memdc2,TBitmap *Jupi,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint,bool NB){

  satsat(d,sys,false);
	//definition d'un carre sur lequel est affiche les planetes
	if (PPrint==false) memdc.SelectObject(crayon[2]);   //rouge
		else memdc.SelectObject(crayon[0]);
	if (PPrint==false)memdc.SelectObject(pinceau[3]); //noir
		else memdc.SelectObject(pinceau[1]);                    //blanc
	memdc.Rectangle(sys->ScrW()/2+8,sys->ScrH()/2+45,sys->ScrW()-10,sys->ScrH()-10);
//sys: pointeur sur le systeme
// jaune ->6
//oraange ->7

	if (PPrint==false){memdc.SelectObject(pinceau[6]);memdc.SelectObject(crayon[0]);}
	else {memdc.SelectObject(pinceau[1]);memdc.SelectObject(crayon[0]);}
	if (PPrint==false) memdc.SetTextColor(RGB(120,120,200));
	else memdc.SetTextColor(RGB(0,0,0));
	memdc.SetBkColor(RGB(0,0,70));


// boucle sur l'ordonnee de l'affichage
//satsat(d,sys);
//  grs=sys->tabjupi[20];


float R=40*(float)sys->ScrH()/500.; //rayon jupi en pixel base 500 pixels de haut
//float H=-32*(float)sys->ScrH()/500.; // position de la tache rouge %  l'equateur
//float r=10*(float)sys->ScrH()/500.; // rayon de la tache

int X=sys->ScrW()*3/4;  // centre de la planete
int Y=sys->ScrH()*3/4+15; //   "

	int i,j;
// dessin planete
	if (NB==false){
		 TBitmap * Jupi2;
		 Jupi2=new TBitmap(*Jupi);
		 memdc2.SelectObject(*Jupi2);
		 memdc2.StretchBlt(0, 0, 2*R, 2*R,memdc2, 0, 0, 99, 86, SRCCOPY);
		 memdc.BitBlt(X-R,Y-R,2*R,2*R,memdc2,0,0, SRCCOPY);
	  //	 memdc2.RestoreBitmap();
		 Jupi2->~TBitmap();
       memdc2.RestoreBitmap();
		 // scan pour enlever blanc
		 if (PPrint==true){
			TColor koul;
			for(i=X-R;i<=X+R;i++){
				for(j=Y-R;j<=Y+R;j++){
				 koul=memdc.GetPixel(i,j);
				 if(koul.Blue()==0 && koul.Green()==0 &&koul.Red()==0) memdc.SetPixel(i,j,RGB(255,255,255));
				}
			}
		 }
		 if (PPrint==false){memdc.SelectObject(crayon[20]);}
		 else {memdc.SelectObject(crayon[3]);}
		 //anneaux
		 memdc.MoveTo(X-2.3*R,Y);
		 memdc.LineTo(X+2.3*R,Y);
	}/*
	if (NB==false){

		 if (PPrint==false){memdc.SelectObject(pinceau[6]);memdc.SelectObject(crayon[3]);}
		 else {memdc.SelectObject(pinceau[1]);memdc.SelectObject(crayon[3]);}
		 memdc.Ellipse(X-R,Y-R,X+R,Y+R);
		 if (PPrint==false){memdc.SelectObject(crayon[6]);}
		 else {memdc.SelectObject(crayon[3]);}
		 //anneaux
		 memdc.MoveTo(X-2.3*R,Y);
		 memdc.LineTo(X+2.3*R,Y);
	}
	*/
	else {
	if (PPrint==false){memdc.SelectObject(pinceau[6]);memdc.SelectObject(crayon[0]);}
	else {memdc.SelectObject(pinceau[1]);memdc.SelectObject(crayon[3]);}
			memdc.Ellipse(X-R,Y-R,X+R,Y+R);

			 //anneaux
          memdc.MoveTo(X-2.3*R,Y);
			 memdc.LineTo(X+2.3*R,Y);
	}
  int x,y,z;
 // dessin des satellites
	for(i=0;i<nbr;i++){
		//calcul abscisse d'affichage
		x=X+(sys->tabjupi[48+i])*2*R;
		z=Y+(0)*2*R;
		y=(sys->tabjupi[56+i]);   //u

		// couleurs
		if (i==0){ memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[13]);}
		if (i==1){ memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[1]);}
		if (i==2){ memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[7]);}     //orange
		if (i==3){ memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[2]);}     // rouge
		if (i==4){ memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[4]);}     //bleu
		if (i==5){ memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[8]);}     // rose
		if (i==6){ memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[9]);}         // vert
		if (i==7){ memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[10]);}       //bleu clair
		if (NB==true) {memdc.SelectObject(crayon[3]);memdc.SelectObject(pinceau[3]);}   //noir
		//dessin
		if ((abs(x-X)<R && abs(z-Y)<R && y>0) || x<sys->ScrW()/2.+9 || x>sys->ScrW()-12 || z<sys->ScrH()/2+46 || z>sys->ScrH()-12){
		}
		  else memdc.Ellipse(x-3,z-3,x+3,z+3);
		  if(y>0 && abs(x-X)<2.3*R && abs(x-X)>R){
		  if (PPrint==false){memdc.SelectObject(crayon[20]);}
		 else {memdc.SelectObject(crayon[3]);}
		 //anneaux
		 memdc.MoveTo(x-3,z);
		 memdc.LineTo(x+3,z);
		 }
	} // for nbr
  
}