#include "saturn3d.h"
#include "horaire.h"
#include "spherpro.h"
// por saturne

/*
struct Trapeze{
  Vecteur Pt[4];
  BPoint Pt2[4];
  int Couleur;
  int Distance;
};
*/
const int nbrsat=6;
const float R2=0.4;			// rayon de la planete

void saturne3d(systeme *sys,TMemoryDC * memdc2, Plan P,int k,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint, bool NB ){

int nbrx,nbry,nbrr; // nbr de points pour anneaux et planete
double distance[200];
Trapeze Data;
int i,jj,aa,kk,kkk,ab,ac,j,l;
Vecteur Centre;
float zoom;
if (k>=1) zoom=k;
	else zoom=sqrt(1./(2.-(float)k));
double Zoom=100.*zoom;
int TabOrdre[200];
double x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4;

// dessin du fond
	if (PPrint==false){ memdc2->SelectObject (crayon[2]); memdc2->SelectObject (pinceau[3]);}
		else { memdc2->SelectObject(crayon[0]); memdc2->SelectObject(pinceau[1]);}
	memdc2->Rectangle(5,45,sys->ScrW()-5,sys->ScrH()-5);




// lecture fichier et calcul des distances
	FILE * Source=fopen("Sat3d.spi","rt");
	fscanf(Source,"%d %d %d\n",&nbrx,&nbry,&nbrr);
	kk=0;
	// lecture planete
	for(i=0;i<nbrx;i++){
		for(j=0;j<nbry;j++){
			  fscanf(Source,"%lf %lf %lf/%lf %lf %lf/%lf %lf %lf/%lf %lf %lf\n",&x1,&y1,&z1,&x2,&y2,&z2,&x3,&y3,&z3,&x4,&y4,&z4);
			  Centre.X=(x1+x2+x3+x4)/4.;
			  Centre.Y=(y1+y2+y3+y4)/4.;
			  Centre.Z=(z1+z2+z3+z4)/4.;
			  distance[kk++]=Norme(Soustraction(P.Centre,Centre));
		}
	}
	fscanf(Source,"\n");
	// lecture anneaux
	for(i=0;i<nbrr;i++){
			  // anneau interieur
			  fscanf(Source,"%lf %lf/%lf %lf/%lf %lf/%lf %lf -",&x1,&y1,&x2,&y2,&x3,&y3,&x4,&y4);
			  Centre.X=(x1+x2+x3+x4)/4.;
			  Centre.Y=(y1+y2+y3+y4)/4.;
			  Centre.Z=0;
			  distance[kk++]=Norme(Soustraction(P.Centre,Centre));
			  // anneau extrieur
			  fscanf(Source," %lf %lf/%lf %lf/%lf %lf/%lf %lf\n",&x1,&y1,&x2,&y2,&x3,&y3,&x4,&y4);
			  Centre.X=(x1+x2+x3+x4)/4.;
			  Centre.Y=(y1+y2+y3+y4)/4.;
			  Centre.Z=0;
			  distance[kk++]=Norme(Soustraction(P.Centre,Centre));

	}
	rewind(Source); //retourne au dbut du fichier
	// ordonner les trapezes
  TabOrdre[0]=0;
  for(i=1;i<kk;i++){
	  TabOrdre[i]=i;
	  for(l=0;l<i;l++){
		if (distance[i]>distance[TabOrdre[l]]){
			for(j=i;j>l;j--)TabOrdre[j]=TabOrdre[j-1];
			TabOrdre[l]=i;
			l=i;
		}
	  }
  }
	// afficher les trapezes
	l=0;
	while (l<kk){
		fscanf(Source,"%d %d %d\n",&aa,&ab,&ac);
		kkk=0;
		// lecture planete
		for(i=0;i<nbrx;i++){
			for(j=0;j<nbry;j++){
			  fscanf(Source,"%lf %lf %lf/%lf %lf %lf/%lf %lf %lf/%lf %lf %lf\n",&x1,&y1,&z1,&x2,&y2,&z2,&x3,&y3,&z3,&x4,&y4,&z4);
			  if(kkk++==TabOrdre[l]){

				 Data.Pt[0].X=x1; Data.Pt[1].X=x2; Data.Pt[2].X=x3; Data.Pt[3].X=x4;
				 Data.Pt[0].Y=y1; Data.Pt[1].Y=y2; Data.Pt[2].Y=y3; Data.Pt[3].Y=y4;
				 Data.Pt[0].Z=z1; Data.Pt[1].Z=z2; Data.Pt[2].Z=z3; Data.Pt[3].Z=z4;
				 //calcul 2d

				 for(jj=0;jj<4;jj++)
					Data.Pt2[jj]=InterPlan2(Data.Pt[jj],P);
				 // dessin

				 DrawTrapeze(Data,7,Zoom,sys,memdc2, pinceau,crayon,PPrint, NB);
             
             l++;
			  }  // if kkk++
			}  // for i
		} // for j
		fscanf(Source,"\n");
		// lecture anneaux
		for(i=0;i<nbrr;i++){
			  // anneau interieur
			  fscanf(Source,"%lf %lf/%lf %lf/%lf %lf/%lf %lf -",&x1,&y1,&x2,&y2,&x3,&y3,&x4,&y4);
			  if(kkk++==TabOrdre[l]){

				 Data.Pt[0].X=x1; Data.Pt[1].X=x2; Data.Pt[2].X=x3; Data.Pt[3].X=x4;
				 Data.Pt[0].Y=y1; Data.Pt[1].Y=y2; Data.Pt[2].Y=y3; Data.Pt[3].Y=y4;
				 Data.Pt[0].Z=0; Data.Pt[1].Z=0; Data.Pt[2].Z=0; Data.Pt[3].Z=0;
				 //calcul 2d
				 for(jj=0;jj<4;jj++)
					Data.Pt2[jj]=InterPlan2(Data.Pt[jj],P);
				 // dessin
				 DrawTrapeze(Data,7,Zoom,sys,memdc2, pinceau,crayon,PPrint, NB);

				 l++;

			  }  // if kkk++
			  // anneau extrieur
			  fscanf(Source," %lf %lf/%lf %lf/%lf %lf/%lf %lf\n",&x1,&y1,&x2,&y2,&x3,&y3,&x4,&y4);
			  if(kkk++==TabOrdre[l]){

				 Data.Pt[0].X=x1; Data.Pt[1].X=x2; Data.Pt[2].X=x3; Data.Pt[3].X=x4;
				 Data.Pt[0].Y=y1; Data.Pt[1].Y=y2; Data.Pt[2].Y=y3; Data.Pt[3].Y=y4;
				 Data.Pt[0].Z=0; Data.Pt[1].Z=0; Data.Pt[2].Z=0; Data.Pt[3].Z=0;
				 //calcul 2d
				 for(jj=0;jj<4;jj++)
					Data.Pt2[jj]=InterPlan2(Data.Pt[jj],P);

					 // dessin
				 DrawTrapeze(Data,7,Zoom,sys,memdc2, pinceau,crayon,PPrint, NB);

             l++;
			  }  // if kkk++

		}
	rewind(Source); //retourne au dbut du fichier
	}  // while l

	fclose (Source);

}  // end of function


// ne recalcule pas la planete -> va au moins 5 fois plus vite
void quicksaturne3d(date2* datum,systeme *sys,TMemoryDC * memdc2, Plan P,int k,HBRUSH pinceau[40],HPEN crayon[40],bool PPrint, bool NB ,bool Actualiser){

int nbrr; // nbr de points pour anneaux et planete
double distance,distancecentre,R;
Trapeze Data;
int i,aa,jj;
Vecteur Centre;
float zoom;
if (k>=1) zoom=k;
	else zoom=sqrt(1./(2.-(float)k));
double Zoom=100.*zoom;
//Zoom=50.;
double x1,y1,x2,y2,x3,y3,x4,y4;

// dessin du fond
	if (PPrint==false){ memdc2->SelectObject (crayon[2]); memdc2->SelectObject (pinceau[3]);}
		else { memdc2->SelectObject(crayon[0]); memdc2->SelectObject(pinceau[1]);}
	memdc2->Rectangle(5,45,sys->ScrW()-5,sys->ScrH()-5);

    satsat3dsatelites(datum,sys,memdc2, P,k,pinceau,crayon,PPrint,NB,0,Actualiser);



// lecture fichier et calcul des distances
	FILE * Source=fopen("anneau3d.spi","rt");
	fscanf(Source,"%d %lf\n",&nbrr,&R);
	Centre.X=0;
	Centre.Y=0;
	Centre.Z=0;
	distancecentre=Norme(Soustraction(P.Centre,Centre));

   double R3;
   // calcul du rayon:

	 Data.Pt[0].X=R*P.Dir1.X;
    Data.Pt[0].Y=R*P.Dir1.Y;
    Data.Pt[0].Z=R*P.Dir1.Z;
    //calcul 2d
    Data.Pt2[0]=InterPlan2(Data.Pt[0],P);
    R3=Data.Pt2[0].X/10.*Data.Pt2[0].X/10.+Data.Pt2[0].Y/10.*Data.Pt2[0].Y/10.;
    R3=10.*sqrt(R3);

	// afficher les trapezes qui sont derrieres la planete

		// lecture anneaux
		for(i=0;i<nbrr;i++){
      		// anneau interieur C
			  fscanf(Source,"%lf %lf/%lf %lf/%lf %lf/%lf %lf -",&x1,&y1,&x2,&y2,&x3,&y3,&x4,&y4);
			  Centre.X=(x1+x2+x3+x4)/4.;
			  Centre.Y=(y1+y2+y3+y4)/4.;
			  Centre.Z=0;
			  distance=Norme(Soustraction(P.Centre,Centre));
			  if(distance>=distancecentre){

				 Data.Pt[0].X=x1; Data.Pt[1].X=x2; Data.Pt[2].X=x3; Data.Pt[3].X=x4;
				 Data.Pt[0].Y=y1; Data.Pt[1].Y=y2; Data.Pt[2].Y=y3; Data.Pt[3].Y=y4;
				 Data.Pt[0].Z=0; Data.Pt[1].Z=0; Data.Pt[2].Z=0; Data.Pt[3].Z=0;
				 //calcul 2d
				 for(jj=0;jj<4;jj++)
					Data.Pt2[jj]=InterPlan2(Data.Pt[jj],P);
				 // dessin
				 DrawTrapeze(Data,32,Zoom,sys,memdc2, pinceau,crayon,PPrint, NB);
			  }  // if distance

			  // anneau interieur B
			  fscanf(Source," %lf %lf/%lf %lf/%lf %lf/%lf %lf -",&x1,&y1,&x2,&y2,&x3,&y3,&x4,&y4);
			  Centre.X=(x1+x2+x3+x4)/4.;
			  Centre.Y=(y1+y2+y3+y4)/4.;
			  Centre.Z=0;
			  distance=Norme(Soustraction(P.Centre,Centre));
			  if(distance>=distancecentre){

				 Data.Pt[0].X=x1; Data.Pt[1].X=x2; Data.Pt[2].X=x3; Data.Pt[3].X=x4;
				 Data.Pt[0].Y=y1; Data.Pt[1].Y=y2; Data.Pt[2].Y=y3; Data.Pt[3].Y=y4;
				 Data.Pt[0].Z=0; Data.Pt[1].Z=0; Data.Pt[2].Z=0; Data.Pt[3].Z=0;
				 //calcul 2d
				 for(jj=0;jj<4;jj++)
					Data.Pt2[jj]=InterPlan2(Data.Pt[jj],P);
				 // dessin
				 DrawTrapeze(Data,30,Zoom,sys,memdc2, pinceau,crayon,PPrint, NB);
			  }  // if distance

			  // anneau extrieur   A

			  fscanf(Source," %lf %lf/%lf %lf/%lf %lf/%lf %lf\n",&x1,&y1,&x2,&y2,&x3,&y3,&x4,&y4);
			  Centre.X=(x1+x2+x3+x4)/4.;
			  Centre.Y=(y1+y2+y3+y4)/4.;
			  Centre.Z=0;
			  distance=Norme(Soustraction(P.Centre,Centre));
			  if(distance>=distancecentre){

				 Data.Pt[0].X=x1; Data.Pt[1].X=x2; Data.Pt[2].X=x3; Data.Pt[3].X=x4;
				 Data.Pt[0].Y=y1; Data.Pt[1].Y=y2; Data.Pt[2].Y=y3; Data.Pt[3].Y=y4;
				 Data.Pt[0].Z=0; Data.Pt[1].Z=0; Data.Pt[2].Z=0; Data.Pt[3].Z=0;
				 //calcul 2d
				 for(jj=0;jj<4;jj++)
					Data.Pt2[jj]=InterPlan2(Data.Pt[jj],P);
				 // dessin
				 DrawTrapeze(Data,31,Zoom,sys,memdc2, pinceau,crayon,PPrint, NB);
			  }  // if distance

		}  // for i<nbrr
	rewind(Source); //retourne au dbut du fichier

	//-------------------------
	// aficher la planete
	if( NB==FALSE) {
		memdc2->SelectObject(pinceau[7]);
		memdc2->SelectObject(crayon[7]);
	}
	else {
		memdc2->SelectObject(pinceau[1]);
		memdc2->SelectObject(crayon[3]);
	}
	x1=(int)(-R3*Zoom+sys->ScrW()/2.);
	y1=45+(int)((sys->ScrH()-50.)/2.-R3*Zoom);
	x2=(int)(+R3*Zoom+sys->ScrW()/2.);
	y2=45+(int)((sys->ScrH()-50.)/2.+R3*Zoom);

   int deb;
   // en fonction de l'inclinason commence plu haut ou plus bas dans le fichie
   deb=(int)((float)(13.+(25.*(P.Centre.Z/distancecentre))));
   CollerFichierSurEllipse(memdc2,"saturne.spi",(x2-x1)/2,(x2-x1)/2,(x1+x2)/2,(y1+y2)/2, 25, deb);

//	Ellipse(*memdc2,x1,y1,x2,y2);

   // afficher les trapezes qui sont derrieres la planete
		fscanf(Source,"%d %lf\n",&aa,&R);
		// lecture anneaux
		for(i=0;i<nbrr;i++){
      		fscanf(Source,"%lf %lf/%lf %lf/%lf %lf/%lf %lf -",&x1,&y1,&x2,&y2,&x3,&y3,&x4,&y4);
			  Centre.X=(x1+x2+x3+x4)/4.;
			  Centre.Y=(y1+y2+y3+y4)/4.;
			  Centre.Z=0;
			  distance=Norme(Soustraction(P.Centre,Centre));
			  if(distance<distancecentre){

				 Data.Pt[0].X=x1; Data.Pt[1].X=x2; Data.Pt[2].X=x3; Data.Pt[3].X=x4;
				 Data.Pt[0].Y=y1; Data.Pt[1].Y=y2; Data.Pt[2].Y=y3; Data.Pt[3].Y=y4;
				 Data.Pt[0].Z=0; Data.Pt[1].Z=0; Data.Pt[2].Z=0; Data.Pt[3].Z=0;
				 //calcul 2d
				 for(jj=0;jj<4;jj++)
					Data.Pt2[jj]=InterPlan2(Data.Pt[jj],P);
				 // dessin
				 DrawTrapeze(Data,32,Zoom,sys,memdc2, pinceau,crayon,PPrint, NB);
			  }  // if distance

			  // anneau interieur
			  fscanf(Source," %lf %lf/%lf %lf/%lf %lf/%lf %lf -",&x1,&y1,&x2,&y2,&x3,&y3,&x4,&y4);
			  Centre.X=(x1+x2+x3+x4)/4.;
			  Centre.Y=(y1+y2+y3+y4)/4.;
			  Centre.Z=0;
			  distance=Norme(Soustraction(P.Centre,Centre));
			  if(distance<distancecentre){

				 Data.Pt[0].X=x1; Data.Pt[1].X=x2; Data.Pt[2].X=x3; Data.Pt[3].X=x4;
				 Data.Pt[0].Y=y1; Data.Pt[1].Y=y2; Data.Pt[2].Y=y3; Data.Pt[3].Y=y4;
				 Data.Pt[0].Z=0; Data.Pt[1].Z=0; Data.Pt[2].Z=0; Data.Pt[3].Z=0;
				 //calcul 2d
				 for(jj=0;jj<4;jj++)
					Data.Pt2[jj]=InterPlan2(Data.Pt[jj],P);
				 // dessin
				 DrawTrapeze(Data,30,Zoom,sys,memdc2, pinceau,crayon,PPrint, NB);
			  }  // if distance

			  // anneau extrieur

			  fscanf(Source," %lf %lf/%lf %lf/%lf %lf/%lf %lf\n",&x1,&y1,&x2,&y2,&x3,&y3,&x4,&y4);
			  Centre.X=(x1+x2+x3+x4)/4.;
			  Centre.Y=(y1+y2+y3+y4)/4.;
			  Centre.Z=0;
			  distance=Norme(Soustraction(P.Centre,Centre));
			  if(distance<distancecentre){

				 Data.Pt[0].X=x1; Data.Pt[1].X=x2; Data.Pt[2].X=x3; Data.Pt[3].X=x4;
				 Data.Pt[0].Y=y1; Data.Pt[1].Y=y2; Data.Pt[2].Y=y3; Data.Pt[3].Y=y4;
				 Data.Pt[0].Z=0; Data.Pt[1].Z=0; Data.Pt[2].Z=0; Data.Pt[3].Z=0;
				 //calcul 2d
				 for(jj=0;jj<4;jj++)
					Data.Pt2[jj]=InterPlan2(Data.Pt[jj],P);
				 // dessin
				 DrawTrapeze(Data,31,Zoom,sys,memdc2, pinceau,crayon,PPrint, NB);
			  }  // if distance

		}  // for i<nbrr

	fclose (Source);

   satsat3dsatelites(datum,sys,memdc2, P,k,pinceau,crayon,PPrint,NB,1,Actualiser);


}  // end of function

void DrawTrapeze(Trapeze Data,int couleur,double Zoom,systeme *sys,TMemoryDC * memdc2, HBRUSH pinceau[35],HPEN crayon[35],bool PPrint, bool NB){
	TPoint Ply[4];
	int j;
			if(NB==TRUE && PPrint==TRUE){
				memdc2->SelectObject(crayon[3]);
				memdc2->SelectObject(pinceau[1]);
			}
			else{
				memdc2->SelectObject(crayon[couleur]);
				memdc2->SelectObject(pinceau[couleur]);
			}
			for(j=0;j<4;j++){
				Ply[j].x=(int)(Data.Pt2[j].X*Zoom+sys->ScrW()/2.);
				Ply[j].y=45+(int)((sys->ScrH()-50.)/2.-Data.Pt2[j].Y*Zoom);
			}
	memdc2->Polygon(Ply,4);
}

void satsat3d(systeme *sys,TMemoryDC * memdc,TMemoryDC * memdc2){
 memdc->BitBlt(5,45,sys->ScrW()-10,sys->ScrH()-50,*memdc2,5,45);

}

void satsat3dsatelites(date2* datum,systeme *sys,TMemoryDC * memdc2, Plan P,int k,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint, bool NB, int phase,bool Actualiser){
float zoom;
if (k>=1) zoom=k;
	else zoom=sqrt(1./(2.-(float)k));
double Zoom=100.*zoom;
double zz;

int i,jj;
float x,y,z;
Trapeze Data;
Vecteur Centre;
double distancecentre,distance;
Centre.X=0;
	Centre.Y=0;
	Centre.Z=0;
	distancecentre=Norme(Soustraction(P.Centre,Centre));


	if(phase==0) { // satellites derriere
   	for(i=0;i<nbrsat;i++){
   		  satsat(datum,sys,Actualiser);
           Centre.X=(sys->tabjupi[48+i])*2.*R2;
			  Centre.Y=(sys->tabjupi[56+i])*2.*R2;   //u
			  Centre.Z=0;
			  distance=Norme(Soustraction(P.Centre,Centre));
           //Centre.X=Centre.X/(Centre.X+Centre.Y);
           //Centre.Y=Centre.Y/(Centre.X+Centre.Y);
			  if(distance>=distancecentre){

				 Data.Pt[0].X=Centre.X;
				 Data.Pt[0].Y=Centre.Y;
				 Data.Pt[0].Z=0;

					Data.Pt2[0]=InterPlan2(Data.Pt[0],P);
				 // dessin
             if(NB==TRUE && PPrint==TRUE){
					memdc2->SelectObject(crayon[3]);
					memdc2->SelectObject(pinceau[1]);
				}
				else{
               int couleur;
               if(i==0) couleur=13;
               if(i==1) if (PPrint==false) couleur=1;
						else couleur=3;
               if(i==2) couleur=7;
               if(i==3) couleur=2;
               if(i==4) couleur=4;
               if(i==5) couleur=8;
               if(i==6) couleur=9;
               if(i==7) couleur=10;
              	memdc2->SelectObject(crayon[couleur]);
					memdc2->SelectObject(pinceau[couleur]);
            }
            zz=5*sqrt(Zoom/100.)/2.;
               if(i==0) zz*=0.5; // mimas
               if(i==1) zz*=0.5; // encelade
					if(i==2) zz*=0.9; // thethys
               if(i==3) zz*=0.9; // dione
               if(i==4) zz*=1.2; // rhea
               if(i==5) zz*=1.5; // titan
               if(i==6) zz*=0.5; // hyperion
               if(i==7) zz*=0.9; // japet
               if (zz<1) zz=1;
               y=45+(int)((sys->ScrH()-50.)/2.-Data.Pt2[0].Y*Zoom);
               x=(int)(Data.Pt2[0].X*Zoom+sys->ScrW()/2.);
               memdc2->Ellipse(x-zz,y-zz,x+zz,y+zz);


			  }  // if distance

      }

   }
   else{
   for(i=0;i<nbrsat;i++){
           Centre.X=(sys->tabjupi[48+i])*2.*R2;
			  Centre.Y=(sys->tabjupi[56+i])*2.*R2;   //u
			  Centre.Z=0;
			  distance=Norme(Soustraction(P.Centre,Centre));
           //Centre.X=Centre.X/(Centre.X+Centre.Y);
           //Centre.Y=Centre.Y/(Centre.X+Centre.Y);
			  if(distance<=distancecentre){

				 Data.Pt[0].X=Centre.X;
             Data.Pt[0].Y=Centre.Y;
             Data.Pt[0].Z=0;
				 //calcul 2d
				 Data.Pt2[0]=InterPlan2(Data.Pt[0],P);
				 // dessin
             if(NB==TRUE && PPrint==TRUE){
					memdc2->SelectObject(crayon[3]);
					memdc2->SelectObject(pinceau[1]);
				}
				else{
               int couleur;
               if(i==0) couleur=13;
               if(i==1) if (PPrint==false) couleur=1;
						else couleur=3;
               if(i==2) couleur=7;
               if(i==3) couleur=2;
               if(i==4) couleur=4;
               if(i==5) couleur=8;
               if(i==6) couleur=9;
               if(i==7) couleur=10;
               memdc2->SelectObject(crayon[couleur]);
					memdc2->SelectObject(pinceau[couleur]);
            }
            zz=5*sqrt(Zoom/100.)/2.;
               if(i==0) zz*=0.5; // mimas
               if(i==1) zz*=0.5; // encelade
					if(i==2) zz*=0.9; // thethys
               if(i==3) zz*=0.9; // dione
               if(i==4) zz*=1.2; // rhea
               if(i==5) zz*=1.5; // titan
               if(i==6) zz*=0.5; // hyperion
               if(i==7) zz*=0.9; // japet
               if (zz<1) zz=1;

               y=45+(int)((sys->ScrH()-50.)/2.-Data.Pt2[0].Y*Zoom);
               x=(int)(Data.Pt2[0].X*Zoom+sys->ScrW()/2.);
               memdc2->Ellipse(x-zz,y-zz,x+zz,y+zz);


			  }  // if distance

      }


   //--------
// legende
	memdc2->SetBkMode(TRANSPARENT);
	memdc2->SetTextColor(RGB(0,0,0));
	// legende
	memdc2->TextOut(sys->ScrL()+80,5,"LEGENDE",strlen("LEGENDE"));

	if (PPrint==false) memdc2->SetTextColor(RGB(200,200,200));
	else memdc2->SetTextColor(RGB(0,0,0));
	//TextOut(memdc2,6,sys->ScrH()/2,"OUEST",5);
	//TextOut(memdc2,sys->ScrL()-55,sys->ScrH()/2,"EST",3);
	if (PPrint==false) memdc2->SetTextColor(RGB(255,255,255));
	else memdc2->SetTextColor(RGB(0,0,0));
   int afficheY=50,dy=15;
	// affiche nom des planetes avec ligne de la couleur correspondante devant
	for(i=0;i<nbrsat;i++){

		if (NB==true) memdc2->SelectObject(crayon[0]);   //noir
		if (i==0){
			memdc2->SelectObject(crayon[13]);
			memdc2->TextOut(sys->ScrL()+30,afficheY,"Mimas",5);
			memdc2->MoveTo(sys->ScrL()+10,afficheY+5);
			memdc2->LineTo(sys->ScrL()+25,afficheY+5);
         afficheY+=dy;
		}
		if (i==1){
			if (PPrint==false)memdc2->SelectObject(crayon[1]);
				else memdc2->SelectObject(crayon[3]);
			memdc2->TextOut(sys->ScrL()+30,afficheY,"Encelade",8);
			memdc2->MoveTo(sys->ScrL()+10,afficheY+5);
			memdc2->LineTo(sys->ScrL()+25,afficheY+5);
         afficheY-=dy;
		}
		if (i==2){
			memdc2->SelectObject(crayon[7]);
			memdc2->TextOut(sys->ScrL()+120,afficheY,"Thethys",7);
			memdc2->MoveTo(sys->ScrL()+100,afficheY+5);
			memdc2->LineTo(sys->ScrL()+115,afficheY+5);
         afficheY+=dy;
		}
		if (i==3){
			memdc2->SelectObject(crayon[2]);
			memdc2->TextOut(sys->ScrL()+120,afficheY,"Dion",5);
			memdc2->MoveTo(sys->ScrL()+100,afficheY+5);
			memdc2->LineTo(sys->ScrL()+115,afficheY+5);
         afficheY+=dy;
		}
		if (i==4){
			memdc2->SelectObject(crayon[4]);
			memdc2->TextOut(sys->ScrL()+30,afficheY,"Rhea",4);
			memdc2->MoveTo(sys->ScrL()+10,afficheY+5);
			memdc2->LineTo(sys->ScrL()+25,afficheY+5);
         afficheY+=dy;
		}
		if (i==5){
			memdc2->SelectObject(crayon[8]);
			memdc2->TextOut(sys->ScrL()+30,afficheY,"Titan",5);
			memdc2->MoveTo(sys->ScrL()+10,afficheY+5);
			memdc2->LineTo(sys->ScrL()+25,afficheY+5);
         afficheY-=dy;
		}
		if (i==6){
			memdc2->SelectObject(crayon[9]);
			memdc2->TextOut(sys->ScrL()+120,afficheY,"Hyperion",8);
			memdc2->MoveTo(sys->ScrL()+100,afficheY+5);
			memdc2->LineTo(sys->ScrL()+115,afficheY+5);
         afficheY+=dy;
		}
		if (i==7){
			memdc2->SelectObject(crayon[10]);
			memdc2->TextOut(sys->ScrL()+120,afficheY,"Japet",5);
			memdc2->MoveTo(sys->ScrL()+100,afficheY+5);
			memdc2->LineTo(sys->ScrL()+115,afficheY+5);
		}

	}  //for i
	// affichage heure et minute
   // date
	char txt[30];
	char txt1[30];
	datum->date4(txt1);
	sprintf(txt,"Heure GMT : %s",txt1 );
	memdc2->TextOut(sys->ScrL(),afficheY+2*dy,txt,strlen(txt));
	date4l(datum,txt1);
	sprintf(txt,"Heure Locale : %s",txt1);
	memdc2->TextOut(sys->ScrL(),afficheY+3*dy,txt,strlen(txt));

// fin legende
} // else
}

