#include "systeme.h"
#include <owl/dialog.h>
 // pour le fichier ini
#include <windows.h>
#include <string.h>
#include <stdio.h>
const char IniFilename[] = "Spica.ini";

//class systeme

systeme::systeme() : nbrplanete(0), nbrconstellation(0),nbrngc(0) {}

systeme::~systeme() {
        int i,j;
        for (i=0;i<nbrplanete && i<max_planete ;i++) {
                for (j=0;j<tabplanete[i]->getnbrsatellite() && j<max_satellite ;j++) {
                tabplanete[i]->getsatellite(j)->~satellite();
                tabplanete[i]->~planete();
                }
		  }
        for (i=0;i<nbrconstellation && i<max_constellation ;i++) {
                tabconstellation[i]->~constellation();
		  }
		  for (i=0;i<nbrngc && i<max_ngc ;i++) {
                tabngc[i]->~ngc();
		  }
}

//  -------------------------------------
// initialisation d'un systme plantaire
//
int systeme::initialisation(char *systfilename) {
        //lecture du fichier 'systeme.dat'
		  int erreur=0;
		  FILE * syst = fopen(systfilename,"rt");

		  if (syst==NULL) {
			 erreur=-1;
			 MessageBox(NULL,"Fichier systme introuvable","Erreur",MB_OK);
			 return erreur;
		  }
        int i;
        char planetefilename[max_file];

		  erreur+=-1+fscanf(syst,"Fichier du soleil\:%s",planetefilename);


		  // creation du soleil
		  erreur+=initialisationsoleil(planetefilename);

        // lecture du nombre de plante
		  erreur+=-1+fscanf(syst,"\nNombre de planetes\:%d",&nbrplanete);

        // initialisation de chaque planete
        for (i=0;i<nbrplanete && i<max_planete ;i++) {
					 // lecture du nom du fichier de la planete
					 erreur+=-1+fscanf(syst,"\nFichier de la planete\:%s",planetefilename);
                // creation de la planete et ajout du pointeur dans le tableau
					 tabplanete[i]=initialisationplanete(planetefilename);
					 if (tabplanete[i]==NULL) erreur=-1;
		  }
		  // initialisation des constellations
		  erreur+=-1+fscanf(syst,"\nFichier des constellations\:%s",planetefilename);
		  erreur+=initialisationc(planetefilename);
			// initialisation des objets messier
		  erreur+=-1+fscanf(syst,"\nFichier des objets Messier\:%s",planetefilename);
		  erreur+=initialisationm(planetefilename);
			// initialisation des objets ngc
		  erreur+=-1+fscanf(syst,"\nFichier des objets NGC\:%s",planetefilename);
		  erreur+=initialisationn(planetefilename);
			// initialisation de la voie lactee
		  erreur+=-1+fscanf(syst,"\nFichier de la Voie Lacte\:%s",planetefilename);
		  erreur+=initialisationv(planetefilename);
		  // initialisation des cometes
			erreur+=-1+fscanf(syst,"\nFichier des cometes\:%s",planetefilename);
		  erreur+=initialisationcom(planetefilename);
		  fclose(syst);

		  //lecture fichier ini
        // informations catalogue
				int dis,GuideStarCatalo,MXm,MNm;
				double MaxMagnoo,MinMagnoo;
		  dis = GetPrivateProfileInt( "Catalogue", "CD-ROM Drive", 3, IniFilename );
		  GuideStarCatalo = GetPrivateProfileInt( "Catalogue", "Guide Star Catalog", 0, IniFilename );
		  MXm = GetPrivateProfileInt( "Catalogue", "Magnitude Maximale",-200, IniFilename );
		  MNm = GetPrivateProfileInt( "Catalogue", "Magnitude Minimale",1600, IniFilename );
		  MaxMagnoo = (double)(MXm)/100.;
		  MinMagnoo = (double)(MNm)/100.;
				disk=new int(dis);
				GuideStarCatalog=new int(GuideStarCatalo);
				MaxMagni=new double(MaxMagnoo);
				MinMagni=new double(MinMagnoo);

		  //initialisation longitude, latitude, ville
				int numci,lat,lon;
				double longit,latit;
		  numci = GetPrivateProfileInt( "Position", "N ville", 31, IniFilename );
		  lat = GetPrivateProfileInt( "Position", "Latitude", 4590, IniFilename );
		  lon = GetPrivateProfileInt( "Position", "Longitude", 17380, IniFilename );
		  latit=(double)lat/100.;
		  longit=(double)lon/100.-180.;
		  GetPrivateProfileString("Position", "Ville","France-Annecy", cityname, sizeof(cityname), IniFilename);
				numcity=new int(numci);
				longitude=new double(longit);
				latitude=new double(latit);

		  numci = GetPrivateProfileInt( "Position ordinateur", "N ville", 31, IniFilename );
		  GetPrivateProfileString("Position ordinateur", "Ville","France-Annecy", cityname1, sizeof(cityname1), IniFilename);
				numcity1=new int(numci);

        int ete;
          int ordi,obs;
          ordi= GetPrivateProfileInt( "Heure", "Lieu de l'ordinateur", 26, IniFilename );
		    obs = GetPrivateProfileInt( "Heure", "Lieu d'observation", 26, IniFilename );
          ete = GetPrivateProfileInt( "Heure", "Saison", -1, IniFilename );
          Hordi=new int(ordi);
          Hobs=new int(obs);
          Saison=new int(ete);

		  return erreur;
}

//  -----------------------
// initialisation du soleil
//
int systeme::initialisationsoleil(char * sunfilename) {
  int k,i,erreur=0;
  FILE * sol;

  char no[max_nom];
  char couleu[max_couleur];
  int rayo;
  double L[max_dp],a[max_dp],e[max_dp],I[max_dp],o[max_dp],O[max_dp],M[max_dp],epsi[max_dp];

// ouverture du fichier
  sol = fopen(sunfilename,"rt");
  if (sol==NULL) {
			 erreur=-1;
			 MessageBox(NULL,"Fichier du soleil introuvable","Erreur",MB_OK);
			 return erreur;
		  }

// -*-*-*- LECTURE -*-*-*-

  // nom couleur rayon
  erreur+=-1+fscanf(sol,"\nNom\:%s",no);
  erreur+=-1+fscanf(sol,"\nCouleur\:%s",couleu);
  erreur+=-1+fscanf(sol,"\nRayon\:%d",&rayo);
  // lecture des caracteristiques
  i=0; erreur+=-1+fscanf(sol," \nL %lf",&L[0]);
  while(L[i]!=0) {i++;erreur+=-1+fscanf(sol," %lf",&L[i]);}
  i=0; erreur+=-1+fscanf(sol," \na %lf",&a[0]);
  while(a[i]!=0) {i++;erreur+=-1+fscanf(sol," %lf",&a[i]);}
  i=0; erreur+=-1+fscanf(sol," \ne %lf",&e[0]);
  while(e[i]!=0) {i++;erreur+=-1+fscanf(sol," %lf",&e[i]);}
  i=0; erreur+=-1+fscanf(sol," \ni %lf",&I[0]);
  while(I[i]!=0) {i++;erreur+=-1+fscanf(sol," %lf",&I[i]);}
  i=0; erreur+=-1+fscanf(sol," \no %lf",&o[0]);
  while(o[i]!=0) {i++;erreur+=-1+fscanf(sol," %lf",&o[i]);}
  i=0; erreur+=-1+fscanf(sol," \nO %lf",&O[0]);
  while(O[i]!=0) {i++;erreur+=-1+fscanf(sol," %lf",&O[i]);}
  i=0; erreur+=-1+fscanf(sol," \nM %lf",&M[0]);
  while(M[i]!=0) {i++;erreur+=-1+fscanf(sol," %lf",&M[i]);}
  i=0; erreur+=-1+fscanf(sol," \nE %lf",&epsi[0]);
  while(epsi[i]!=0) {i++;erreur+=-1+fscanf(sol," %lf",&epsi[i]);}
// -*-*- ECRITURE -*-*-*
   sun=new soleil(no,couleu,rayo);

  // ecriture dans la classe
  for(i=0;i<dp;i++){
         if (L[i]!=0) sun->setL(L[i],i);
         else {sun->setL(0,i);for(k=1;k<dp;k++) L[i+k]=0;}
          if (a[i]!=0) sun->seta(a[i],i);
         else {sun->seta(0,i);for(k=1;k<dp;k++) a[i+k]=0;}
          if (e[i]!=0) sun->sete(e[i],i);
         else {sun->sete(0,i);;for(k=1;k<dp;k++) e[i+k]=0;}
          if (I[i]!=0) sun->setI(I[i],i);
         else {sun->setI(0,i);for(k=1;k<dp;k++) I[i+k]=0;}
          if (o[i]!=0) sun->seto(o[i],i);
         else {sun->seto(0,i);for(k=1;k<dp;k++) o[i+k]=0;}
          if (O[i]!=0) sun->setO(O[i],i);
         else {sun->setO(0,i);for(k=1;k<dp;k++) O[i+k]=0;}
          if (M[i]!=0) sun->setM(M[i],i);
         else {sun->setM(0,i);for(k=1;k<dp;k++) M[i+k]=0;}
          if (epsi[i]!=0) sun->setepsilon(epsi[i],i);
         else {sun->setepsilon(0,i);for(k=1;k<dp;k++) epsi[i+k]=0;}
  }

  fclose(sol);

  return erreur;
}

//  -----------------------------
// initialisation d'une planete
//
planete * systeme::initialisationplanete(char * planetefilename) {
  int erreur=0;
  int i,k;
  FILE * planet;

  char no[max_nom];
  char couleu[max_couleur];
  double rayo;
  double L[max_dp],a[max_dp],e[max_dp],I[max_dp],o[max_dp],O[max_dp],M[max_dp];
  int nbrsat;
  char satellitefilename[max_file];
  planete *plan; // pointeur sur la planete creee
  satellite *satel; // pointeur sur satellite

// ouverture du fichier
  planet = fopen(planetefilename,"rt");
  if (planet==NULL) {
			 MessageBox(NULL,"Fichier d'une des planetes introuvable","Erreur",MB_OK);
			 return NULL;
		  }

// -*-*-*- LECTURE -*-*-*-

  // nom couleur rayon
  erreur+=-1+fscanf(planet,"\nNom\:%s",no);
  erreur+=-1+fscanf(planet,"\nCouleur\:%s",couleu);
  erreur+=-1+fscanf(planet,"\nRayon\:%lf",&rayo);
  // lecture des caracteristiques
  i=0; erreur+=-1+fscanf(planet,"\nL %lf",&L[0]);
  while(L[i]!=0) {i++;erreur+=-1+fscanf(planet," %lf",&L[i]);}
  i=0; erreur+=-1+fscanf(planet," \na %lf",&a[0]);
  while(a[i]!=0) {i++;erreur+=-1+fscanf(planet," %lf",&a[i]);}
  i=0; erreur+=-1+fscanf(planet," \ne %lf",&e[0]);
  while(e[i]!=0) {i++;erreur+=-1+fscanf(planet," %lf",&e[i]);}
  i=0; erreur+=-1+fscanf(planet," \ni %lf",&I[0]);
  while(I[i]!=0) {i++;erreur+=-1+fscanf(planet," %lf",&I[i]);}
  i=0; erreur+=-1+fscanf(planet," \no %lf",&o[0]);
  while(o[i]!=0) {i++;erreur+=-1+fscanf(planet," %lf",&o[i]);}
  i=0; erreur+=-1+fscanf(planet," \nO %lf",&O[0]);
  while(O[i]!=0) {i++;erreur+=-1+fscanf(planet," %lf",&O[i]);}
  i=0; erreur+=-1+fscanf(planet," \nM %lf",&M[0]);
  while(M[i]!=0) {i++;erreur+=-1+fscanf(planet," %lf",&M[i]);}
// -*-*- ECRITURE -*-*-*

  plan=new planete(no,couleu,rayo);

   // ecriture dans la classe
  for(i=0;i<dp;i++){
			if (L[i]!=0) plan->setL(L[i],i);
			else {plan->setL(0,i);for(k=1;k<dp;k++) L[i+k]=0;}
			 if (a[i]!=0) plan->seta(a[i],i);
			else {plan->seta(0,i);for(k=1;k<dp;k++) a[i+k]=0;}
			 if (e[i]!=0) plan->sete(e[i],i);
         else {plan->sete(0,i);;for(k=1;k<dp;k++) e[i+k]=0;}
          if (I[i]!=0) plan->setI(I[i],i);
			else {plan->setI(0,i);for(k=1;k<dp;k++) I[i+k]=0;}
          if (o[i]!=0) plan->seto(o[i],i);
         else {plan->seto(0,i);for(k=1;k<dp;k++) o[i+k]=0;}
          if (O[i]!=0) plan->setO(O[i],i);
			else {plan->setO(0,i);for(k=1;k<dp;k++) O[i+k]=0;}
          if (M[i]!=0) plan->setM(M[i],i);
         else {plan->setM(0,i);for(k=1;k<dp;k++) M[i+k]=0;}
  }

		  // lecure des satellites
        erreur+=-1+fscanf(planet,"\nNombre de satellite(s)\:%d",&nbrsat);
		  // initialisation de chaque planete
		  plan->setnbrsatellite(nbrsat);

		  for (i=0;i<nbrsat && i<max_satellite;i++) {
					 // lecture du nom de la planete
					 erreur+=-1+fscanf(planet,"\nFichier du satellite\:%s",satellitefilename);
					 satel=initialisationsatellite(satellitefilename);
					 plan->setsatellite(satel,i);
		  }
		  double Mmag[4];
		  fscanf(planet,"\nMag %lf %lf %lf %lf",&Mmag[0],&Mmag[1],&Mmag[2],&Mmag[3]);
		  for(i=0;i<4;i++) plan->setMagni(Mmag[i],i);

  fclose(planet);
  if (erreur<0) plan=NULL;
 return plan;
}

//  -----------------------------
// initialisation d'un satellite
//

satellite * systeme::initialisationsatellite(char * satellitefilename) {
  int erreur=0;
  int i;
  FILE * satell;

  satellite *satel;
  char nom[max_nom];
  char couleur[max_couleur];
  double rayon;
  double L[max_dp],a[max_dp],e[max_dp],I[max_dp],o[max_dp],O[max_dp],M[max_dp];

  // ouverture du fichier
	satell = fopen(satellitefilename,"rt");
	if (satell==NULL) {
			 MessageBox(NULL,"Fichier d'un des satellites introuvable","Erreur",MB_OK);
			 return NULL;
		  }
// -*-*-*- LECTURE -*-*-*-

  // nom couleur rayon
  erreur+=-1+fscanf(satell,"\nNom\:%s",nom);
  erreur+=-1+fscanf(satell,"\nCouleur\:%s",couleur);
  erreur+=-1+fscanf(satell,"\nRayon\:%lf",&rayon);

  // creation du satellite
  satel=new satellite(nom,couleur,rayon);

  // lecture caracteristiques
  i=0; erreur+=-1+fscanf(satell," \nL %lf",&L[0]);
  while(L[i]!=0) {i++;erreur+=-1+fscanf(satell," %lf",&L[i]);}
  i=0; erreur+=-1+fscanf(satell," \na %lf",&a[0]);
  while(a[i]!=0) {i++;erreur+=-1+fscanf(satell," %lf",&a[i]);}
  i=0; erreur+=-1+fscanf(satell," \ne %lf",&e[0]);
  while(e[i]!=0) {i++;erreur+=-1+fscanf(satell," %lf",&e[i]);}
  i=0; erreur+=-1+fscanf(satell," \ni %lf",&I[0]);
  while(I[i]!=0) {i++;erreur+=-1+fscanf(satell," %lf",&I[i]);}
  i=0; erreur+=-1+fscanf(satell," \no %lf",&o[0]);
  while(o[i]!=0) {i++;erreur+=-1+fscanf(satell," %lf",&o[i]);}
  i=0; erreur+=-1+fscanf(satell," \nO %lf",&O[0]);
  while(O[i]!=0) {i++;erreur+=-1+fscanf(satell," %lf",&O[i]);}
  i=0; erreur+=-1+fscanf(satell," \nM %lf",&M[0]);
  while(M[i]!=0) {i++;erreur+=-1+fscanf(satell," %lf",&M[i]);}
  // ecriture dans la classe
  for(i=0;i<dp;i++){
         if (L[i]!=0) satel->setL(L[i],i);
         else satel->setL(0,i);
          if (a[i]!=0) satel->seta(a[i],i);
         else satel->seta(0,i);
          if (e[i]!=0) satel->sete(e[i],i);
         else satel->sete(0,i);
          if (I[i]!=0) satel->setI(I[i],i);
         else satel->setI(0,i);
          if (o[i]!=0) satel->seto(o[i],i);
         else satel->seto(0,i);
          if (O[i]!=0) satel->setO(O[i],i);
         else satel->setO(0,i);
          if (M[i]!=0) satel->setM(M[i],i);
         else satel->setM(0,i);
  }
   double Mmag[4];
		  fscanf(satell,"\nMag %lf %lf %lf %lf",&Mmag[0],&Mmag[1],&Mmag[2],&Mmag[3]);
		  for(i=0;i<4;i++) satel->setMagni(Mmag[i],i);
 fclose (satell);
 if (erreur<0) satel=NULL;
 return satel;
}

// ---------------------------------
// initialisation des constellations
//
int systeme::initialisationc(char *constfilename) {
//creation de toutes les constellations par lecture du fichier de donnes

//  FILE*fptr1; fptr1=fopen("test1.txt","wt");
		  // variables
        FILE * cons;
		  int i,j,k,erreur=0;
		  char nom[15],coul[15];
		  double mag,dec,asc;
		  int consligne;
		  constellation * constel;
		  etoile* star;
		  int numc,f[4],nbrstar,ff,numn,dec0,dec1,dec2,asc1,asc2,asc0;
		  char abrev[5],anom[15];

		  // ouverture du fichier pour lecture en mode txt
		  cons = fopen(constfilename,"rt");

		  if (cons==NULL) {
			 erreur=-1;
			 MessageBox(NULL,"Fichier des CONSTELL.SYT introuvable","Erreur",MB_OK);
			 return erreur;
		  } // if cons
		  	// lecture du nbre de constellations
		  erreur+=-1+fscanf(cons,"Nombre de constellations\:%d",&nbrconstellation);

		  // initialisation de chaque constellation
			for(i=0;i<nbrconstellation && i<max_constellation;i++){
					 erreur+=-1+fscanf(cons,"\n%d %s %s %d %d %d %d %d",&numc,nom,abrev,&f[0],&f[1],&f[2],&f[3],&nbrstar);
					 constel=new constellation(nom,abrev,numc,f[0],f[1],f[2],f[3]);
					 constel->Nombre=nbrstar;

					 //test
				  //	 fprintf(fptr1,"\n%s %d",constel->Nom,constel->Nombre);
				// initialisation des toiles
				for(k=0;k<nbrstar;k++){
					 erreur+=-1+fscanf(cons,"\n%d %s %s %s %d %d %d %d %d %d %lf %d",&numn,anom,nom,coul,&asc0,&asc1,&asc2,&dec0,&dec1,&dec2,&mag,&consligne);
						//strcpy(coul," ");

						//test
					  //	fprintf(fptr1,"\n%s ",nom);

						if(dec0<0 ||dec1<0) ff=-1;
						else ff=1;
						dec=ff*((double)abs(dec0)+(double)abs(dec1)/60.0+(double)abs(dec2)/3600.0);
						asc=360.0/24.*((double)abs(asc0)+(double)abs(asc1)/60.0+(double)abs(asc2)/3600.0);
					 star=new etoile(nom,anom,dec,asc,mag,coul);
					 j=0;
					 while(consligne>=0 && consligne<=nbrconstellation && j<max_lignes){
						star->setligne(j,consligne);
						erreur+=fscanf(cons," %d",&consligne);
						j++;
					 } //while
					 star->setligne(j,-1);
					 constel->Star[k]=star;
				} //for  k
				tabconstellation[i]=constel;
          }// for i
  fclose(cons);
  return erreur;

}

// messier
int systeme::initialisationm(char *constfilename) {
//creation de toutes les objets messier par lecture du fichier de donnes
		  // variables
		  FILE * cons;
		  int i,erreur=0;
		  char nom[30];
		  double dec,asc,mag,ll;
		  int typet;
		  ngc * nngc;
		  int numc,f[3];
		  char aabrev[4],abrev[5]="M";

		  // ouverture du fichier pour lecture en mode txt
		  cons = fopen(constfilename,"rt");

		  if (cons==NULL) {
			 erreur=-1;
			 MessageBox(NULL,"Fichier des Messier.SYT introuvable","Erreur",MB_OK);
			 return erreur;
		  }
		  // lecture du nbre de constellations
		  erreur+=-1+fscanf(cons,"Nombre d'objets\:%d",&nbrngc);

		  // initialisation de chaque constellation
			for(i=0;i<nbrngc && i<max_ngc;i++){
         		 strcpy(abrev,"M");
					 erreur+=-1+fscanf(cons,"\n\nM\:%d\nType\:%d\nNom\:%s\nCoordonnes\:%d %lf %d %d %lf",&numc,&typet,nom,&f[0],&ll,&f[1],&f[2],&mag);
					 asc=360/24*((double)f[0]+ll/60.0);
					 dec=(double)f[1];
					 if(dec>=0) dec+=(double)f[2]/60;
					 else dec-=(double)f[2]/60;
					 strcat(abrev,itoa(numc,aabrev,10));
					 nngc=new ngc(nom,abrev,dec,asc,typet,mag);


				tabngc[i]=nngc;

  }
  fclose(cons);
  //nbrconstellation=80;

  return erreur;


}

// ngc
int systeme::initialisationn(char *constfilename) {
//creation de toutes les objets ngc par lecture du fichier de donnes
		  // variables
		  FILE * cons;
		  int i,erreur=0;
		  double dec,asc,ll;
		  int type2,type3,nbrngc2;
		  ngc * nngc;
		  int numc,f[3];
		  char abrev[8];

		  // ouverture du fichier pour lecture en mode txt
		  cons = fopen(constfilename,"rt");

		  if (cons==NULL) {
			 erreur=-1;
			 MessageBox(NULL,"Fichier des NGC.SYT introuvable","Erreur",MB_OK);
			 return erreur;
		  }
		  // lecture du nbre de constellations
		  erreur+=-1+fscanf(cons,"Nombre:%d",&nbrngc2);


		  // initialisation de chaque constellation
			for(i=0;i<nbrngc2 ;i++){//&& i<max_ngc-nbrngc;i++){
					 erreur+=-1+fscanf(cons,"\nNGC:%d\n%d %d %lf %d %d",&numc,&type2,&f[0],&ll,&f[1],&f[2]);
					 sprintf(abrev,"NGC%d",numc);
					 asc=360./24.*((double)f[0]+ll/60.0);
					 dec=(double)f[1];
					 if(dec>=0) dec+=(double)f[2]/60;
					 else dec-=(double)f[2]/60;
					 type3=type2;
					 if (type2==2) type3=3;
					 if (type2==3) type3=2;
					 if (type2==4) type3=6;
					 if (type2==6) type3=8;
					 if (type2==7) type3=4;
                nngc=new ngc("_",abrev,dec,asc,type3,0);
					 
				tabngc[nbrngc+i]=nngc;

  }
  nbrngc+=nbrngc2;
  fclose(cons);

  return erreur;


}

// comet
int systeme::initialisationcom(char *comfilename) {
	tabselected[0]=-1; // pas d'asteroides selectionns pour l'affichage
   MagAste= (float)GetPrivateProfileInt( "Asteroides", "Magnitude Maximale", 700, IniFilename )/100.;

//creation de tous les asteroides
     int erreur=0;
  int k;
  FILE * planet;

  char no[max_nom];
  long double d1,d2;
  double a,e,I,o,O;
  comet *comm; // pointeur sur la comete creee


// ouverture du fichier
  planet = fopen(comfilename,"rt");
  if (planet==NULL) {
			 MessageBox(NULL,"Fichier des astroides introuvable","Erreur",MB_OK);
			 return NULL;
		  }

// -*-*-*- LECTURE -*-*-*-
int nbr;
  erreur+=-1+fscanf(planet,"Nombre\:%d\n",&nbr);
  nbrcomet=nbr;
  for (k=0;k<nbr;k++){
  // nom couleur rayon
  erreur+=-1+fscanf(planet,"\nNom\:%s",no);

  // lecture des caracteristiques
  erreur+=-1+fscanf(planet,"\na\:%lf\ne\:%lf\nI\:%lf\no\:%lf\nO\:%lf\n",&a,&e,&I,&o,&O);
// -*-*- ECRITURE -*-*-*

  comm=new comet(no,"gris",10);

  // ecriture dans la classe
  comm->setL(0,0);comm->setL(0,1);
  comm->seta(a,0);comm->seta(0,1);
  comm->sete(e,0);comm->sete(0,1);
  comm->setI(I,0);comm->setI(0,1);
  comm->seto(o,0);comm->seto(0,1);
  comm->setO(O,0);comm->setO(0,1);
  comm->setM(0,0);comm->setM(0,1);

  //les deux dates
  int ttm,tta;
  double ttj,temp;
  float mag1,mag2;
  erreur+=-1+fscanf(planet,"\ntperi:%d/%d/%d\n", &ttm, &ttj, &tta);
  // calcul siecle julien
  //double aaa,b,jj,m,y;
  long double y,m,aaa,b,jj;
  if(ttm>2) {y=tta; m=ttm;}
  else {y=tta-1; m=ttm+12;}
  if (tta<=1582 && ttm<=10 && ttm<15){  // on est pas dans le calendrier gregorien
		b=0;  }
  else {  		aaa=floor(y/100.);
					b=2.-aaa+floor(aaa/4.);  }
  jj=b+floor(365.25*y)+floor(30.6001*(m+1.))+ttj-694025.5;
  d1=(jj)/36525.0;

  erreur+=-1+fscanf(planet,"tequi:%f\n",&temp);
  tta=(int)temp;
  ttm=1;
  ttj=1;
  if(ttm>2) {y=tta; m=ttm;}
  else {y=tta-1; m=ttm+12;}
  if (tta<=1582 && ttm<=10 && ttm<15){  // on est pas dans le calendrier gregorien
		b=0;  }
  else {  		aaa=floor(y/100.);
					b=2.-aaa+floor(aaa/4.);  }
  jj=b+floor(365.25*y)+floor(30.6001*(m+1.))+ttj-694025.5;
  d2=(jj)/36525.0;

  comm->setdate(d1,d2);
  erreur+=-1+fscanf(planet,"mag:%f ",&mag1);
  erreur+=-1+fscanf(planet,"%f\n",&mag2);

  comm->Magn[0]=mag1;
  comm->Magn[1]=mag2;
  

  tabcomet[k]=comm;

  }// for k

  fclose(planet);

 return erreur;


}


// ngc
int systeme::initialisationv(char *constfilename) {
//creation de la voie lacte par lecture du fichier de donnes
		  // variables
		  FILE * cons;
		  int i,k,erreur=0;

		  double j;
		  double dec,asc;
		  int nn;
		  // ouverture du fichier pour lecture en mode txt
		  cons = fopen(constfilename,"rt");

		  if (cons==NULL) {
			 erreur=-1;
			 MessageBox(NULL,"Fichier de la Voie Lactee introuvable","Erreur",MB_OK);
			 return erreur;
		  }
		  // lecture du nbre de constellations
		  erreur+=-1+fscanf(cons,"Ligne_1\nN1\:%d",&nn);
		  lac=new Lactee();
		  //ligne 1

			for(k=0;k<nn;k++){
					 erreur+=-1+fscanf(cons,"\nPt\:%d %lf %lf",&i,&j,&dec);
					 asc=360.0/24.*((double)i+j/60.0);
				lac->setpoint(1,asc,dec);

			}

			erreur+=-1+fscanf(cons,"\nFin_1\n\nLigne_2\nN2\:%d",&nn);
		  /// ligne 2
			for(k=0;k<nn;k++){
					 erreur+=-1+fscanf(cons,"\nPt\:%d %lf %lf",&i,&j,&dec);
					 asc=360/24*((double)i+j/60.0);
			  	lac->setpoint(2,asc,dec);

			}   
				
  fclose(cons);

  return erreur;


}

// --------------------------
// petites fonctions diverses
//
soleil * systeme::getsun(){return sun;}

int systeme::getnbrplanete() { return nbrplanete; }
planete * systeme::getplanete(int i) { return tabplanete[i]; }

int systeme::getnbrconstellation() { return nbrconstellation; }
constellation * systeme::getconstellation(int i) { return tabconstellation[i]; }

int systeme::getnbrngc(){return nbrngc;}
ngc *systeme::getngc(int i){return tabngc[i];}

Lactee *systeme::getlactee(){return lac;}

int systeme::getnbrcomet(){return nbrcomet;}
comet *systeme::getcomet(int i){
	if(i<3000 && i>=0)
   	return tabcomet[i];
	else
		return tabcomet[0];
}

void systeme::calculposition(date2*t,bool satellite) {
		  int i,j;
        sun->calculposition(t);
		  for (i=0;i<nbrplanete;i++) {
					 // position des planetes
					 tabplanete[i]->calculposition(t,sun);
					 if (satellite==true){
						//position des satellites long => peut demander de ne pas le faire
						for (j=0;j<tabplanete[i]->getnbrsatellite();j++){
								tabplanete[i]->getsatellite(j)->calculposition(t,sun);
						}
					 }
        }
}
//------------------------------------------------------------------
//coordonnees d'affichage
void systeme::ChangeWindowSize(int X,int Y){
	ScreenW=(float)X;
	ScreenH=(float)Y;
	if (ScreenW>732.) ScreenL=ScreenW-232;
	else ScreenL=ScreenW*5./8.;
	if( ScreenL>ScreenH-30) ScreenR=(ScreenH-50.)/2.;
	else ScreenR=(ScreenL-10.)/2.;

	Ell_lef=5;
	Ell_xr=ScreenR;
	Ell_top=(int)(40+(double)(3./4.*ScreenR-(*latitude-45.)/90.*ScreenR));
   Ell_yr=(int)((double)( ScreenR*(1./4.+3*(*latitude-45.)/90.) ));
}
int systeme::NChgX(int X){
  float result;
  result=(float)X*ScreenW/732.;
  return (int)result;

}
int systeme::NChgY(int Y){
  float result;
  result=(float)Y*ScreenH/500.;
  return (int)result;

}

int systeme::CChgX(int X){
  float result;
  result=(float)X*ScreenM/500.;
  return (int)result;

}
int systeme::CChgY(int Y){
  float result;
  result=(float)Y*ScreenM/500.;
  return (int)result;

}
int systeme::CChgR(int R){
  float result;
  result=(float)R*ScreenR/120.;
  return (int)result;

}

int systeme::UNChgX(int X){
  float result;
  result=(float)X*732./ScreenW;
  return (int)result;

}
int systeme::UNChgY(int Y){
  float result;
  result=(float)Y*500./ScreenH;
  return (int)result;

}

int systeme::UCChgX(int X){
  float result;
  result=(float)X*500./ScreenM;
  return (int)result;

}
int systeme::UCChgY(int Y){
  float result;
  result=(float)Y*500./ScreenM;
  return (int)result;

}



