#ifndef systeme_h
#define systeme_h

// includes
#include "constant.h"      // lecture des constantes
#include <stdio.h>         // lecture des fichiers

#include "objet.h"         // classe mere
#include "satellit.h"      // satellite : objet
#include "planete.h"       // planete :objet
#include "soleil.h"        // soleil
#include "constell.h"   	// constellation
#include "ngc.h"           // ngc + messier + voie lactee
#include "comet.h"			// comet :objet
#include "date.h"          // date

class systeme {
//attributs
public:
        soleil * sun;

		  int nbrplanete;
        planete* tabplanete[9]; //tableau de pointeurs sur les plantes

		  int nbrconstellation;
        constellation* tabconstellation[max_constellation]; //tableau de pointeurs sur les constellations

		  int nbrngc;
		  ngc* tabngc[400];

		  Lactee*lac;

		  int nbrcomet;
		  comet* tabcomet[3000];
        int tabselected[3000];
        double MagAste;
       // taille de l'ecran
		  float ScreenW;
		  float ScreenH;
		  float ScreenM;// pour le cercle
		  float ScreenL;//debut de la legende
		  float ScreenR; // rayon du cercle

		  double tabjupi[80];   // pour les satellites de jupiter

		  // pour les catalogues d'etoiles
		  int *disk;  				// numro du lecteur cdrom      // 1 =A:
		  int *GuideStarCatalog; // type de catalogue : 0-> rien
																 //  1-> the guide star catalog version 1.1
																 //  2->
		  double *MaxMagni;   // magnitude  partir de laquelle on dessine etoile
		  double *MinMagni;	// magnitude jusqua laquelle on dessine truc
		  // MaxMagni<MinMagni  ;  ex : Max =-2,   Min =10;


public:
		  int *numcity;
		  double *latitude;
		  double *longitude;
		  char cityname[30];
        int *numcity1;
		  char cityname1[30];
        int *Hordi;
        int *Hobs;//shift babasse GMT, et shift lieu utilis GMT
	  	  int *Saison; //heure d't ou d'hiver?

        int Ell_lef,Ell_top,Ell_yr,Ell_xr; // ellipse : left, top, rayon y, rayon x


//methodes
public:
        systeme(); //constructeur
        ~systeme(); //destructeur

		  int initialisation(char *); //cration des plantes et des satellites
                                                        //par lecture du fichier "systeme.dat"
			  int initialisationsoleil(char * sunfilename);
                planete * initialisationplanete(char * planetefilename);
                satellite * initialisationsatellite(char * satellitefilename);

        int initialisationc(char *); //cration des contellations
                                                   //par lecture du fichier "constellation.dat"
		  int initialisationm(char *); //cration des objets messier
		  int initialisationn(char *); //cration des objets ngc
		  int initialisationv(char *); //cration de la voie lactee
        int initialisationcom(char *); //cration des contellations


        int getnbrplanete();
        planete * getplanete(int i); //renvoit l'lment i du tableau de pointeurs
                                                     //de plante

		  int getnbrconstellation();
        constellation * getconstellation(int i); //renvoit l'lment i du tableau de

		  int getnbrngc();
		  ngc *getngc(int i);

		  Lactee *getlactee();

		  int getnbrcomet();
		  comet *getcomet(int i);
																									//pointeurs de constellation

		  void calculposition(date2*,bool satellite=true); //calcul de la position de tous les objets celestes
						// si bool =false -> calcul pas les satellites
                  // par defaut bool =true
		  soleil * getsun();

		  int getnumcity(){return *numcity;}
		  double getlatitude(){return *latitude;}
		  double getlongitude(){return *longitude;}
        char * getcityname(){return cityname;}

		  void ChangeWindowSize(int X,int Y);
		  int NChgX(int X);        // CONVERTIR VIRTUEL -> ecran
		  int NChgY(int Y);        //coor rectangulaires
		  int CChgX(int X);         // coor circulaires
		  int CChgY(int Y);
        int CChgR(int R);

		  int UNChgX(int X);      // convertir ecran-> virtuel
		  int UNChgY(int Y);
		  int UCChgX(int X);
		  int UCChgY(int Y);

		  int ScrL(){return (int)ScreenL;}
		  int ScrW(){return (int)ScreenW;}
		  int ScrH(){return (int)ScreenH;}
		  int ScrR(){return (int)ScreenR;}


        bool DansEllipse(int x,int y);
		  int Convx(int x);
		  int Convy(int y);

};
        
#endif  //systeme_h
                